
// File: index.xml

// File: classAdmixtures.xml
%feature("docstring") Admixtures "

The list of material admixtures to a slice.

Needed for calculating the average of a material, which is needed in the Fresnel calculation.

C++ includes: Admixtures.h
";

%feature("docstring")  Admixtures::Admixtures "Admixtures::Admixtures()=default
Admixtures::Admixtures";

%feature("docstring")  Admixtures::Admixtures "Admixtures::Admixtures(const std::vector< OneAdmixture > &_super)
Admixtures::Admixtures";


// File: classBarGauss.xml
%feature("docstring") BarGauss "

The form factor of an elongated bar, with Gaussian profile in elongation direction.

C++ includes: Bar.h
";

%feature("docstring")  BarGauss::BarGauss "BarGauss::BarGauss(double length, double width, double height)
BarGauss::BarGauss";

%feature("docstring")  BarGauss::BarGauss "BarGauss::BarGauss(std::vector< double > P)
BarGauss::BarGauss";

%feature("docstring")  BarGauss::clone "BarGauss * BarGauss::clone() const override
BarGauss::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  BarGauss::className "std::string BarGauss::className() const final
BarGauss::className";

%feature("docstring")  BarGauss::parDefs "std::vector< ParaMeta > BarGauss::parDefs() const final
BarGauss::parDefs";


// File: classBarLorentz.xml
%feature("docstring") BarLorentz "

The form factor of an elongated, with Lorentz form factor in elongation direction.

C++ includes: Bar.h
";

%feature("docstring")  BarLorentz::BarLorentz "BarLorentz::BarLorentz(double length, double width, double height)
BarLorentz::BarLorentz";

%feature("docstring")  BarLorentz::BarLorentz "BarLorentz::BarLorentz(std::vector< double > P)
BarLorentz::BarLorentz";

%feature("docstring")  BarLorentz::clone "BarLorentz * BarLorentz::clone() const override
BarLorentz::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  BarLorentz::className "std::string BarLorentz::className() const final
BarLorentz::className";

%feature("docstring")  BarLorentz::parDefs "std::vector< ParaMeta > BarLorentz::parDefs() const final
BarLorentz::parDefs";


// File: classBaseMaterialImpl.xml
%feature("docstring") BaseMaterialImpl "

Interface for material implementation classes. Inherited by  MagneticMaterialImpl, which has further children.

C++ includes: BaseMaterialImpl.h
";

%feature("docstring")  BaseMaterialImpl::BaseMaterialImpl "BaseMaterialImpl::BaseMaterialImpl(const std::string &name)
BaseMaterialImpl::BaseMaterialImpl
Constructs basic material with name. 
";

%feature("docstring")  BaseMaterialImpl::~BaseMaterialImpl "virtual BaseMaterialImpl::~BaseMaterialImpl()=default
BaseMaterialImpl::~BaseMaterialImpl";

%feature("docstring")  BaseMaterialImpl::clone "virtual BaseMaterialImpl * BaseMaterialImpl::clone() const =0
BaseMaterialImpl::clone
Returns pointer to a copy of material. 
";

%feature("docstring")  BaseMaterialImpl::inverted "virtual BaseMaterialImpl * BaseMaterialImpl::inverted() const =0
BaseMaterialImpl::inverted
Constructs a material with inverted magnetization. 
";

%feature("docstring")  BaseMaterialImpl::refractiveIndex "virtual complex_t BaseMaterialImpl::refractiveIndex(double wavelength) const =0
BaseMaterialImpl::refractiveIndex
Returns refractive index. 
";

%feature("docstring")  BaseMaterialImpl::refractiveIndex2 "virtual complex_t BaseMaterialImpl::refractiveIndex2(double wavelength) const =0
BaseMaterialImpl::refractiveIndex2
Returns squared refractive index. 
";

%feature("docstring")  BaseMaterialImpl::isScalarMaterial "virtual bool BaseMaterialImpl::isScalarMaterial() const =0
BaseMaterialImpl::isScalarMaterial
Indicates whether the interaction with the material is scalar. This means that different polarization states will be diffracted equally 
";

%feature("docstring")  BaseMaterialImpl::isMagneticMaterial "virtual bool BaseMaterialImpl::isMagneticMaterial() const =0
BaseMaterialImpl::isMagneticMaterial";

%feature("docstring")  BaseMaterialImpl::magnetization "virtual R3 BaseMaterialImpl::magnetization() const =0
BaseMaterialImpl::magnetization
Returns the magnetization (in A/m) 
";

%feature("docstring")  BaseMaterialImpl::materialData "virtual complex_t BaseMaterialImpl::materialData() const =0
BaseMaterialImpl::materialData
Returns underlying material data. 
";

%feature("docstring")  BaseMaterialImpl::typeID "virtual MATERIAL_TYPES BaseMaterialImpl::typeID() const =0
BaseMaterialImpl::typeID
Returns type of material implementation. 
";

%feature("docstring")  BaseMaterialImpl::scalarSubtrSLD "virtual complex_t BaseMaterialImpl::scalarSubtrSLD(double lambda0) const =0
BaseMaterialImpl::scalarSubtrSLD
Returns (  $ \\\\pi/\\\\lambda^2 $ - sld), sld being the scattering length density. 
";

%feature("docstring")  BaseMaterialImpl::polarizedSubtrSLD "virtual SpinMatrix BaseMaterialImpl::polarizedSubtrSLD(const WavevectorInfo &wavevectors) const =0
BaseMaterialImpl::polarizedSubtrSLD
Returns (  $ \\\\pi/\\\\lambda^2 $ - sld) matrix with magnetization corrections. 
";

%feature("docstring")  BaseMaterialImpl::rotatedMaterial "virtual BaseMaterialImpl * BaseMaterialImpl::rotatedMaterial(const RotMatrix &transform) const =0
BaseMaterialImpl::rotatedMaterial";

%feature("docstring")  BaseMaterialImpl::print "virtual std::string BaseMaterialImpl::print() const =0
BaseMaterialImpl::print
Prints object data. 
";

%feature("docstring")  BaseMaterialImpl::matName "const std::string & BaseMaterialImpl::matName() const
BaseMaterialImpl::matName
Returns name of the material. 
";


// File: classBasicLattice2D.xml
%feature("docstring") BasicLattice2D "

A two-dimensional Bravais lattice with no special symmetry.

C++ includes: Lattice2D.h
";

%feature("docstring")  BasicLattice2D::BasicLattice2D "BasicLattice2D::BasicLattice2D(double length1, double length2, double angle, double xi)
BasicLattice2D::BasicLattice2D";

%feature("docstring")  BasicLattice2D::clone "BasicLattice2D * BasicLattice2D::clone() const override
BasicLattice2D::clone";

%feature("docstring")  BasicLattice2D::className "std::string BasicLattice2D::className() const final
BasicLattice2D::className";

%feature("docstring")  BasicLattice2D::parDefs "std::vector< ParaMeta > BasicLattice2D::parDefs() const final
BasicLattice2D::parDefs";

%feature("docstring")  BasicLattice2D::length1 "double BasicLattice2D::length1() const override
BasicLattice2D::length1";

%feature("docstring")  BasicLattice2D::length2 "double BasicLattice2D::length2() const override
BasicLattice2D::length2";

%feature("docstring")  BasicLattice2D::latticeAngle "double BasicLattice2D::latticeAngle() const override
BasicLattice2D::latticeAngle";

%feature("docstring")  BasicLattice2D::unitCellArea "double BasicLattice2D::unitCellArea() const override
BasicLattice2D::unitCellArea";


// File: classBipyramid4.xml
%feature("docstring") Bipyramid4 "

A truncated bifrustum with quadratic base.

C++ includes: Bipyramid4.h
";

%feature("docstring")  Bipyramid4::Bipyramid4 "Bipyramid4::Bipyramid4(double length, double height, double height_ratio, double alpha)
Bipyramid4::Bipyramid4";

%feature("docstring")  Bipyramid4::Bipyramid4 "Bipyramid4::Bipyramid4(std::vector< double > P)
Bipyramid4::Bipyramid4";

%feature("docstring")  Bipyramid4::clone "Bipyramid4 * Bipyramid4::clone() const override
Bipyramid4::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Bipyramid4::className "std::string Bipyramid4::className() const final
Bipyramid4::className";

%feature("docstring")  Bipyramid4::parDefs "std::vector< ParaMeta > Bipyramid4::parDefs() const final
Bipyramid4::parDefs";

%feature("docstring")  Bipyramid4::length "double Bipyramid4::length() const
Bipyramid4::length";

%feature("docstring")  Bipyramid4::height "double Bipyramid4::height() const
Bipyramid4::height";

%feature("docstring")  Bipyramid4::heightRatio "double Bipyramid4::heightRatio() const
Bipyramid4::heightRatio";

%feature("docstring")  Bipyramid4::alpha "double Bipyramid4::alpha() const
Bipyramid4::alpha";

%feature("docstring")  Bipyramid4::validate "std::string Bipyramid4::validate() const override
Bipyramid4::validate";


// File: classBox.xml
%feature("docstring") Box "

A rectangular prism (parallelepiped).

C++ includes: Box.h
";

%feature("docstring")  Box::Box "Box::Box(double length, double width, double height)
Box::Box";

%feature("docstring")  Box::Box "Box::Box(std::vector< double > P)
Box::Box";

%feature("docstring")  Box::clone "Box * Box::clone() const override
Box::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Box::className "std::string Box::className() const final
Box::className";

%feature("docstring")  Box::parDefs "std::vector< ParaMeta > Box::parDefs() const final
Box::parDefs";

%feature("docstring")  Box::length "double Box::length() const
Box::length";

%feature("docstring")  Box::width "double Box::width() const
Box::width";

%feature("docstring")  Box::height "double Box::height() const override
Box::height";

%feature("docstring")  Box::volume "double Box::volume() const override
Box::volume";

%feature("docstring")  Box::radialExtension "double Box::radialExtension() const override
Box::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  Box::formfactor_at_bottom "complex_t Box::formfactor_at_bottom(C3 q) const override
Box::formfactor_at_bottom";

%feature("docstring")  Box::validate "std::string Box::validate() const override
Box::validate";


// File: classBoxNet.xml
%feature("docstring") BoxNet "";

%feature("docstring")  BoxNet::BoxNet "BoxNet::BoxNet(double length, double width, double height)
BoxNet::BoxNet";

%feature("docstring")  BoxNet::~BoxNet "BoxNet::~BoxNet() override
BoxNet::~BoxNet";


// File: classCantellatedCube.xml
%feature("docstring") CantellatedCube "

A cube, with truncation of all edges and corners, as in Croset (2017) Fig 7

C++ includes: CantellatedCube.h
";

%feature("docstring")  CantellatedCube::CantellatedCube "CantellatedCube::CantellatedCube(double length, double removed_length)
CantellatedCube::CantellatedCube";

%feature("docstring")  CantellatedCube::CantellatedCube "CantellatedCube::CantellatedCube(std::vector< double > P)
CantellatedCube::CantellatedCube";

%feature("docstring")  CantellatedCube::clone "CantellatedCube * CantellatedCube::clone() const override
CantellatedCube::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  CantellatedCube::className "std::string CantellatedCube::className() const final
CantellatedCube::className";

%feature("docstring")  CantellatedCube::parDefs "std::vector< ParaMeta > CantellatedCube::parDefs() const final
CantellatedCube::parDefs";

%feature("docstring")  CantellatedCube::length "double CantellatedCube::length() const
CantellatedCube::length";

%feature("docstring")  CantellatedCube::removedLength "double CantellatedCube::removedLength() const
CantellatedCube::removedLength";

%feature("docstring")  CantellatedCube::validate "std::string CantellatedCube::validate() const override
CantellatedCube::validate";


// File: classCone.xml
%feature("docstring") Cone "

A conical frustum (cone truncated parallel to the base) with circular base.

C++ includes: Cone.h
";

%feature("docstring")  Cone::Cone "Cone::Cone(double radius, double height, double alpha)
Cone::Cone";

%feature("docstring")  Cone::Cone "Cone::Cone(std::vector< double > P)
Cone::Cone";

%feature("docstring")  Cone::clone "Cone * Cone::clone() const override
Cone::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Cone::className "std::string Cone::className() const final
Cone::className";

%feature("docstring")  Cone::parDefs "std::vector< ParaMeta > Cone::parDefs() const final
Cone::parDefs";

%feature("docstring")  Cone::radius "double Cone::radius() const
Cone::radius";

%feature("docstring")  Cone::height "double Cone::height() const
Cone::height";

%feature("docstring")  Cone::alpha "double Cone::alpha() const
Cone::alpha";

%feature("docstring")  Cone::radialExtension "double Cone::radialExtension() const override
Cone::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  Cone::formfactor_at_bottom "complex_t Cone::formfactor_at_bottom(C3 q) const override
Cone::formfactor_at_bottom";

%feature("docstring")  Cone::validate "std::string Cone::validate() const override
Cone::validate";


// File: classCosineRippleBox.xml
%feature("docstring") CosineRippleBox "

The form factor for a cosine ripple, with box profile in elongation direction.

C++ includes: CosineRipple.h
";

%feature("docstring")  CosineRippleBox::CosineRippleBox "CosineRippleBox::CosineRippleBox(double length, double width, double height)
CosineRippleBox::CosineRippleBox";

%feature("docstring")  CosineRippleBox::CosineRippleBox "CosineRippleBox::CosineRippleBox(std::vector< double > P)
CosineRippleBox::CosineRippleBox";

%feature("docstring")  CosineRippleBox::clone "CosineRippleBox * CosineRippleBox::clone() const override
CosineRippleBox::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  CosineRippleBox::className "std::string CosineRippleBox::className() const final
CosineRippleBox::className";

%feature("docstring")  CosineRippleBox::parDefs "std::vector< ParaMeta > CosineRippleBox::parDefs() const final
CosineRippleBox::parDefs";


// File: classCosineRippleGauss.xml
%feature("docstring") CosineRippleGauss "

The form factor for a cosine ripple, with Gaussian profile in elongation direction.

C++ includes: CosineRipple.h
";

%feature("docstring")  CosineRippleGauss::CosineRippleGauss "CosineRippleGauss::CosineRippleGauss(double length, double width, double height)
CosineRippleGauss::CosineRippleGauss";

%feature("docstring")  CosineRippleGauss::CosineRippleGauss "CosineRippleGauss::CosineRippleGauss(std::vector< double > P)
CosineRippleGauss::CosineRippleGauss";

%feature("docstring")  CosineRippleGauss::clone "CosineRippleGauss * CosineRippleGauss::clone() const override
CosineRippleGauss::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  CosineRippleGauss::className "std::string CosineRippleGauss::className() const final
CosineRippleGauss::className";

%feature("docstring")  CosineRippleGauss::parDefs "std::vector< ParaMeta > CosineRippleGauss::parDefs() const final
CosineRippleGauss::parDefs";


// File: classCosineRippleLorentz.xml
%feature("docstring") CosineRippleLorentz "

The form factor for a cosine ripple, with Lorentz form factor in elongation direction.

C++ includes: CosineRipple.h
";

%feature("docstring")  CosineRippleLorentz::CosineRippleLorentz "CosineRippleLorentz::CosineRippleLorentz(double length, double width, double height)
CosineRippleLorentz::CosineRippleLorentz";

%feature("docstring")  CosineRippleLorentz::CosineRippleLorentz "CosineRippleLorentz::CosineRippleLorentz(std::vector< double > P)
CosineRippleLorentz::CosineRippleLorentz";

%feature("docstring")  CosineRippleLorentz::clone "CosineRippleLorentz * CosineRippleLorentz::clone() const override
CosineRippleLorentz::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  CosineRippleLorentz::className "std::string CosineRippleLorentz::className() const final
CosineRippleLorentz::className";

%feature("docstring")  CosineRippleLorentz::parDefs "std::vector< ParaMeta > CosineRippleLorentz::parDefs() const final
CosineRippleLorentz::parDefs";


// File: classCrystal.xml
%feature("docstring") Crystal "

A crystal structure, defined by a Bravais lattice, a basis, and a position variance.

Computations are delegated to class ReMesocrystal.

Used in  MesoCrystal, where it is given an outer shape.

C++ includes: Crystal.h
";

%feature("docstring")  Crystal::Crystal "Crystal::Crystal(const IParticle &basis, const Lattice3D &lattice, double position_variance=0)
Crystal::Crystal";

%feature("docstring")  Crystal::~Crystal "Crystal::~Crystal() override
Crystal::~Crystal";

%feature("docstring")  Crystal::clone "Crystal * Crystal::clone() const override
Crystal::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Crystal::className "std::string Crystal::className() const final
Crystal::className";

%feature("docstring")  Crystal::nodeChildren "std::vector< const INode * > Crystal::nodeChildren() const override
Crystal::nodeChildren";

%feature("docstring")  Crystal::parDefs "std::vector< ParaMeta > Crystal::parDefs() const final
Crystal::parDefs";

%feature("docstring")  Crystal::basis "const IParticle * Crystal::basis() const
Crystal::basis";

%feature("docstring")  Crystal::lattice "const Lattice3D * Crystal::lattice() const
Crystal::lattice";

%feature("docstring")  Crystal::position_variance "double Crystal::position_variance() const
Crystal::position_variance";

%feature("docstring")  Crystal::transformed "Crystal * Crystal::transformed(const IRotation *rotation, const R3 &translation) const
Crystal::transformed";

%feature("docstring")  Crystal::validate "std::string Crystal::validate() const override
Crystal::validate";


// File: classCylinder.xml
%feature("docstring") Cylinder "

A circular cylinder.

C++ includes: Cylinder.h
";

%feature("docstring")  Cylinder::Cylinder "Cylinder::Cylinder(double radius, double height)
Cylinder::Cylinder";

%feature("docstring")  Cylinder::Cylinder "Cylinder::Cylinder(std::vector< double > P)
Cylinder::Cylinder";

%feature("docstring")  Cylinder::clone "Cylinder * Cylinder::clone() const override
Cylinder::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Cylinder::className "std::string Cylinder::className() const final
Cylinder::className";

%feature("docstring")  Cylinder::parDefs "std::vector< ParaMeta > Cylinder::parDefs() const final
Cylinder::parDefs";

%feature("docstring")  Cylinder::height "double Cylinder::height() const
Cylinder::height";

%feature("docstring")  Cylinder::radius "double Cylinder::radius() const
Cylinder::radius";

%feature("docstring")  Cylinder::radialExtension "double Cylinder::radialExtension() const override
Cylinder::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  Cylinder::formfactor_at_bottom "complex_t Cylinder::formfactor_at_bottom(C3 q) const override
Cylinder::formfactor_at_bottom";

%feature("docstring")  Cylinder::validate "std::string Cylinder::validate() const override
Cylinder::validate";


// File: classDistribution1DCauchySampler.xml
%feature("docstring") Distribution1DCauchySampler "";

%feature("docstring")  Distribution1DCauchySampler::Distribution1DCauchySampler "Distribution1DCauchySampler::Distribution1DCauchySampler(double lambda)
Distribution1DCauchySampler::Distribution1DCauchySampler";

%feature("docstring")  Distribution1DCauchySampler::randomSample "double Distribution1DCauchySampler::randomSample() const override
Distribution1DCauchySampler::randomSample";


// File: classDistribution1DCosineSampler.xml
%feature("docstring") Distribution1DCosineSampler "";

%feature("docstring")  Distribution1DCosineSampler::Distribution1DCosineSampler "Distribution1DCosineSampler::Distribution1DCosineSampler(double omega)
Distribution1DCosineSampler::Distribution1DCosineSampler";

%feature("docstring")  Distribution1DCosineSampler::randomSample "double Distribution1DCosineSampler::randomSample() const override
Distribution1DCosineSampler::randomSample";


// File: classDistribution1DGateSampler.xml
%feature("docstring") Distribution1DGateSampler "";

%feature("docstring")  Distribution1DGateSampler::Distribution1DGateSampler "Distribution1DGateSampler::Distribution1DGateSampler(double a, double b)
Distribution1DGateSampler::Distribution1DGateSampler";

%feature("docstring")  Distribution1DGateSampler::randomSample "double Distribution1DGateSampler::randomSample() const override
Distribution1DGateSampler::randomSample";


// File: classDistribution1DGaussSampler.xml
%feature("docstring") Distribution1DGaussSampler "";

%feature("docstring")  Distribution1DGaussSampler::Distribution1DGaussSampler "Distribution1DGaussSampler::Distribution1DGaussSampler(double mean, double stddev)
Distribution1DGaussSampler::Distribution1DGaussSampler";

%feature("docstring")  Distribution1DGaussSampler::randomSample "double Distribution1DGaussSampler::randomSample() const override
Distribution1DGaussSampler::randomSample";


// File: classDistribution1DTriangleSampler.xml
%feature("docstring") Distribution1DTriangleSampler "";

%feature("docstring")  Distribution1DTriangleSampler::Distribution1DTriangleSampler "Distribution1DTriangleSampler::Distribution1DTriangleSampler(double omega)
Distribution1DTriangleSampler::Distribution1DTriangleSampler";

%feature("docstring")  Distribution1DTriangleSampler::randomSample "double Distribution1DTriangleSampler::randomSample() const override
Distribution1DTriangleSampler::randomSample";


// File: classDistribution2DCauchySampler.xml
%feature("docstring") Distribution2DCauchySampler "";

%feature("docstring")  Distribution2DCauchySampler::Distribution2DCauchySampler "Distribution2DCauchySampler::Distribution2DCauchySampler(double omega_x, double omega_y)
Distribution2DCauchySampler::Distribution2DCauchySampler";

%feature("docstring")  Distribution2DCauchySampler::randomSample "std::pair< double, double > Distribution2DCauchySampler::randomSample() const override
Distribution2DCauchySampler::randomSample";


// File: classDistribution2DConeSampler.xml
%feature("docstring") Distribution2DConeSampler "";

%feature("docstring")  Distribution2DConeSampler::Distribution2DConeSampler "Distribution2DConeSampler::Distribution2DConeSampler(double omega_x, double omega_y)
Distribution2DConeSampler::Distribution2DConeSampler";

%feature("docstring")  Distribution2DConeSampler::randomSample "std::pair< double, double > Distribution2DConeSampler::randomSample() const override
Distribution2DConeSampler::randomSample";


// File: classDistribution2DGateSampler.xml
%feature("docstring") Distribution2DGateSampler "";

%feature("docstring")  Distribution2DGateSampler::Distribution2DGateSampler "Distribution2DGateSampler::Distribution2DGateSampler(double omega_x, double omega_y)
Distribution2DGateSampler::Distribution2DGateSampler";

%feature("docstring")  Distribution2DGateSampler::randomSample "std::pair< double, double > Distribution2DGateSampler::randomSample() const override
Distribution2DGateSampler::randomSample";


// File: classDistribution2DGaussSampler.xml
%feature("docstring") Distribution2DGaussSampler "";

%feature("docstring")  Distribution2DGaussSampler::Distribution2DGaussSampler "Distribution2DGaussSampler::Distribution2DGaussSampler(double omega_x, double omega_y)
Distribution2DGaussSampler::Distribution2DGaussSampler";

%feature("docstring")  Distribution2DGaussSampler::randomSample "std::pair< double, double > Distribution2DGaussSampler::randomSample() const override
Distribution2DGaussSampler::randomSample";


// File: classDodecahedron.xml
%feature("docstring") Dodecahedron "

A regular dodecahedron.

C++ includes: Dodecahedron.h
";

%feature("docstring")  Dodecahedron::Dodecahedron "Dodecahedron::Dodecahedron(double edge)
Dodecahedron::Dodecahedron";

%feature("docstring")  Dodecahedron::Dodecahedron "Dodecahedron::Dodecahedron(std::vector< double > P)
Dodecahedron::Dodecahedron";

%feature("docstring")  Dodecahedron::clone "Dodecahedron * Dodecahedron::clone() const override
Dodecahedron::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Dodecahedron::className "std::string Dodecahedron::className() const final
Dodecahedron::className";

%feature("docstring")  Dodecahedron::parDefs "std::vector< ParaMeta > Dodecahedron::parDefs() const final
Dodecahedron::parDefs";

%feature("docstring")  Dodecahedron::edge "double Dodecahedron::edge() const
Dodecahedron::edge";

%feature("docstring")  Dodecahedron::validate "std::string Dodecahedron::validate() const override
Dodecahedron::validate";


// File: classDoubleEllipseX.xml
%feature("docstring") DoubleEllipseX "";

%feature("docstring")  DoubleEllipseX::DoubleEllipseX "DoubleEllipseX::DoubleEllipseX(double x1, double r1_y, double r1_z, double z1_b, double z1_t, double x2, double r2_y, double r2_z, double z2_b, double z2_t)
DoubleEllipseX::DoubleEllipseX";

%feature("docstring")  DoubleEllipseX::~DoubleEllipseX "DoubleEllipseX::~DoubleEllipseX() override
DoubleEllipseX::~DoubleEllipseX";


// File: classDoubleEllipseZ.xml
%feature("docstring") DoubleEllipseZ "";

%feature("docstring")  DoubleEllipseZ::DoubleEllipseZ "DoubleEllipseZ::DoubleEllipseZ(double r0_x, double r0_y, double z, double rz_x, double rz_y)
DoubleEllipseZ::DoubleEllipseZ";

%feature("docstring")  DoubleEllipseZ::~DoubleEllipseZ "DoubleEllipseZ::~DoubleEllipseZ() override
DoubleEllipseZ::~DoubleEllipseZ";


// File: classEllipsoidalCylinder.xml
%feature("docstring") EllipsoidalCylinder "

A cylinder with elliptical base.

C++ includes: EllipsoidalCylinder.h
";

%feature("docstring")  EllipsoidalCylinder::EllipsoidalCylinder "EllipsoidalCylinder::EllipsoidalCylinder(double radius_x, double radius_y, double height)
EllipsoidalCylinder::EllipsoidalCylinder";

%feature("docstring")  EllipsoidalCylinder::EllipsoidalCylinder "EllipsoidalCylinder::EllipsoidalCylinder(std::vector< double > P)
EllipsoidalCylinder::EllipsoidalCylinder";

%feature("docstring")  EllipsoidalCylinder::clone "EllipsoidalCylinder * EllipsoidalCylinder::clone() const override
EllipsoidalCylinder::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  EllipsoidalCylinder::className "std::string EllipsoidalCylinder::className() const final
EllipsoidalCylinder::className";

%feature("docstring")  EllipsoidalCylinder::parDefs "std::vector< ParaMeta > EllipsoidalCylinder::parDefs() const final
EllipsoidalCylinder::parDefs";

%feature("docstring")  EllipsoidalCylinder::radiusX "double EllipsoidalCylinder::radiusX() const
EllipsoidalCylinder::radiusX";

%feature("docstring")  EllipsoidalCylinder::radiusY "double EllipsoidalCylinder::radiusY() const
EllipsoidalCylinder::radiusY";

%feature("docstring")  EllipsoidalCylinder::height "double EllipsoidalCylinder::height() const
EllipsoidalCylinder::height";

%feature("docstring")  EllipsoidalCylinder::radialExtension "double EllipsoidalCylinder::radialExtension() const override
EllipsoidalCylinder::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  EllipsoidalCylinder::formfactor_at_bottom "complex_t EllipsoidalCylinder::formfactor_at_bottom(C3 q) const override
EllipsoidalCylinder::formfactor_at_bottom";

%feature("docstring")  EllipsoidalCylinder::validate "std::string EllipsoidalCylinder::validate() const override
EllipsoidalCylinder::validate";


// File: classFormFactorComponents.xml
%feature("docstring") FormFactorComponents "

Predefined form factors for functional tests.

C++ includes: FormFactorComponents.h
";

%feature("docstring")  FormFactorComponents::FormFactorComponents "FormFactorComponents::FormFactorComponents()
FormFactorComponents::FormFactorComponents";


// File: classFuzzySphere.xml
%feature("docstring") FuzzySphere "

A sphere with gaussian radius distribution.

C++ includes: FuzzySphere.h
";

%feature("docstring")  FuzzySphere::FuzzySphere "FuzzySphere::FuzzySphere(std::vector< double > P)
FuzzySphere::FuzzySphere";

%feature("docstring")  FuzzySphere::FuzzySphere "FuzzySphere::FuzzySphere(double mean, double sigma)
FuzzySphere::FuzzySphere";

%feature("docstring")  FuzzySphere::clone "FuzzySphere * FuzzySphere::clone() const override
FuzzySphere::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  FuzzySphere::className "std::string FuzzySphere::className() const final
FuzzySphere::className";

%feature("docstring")  FuzzySphere::parDefs "std::vector< ParaMeta > FuzzySphere::parDefs() const final
FuzzySphere::parDefs";

%feature("docstring")  FuzzySphere::radialExtension "double FuzzySphere::radialExtension() const override
FuzzySphere::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  FuzzySphere::formfactor_at_bottom "complex_t FuzzySphere::formfactor_at_bottom(C3 q) const override
FuzzySphere::formfactor_at_bottom";

%feature("docstring")  FuzzySphere::validate "std::string FuzzySphere::validate() const override
FuzzySphere::validate";


// File: classGaussFisherPeakShape.xml
%feature("docstring") GaussFisherPeakShape "

A peak shape that is Gaussian in the radial direction and uses the Mises-Fisher distribution in the angular direction.

C++ includes: IPeakShape.h
";

%feature("docstring")  GaussFisherPeakShape::GaussFisherPeakShape "GaussFisherPeakShape::GaussFisherPeakShape(double max_intensity, double radial_size, double kappa)
GaussFisherPeakShape::GaussFisherPeakShape";

%feature("docstring")  GaussFisherPeakShape::~GaussFisherPeakShape "GaussFisherPeakShape::~GaussFisherPeakShape() override
GaussFisherPeakShape::~GaussFisherPeakShape";

%feature("docstring")  GaussFisherPeakShape::clone "GaussFisherPeakShape * GaussFisherPeakShape::clone() const override
GaussFisherPeakShape::clone";

%feature("docstring")  GaussFisherPeakShape::className "std::string GaussFisherPeakShape::className() const final
GaussFisherPeakShape::className";

%feature("docstring")  GaussFisherPeakShape::parDefs "std::vector< ParaMeta > GaussFisherPeakShape::parDefs() const final
GaussFisherPeakShape::parDefs";

%feature("docstring")  GaussFisherPeakShape::peakDistribution "double GaussFisherPeakShape::peakDistribution(R3 q, R3 q_lattice_point) const override
GaussFisherPeakShape::peakDistribution
Peak shape at q from a reciprocal lattice point at q_lattice_point. 
";

%feature("docstring")  GaussFisherPeakShape::angularDisorder "bool GaussFisherPeakShape::angularDisorder() const override
GaussFisherPeakShape::angularDisorder
Indicates if the peak shape encodes angular disorder, in which case all peaks in a spherical shell are needed 
";


// File: classGaussSphere.xml
%feature("docstring") GaussSphere "

The form factor of a Gaussian sphere.

C++ includes: Gauss.h
";

%feature("docstring")  GaussSphere::GaussSphere "GaussSphere::GaussSphere(std::vector< double > P)
GaussSphere::GaussSphere";

%feature("docstring")  GaussSphere::GaussSphere "GaussSphere::GaussSphere(double mean_radius)
GaussSphere::GaussSphere";

%feature("docstring")  GaussSphere::clone "GaussSphere * GaussSphere::clone() const override
GaussSphere::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  GaussSphere::className "std::string GaussSphere::className() const final
GaussSphere::className";

%feature("docstring")  GaussSphere::parDefs "std::vector< ParaMeta > GaussSphere::parDefs() const final
GaussSphere::parDefs";

%feature("docstring")  GaussSphere::meanRadius "double GaussSphere::meanRadius() const
GaussSphere::meanRadius";

%feature("docstring")  GaussSphere::radialExtension "double GaussSphere::radialExtension() const override
GaussSphere::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  GaussSphere::formfactor_at_bottom "complex_t GaussSphere::formfactor_at_bottom(C3 q) const override
GaussSphere::formfactor_at_bottom";

%feature("docstring")  GaussSphere::validate "std::string GaussSphere::validate() const override
GaussSphere::validate";


// File: classHemiEllipsoid.xml
%feature("docstring") HemiEllipsoid "

An hemi ellipsoid, obtained by truncating a full ellipsoid in the middle plane spanned by two principal axes.

C++ includes: HemiEllipsoid.h
";

%feature("docstring")  HemiEllipsoid::HemiEllipsoid "HemiEllipsoid::HemiEllipsoid(double radius_x, double radius_y, double height)
HemiEllipsoid::HemiEllipsoid";

%feature("docstring")  HemiEllipsoid::HemiEllipsoid "HemiEllipsoid::HemiEllipsoid(std::vector< double > P)
HemiEllipsoid::HemiEllipsoid";

%feature("docstring")  HemiEllipsoid::~HemiEllipsoid "HemiEllipsoid::~HemiEllipsoid() override=default
HemiEllipsoid::~HemiEllipsoid";

%feature("docstring")  HemiEllipsoid::clone "HemiEllipsoid * HemiEllipsoid::clone() const override
HemiEllipsoid::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  HemiEllipsoid::className "std::string HemiEllipsoid::className() const final
HemiEllipsoid::className";

%feature("docstring")  HemiEllipsoid::parDefs "std::vector< ParaMeta > HemiEllipsoid::parDefs() const final
HemiEllipsoid::parDefs";

%feature("docstring")  HemiEllipsoid::height "double HemiEllipsoid::height() const
HemiEllipsoid::height";

%feature("docstring")  HemiEllipsoid::radiusX "double HemiEllipsoid::radiusX() const
HemiEllipsoid::radiusX";

%feature("docstring")  HemiEllipsoid::radiusY "double HemiEllipsoid::radiusY() const
HemiEllipsoid::radiusY";

%feature("docstring")  HemiEllipsoid::radialExtension "double HemiEllipsoid::radialExtension() const override
HemiEllipsoid::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  HemiEllipsoid::formfactor_at_bottom "complex_t HemiEllipsoid::formfactor_at_bottom(C3 q) const override
HemiEllipsoid::formfactor_at_bottom";

%feature("docstring")  HemiEllipsoid::validate "std::string HemiEllipsoid::validate() const override
HemiEllipsoid::validate";


// File: classHexagonalLattice2D.xml
%feature("docstring") HexagonalLattice2D "

A two-dimensional Bravais lattice with hexagonal symmetry.

C++ includes: Lattice2D.h
";

%feature("docstring")  HexagonalLattice2D::HexagonalLattice2D "HexagonalLattice2D::HexagonalLattice2D(double length, double xi)
HexagonalLattice2D::HexagonalLattice2D";

%feature("docstring")  HexagonalLattice2D::clone "HexagonalLattice2D * HexagonalLattice2D::clone() const override
HexagonalLattice2D::clone";

%feature("docstring")  HexagonalLattice2D::className "std::string HexagonalLattice2D::className() const final
HexagonalLattice2D::className";

%feature("docstring")  HexagonalLattice2D::parDefs "std::vector< ParaMeta > HexagonalLattice2D::parDefs() const final
HexagonalLattice2D::parDefs";

%feature("docstring")  HexagonalLattice2D::length1 "double HexagonalLattice2D::length1() const override
HexagonalLattice2D::length1";

%feature("docstring")  HexagonalLattice2D::length2 "double HexagonalLattice2D::length2() const override
HexagonalLattice2D::length2";

%feature("docstring")  HexagonalLattice2D::latticeAngle "double HexagonalLattice2D::latticeAngle() const override
HexagonalLattice2D::latticeAngle";

%feature("docstring")  HexagonalLattice2D::unitCellArea "double HexagonalLattice2D::unitCellArea() const override
HexagonalLattice2D::unitCellArea";


// File: classHollowSphere.xml
%feature("docstring") HollowSphere "

Integrated full sphere form factor over a uniform distribution of radii.

C++ includes: HollowSphere.h
";

%feature("docstring")  HollowSphere::HollowSphere "HollowSphere::HollowSphere(double mean, double full_width)
HollowSphere::HollowSphere";

%feature("docstring")  HollowSphere::HollowSphere "HollowSphere::HollowSphere(std::vector< double > P)
HollowSphere::HollowSphere";

%feature("docstring")  HollowSphere::clone "HollowSphere * HollowSphere::clone() const override
HollowSphere::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  HollowSphere::className "std::string HollowSphere::className() const final
HollowSphere::className";

%feature("docstring")  HollowSphere::parDefs "std::vector< ParaMeta > HollowSphere::parDefs() const final
HollowSphere::parDefs";

%feature("docstring")  HollowSphere::radialExtension "double HollowSphere::radialExtension() const override
HollowSphere::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  HollowSphere::formfactor_at_bottom "complex_t HollowSphere::formfactor_at_bottom(C3 q) const override
HollowSphere::formfactor_at_bottom";

%feature("docstring")  HollowSphere::validate "std::string HollowSphere::validate() const override
HollowSphere::validate";


// File: classHorizontalCylinder.xml
%feature("docstring") HorizontalCylinder "

A circular cylinder.

C++ includes: HorizontalCylinder.h
";

%feature("docstring")  HorizontalCylinder::HorizontalCylinder "HorizontalCylinder::HorizontalCylinder(double radius, double length, double slice_bottom, double slice_top)
HorizontalCylinder::HorizontalCylinder";

%feature("docstring")  HorizontalCylinder::HorizontalCylinder "HorizontalCylinder::HorizontalCylinder(double radius, double length)
HorizontalCylinder::HorizontalCylinder";

%feature("docstring")  HorizontalCylinder::HorizontalCylinder "HorizontalCylinder::HorizontalCylinder(std::vector< double > P)
HorizontalCylinder::HorizontalCylinder";

%feature("docstring")  HorizontalCylinder::clone "HorizontalCylinder * HorizontalCylinder::clone() const override
HorizontalCylinder::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  HorizontalCylinder::className "std::string HorizontalCylinder::className() const final
HorizontalCylinder::className";

%feature("docstring")  HorizontalCylinder::parDefs "std::vector< ParaMeta > HorizontalCylinder::parDefs() const final
HorizontalCylinder::parDefs";

%feature("docstring")  HorizontalCylinder::length "double HorizontalCylinder::length() const
HorizontalCylinder::length";

%feature("docstring")  HorizontalCylinder::radius "double HorizontalCylinder::radius() const
HorizontalCylinder::radius";

%feature("docstring")  HorizontalCylinder::slice_bottom "double HorizontalCylinder::slice_bottom() const
HorizontalCylinder::slice_bottom";

%feature("docstring")  HorizontalCylinder::slice_top "double HorizontalCylinder::slice_top() const
HorizontalCylinder::slice_top";

%feature("docstring")  HorizontalCylinder::radialExtension "double HorizontalCylinder::radialExtension() const override
HorizontalCylinder::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  HorizontalCylinder::formfactor_at_bottom "complex_t HorizontalCylinder::formfactor_at_bottom(C3 q) const override
HorizontalCylinder::formfactor_at_bottom";

%feature("docstring")  HorizontalCylinder::validate "std::string HorizontalCylinder::validate() const override
HorizontalCylinder::validate";


// File: classIcosahedron.xml
%feature("docstring") Icosahedron "

A regular icosahedron.

C++ includes: Icosahedron.h
";

%feature("docstring")  Icosahedron::Icosahedron "Icosahedron::Icosahedron(double edge)
Icosahedron::Icosahedron";

%feature("docstring")  Icosahedron::Icosahedron "Icosahedron::Icosahedron(std::vector< double > P)
Icosahedron::Icosahedron";

%feature("docstring")  Icosahedron::clone "Icosahedron * Icosahedron::clone() const override
Icosahedron::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Icosahedron::className "std::string Icosahedron::className() const final
Icosahedron::className";

%feature("docstring")  Icosahedron::parDefs "std::vector< ParaMeta > Icosahedron::parDefs() const final
Icosahedron::parDefs";

%feature("docstring")  Icosahedron::edge "double Icosahedron::edge() const
Icosahedron::edge";

%feature("docstring")  Icosahedron::validate "std::string Icosahedron::validate() const override
Icosahedron::validate";


// File: classICosineRipple.xml
%feature("docstring") ICosineRipple "

Base class for form factors with a cosine ripple profile in the yz plane.

C++ includes: IProfileRipple.h
";

%feature("docstring")  ICosineRipple::ICosineRipple "ICosineRipple::ICosineRipple(const std::vector< double > &PValues)
ICosineRipple::ICosineRipple";


// File: classIdentityRotation.xml
%feature("docstring") IdentityRotation "

The identity rotation, which leaves everything in place.

C++ includes: Rotations.h
";

%feature("docstring")  IdentityRotation::IdentityRotation "IdentityRotation::IdentityRotation()
IdentityRotation::IdentityRotation";

%feature("docstring")  IdentityRotation::clone "IdentityRotation * IdentityRotation::clone() const override
IdentityRotation::clone";

%feature("docstring")  IdentityRotation::className "std::string IdentityRotation::className() const final
IdentityRotation::className";

%feature("docstring")  IdentityRotation::createInverse "IdentityRotation * IdentityRotation::createInverse() const override
IdentityRotation::createInverse
Returns a new  IRotation object that is the current object's inverse. 
";

%feature("docstring")  IdentityRotation::rotMatrix "RotMatrix IdentityRotation::rotMatrix() const override
IdentityRotation::rotMatrix
Returns transformation. 
";

%feature("docstring")  IdentityRotation::isIdentity "bool IdentityRotation::isIdentity() const override
IdentityRotation::isIdentity
Returns true if rotation matrix is identity matrix (no rotations) 
";


// File: classIDistribution1DSampler.xml
%feature("docstring") IDistribution1DSampler "";

%feature("docstring")  IDistribution1DSampler::IDistribution1DSampler "IDistribution1DSampler::IDistribution1DSampler()=default
IDistribution1DSampler::IDistribution1DSampler";

%feature("docstring")  IDistribution1DSampler::~IDistribution1DSampler "IDistribution1DSampler::~IDistribution1DSampler()
IDistribution1DSampler::~IDistribution1DSampler";

%feature("docstring")  IDistribution1DSampler::randomSample "virtual double IDistribution1DSampler::randomSample() const =0
IDistribution1DSampler::randomSample";


// File: classIDistribution2DSampler.xml
%feature("docstring") IDistribution2DSampler "";

%feature("docstring")  IDistribution2DSampler::IDistribution2DSampler "IDistribution2DSampler::IDistribution2DSampler()=default
IDistribution2DSampler::IDistribution2DSampler";

%feature("docstring")  IDistribution2DSampler::~IDistribution2DSampler "IDistribution2DSampler::~IDistribution2DSampler()
IDistribution2DSampler::~IDistribution2DSampler";

%feature("docstring")  IDistribution2DSampler::randomSample "virtual std::pair< double, double > IDistribution2DSampler::randomSample() const =0
IDistribution2DSampler::randomSample";


// File: classIFormFactor.xml
%feature("docstring") IFormFactor "

Abstract base class for Born form factors.

In contrast to the generic IReParticle, a Born form factor does not depend on the incoming and outgoing wave vectors ki and kf, except through their difference, the scattering vector q=ki-kf.

C++ includes: IFormFactor.h
";

%feature("docstring")  IFormFactor::IFormFactor "IFormFactor::IFormFactor()
IFormFactor::IFormFactor";

%feature("docstring")  IFormFactor::IFormFactor "IFormFactor::IFormFactor(const std::vector< double > &PValues)
IFormFactor::IFormFactor";

%feature("docstring")  IFormFactor::~IFormFactor "IFormFactor::~IFormFactor() override
IFormFactor::~IFormFactor";

%feature("docstring")  IFormFactor::clone "IFormFactor * IFormFactor::clone() const override=0
IFormFactor::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  IFormFactor::theFF "complex_t IFormFactor::theFF(const WavevectorInfo &wavevectors) const
IFormFactor::theFF";

%feature("docstring")  IFormFactor::thePolFF "SpinMatrix IFormFactor::thePolFF(const WavevectorInfo &wavevectors) const
IFormFactor::thePolFF";

%feature("docstring")  IFormFactor::bottomZ "double IFormFactor::bottomZ(const IRotation *rotation) const
IFormFactor::bottomZ";

%feature("docstring")  IFormFactor::topZ "double IFormFactor::topZ(const IRotation *rotation) const
IFormFactor::topZ";

%feature("docstring")  IFormFactor::volume "double IFormFactor::volume() const
IFormFactor::volume";

%feature("docstring")  IFormFactor::radialExtension "virtual double IFormFactor::radialExtension() const =0
IFormFactor::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  IFormFactor::formfactor_at_bottom "virtual complex_t IFormFactor::formfactor_at_bottom(C3 q) const =0
IFormFactor::formfactor_at_bottom";

%feature("docstring")  IFormFactor::pythonConstructor "std::string IFormFactor::pythonConstructor() const
IFormFactor::pythonConstructor
Creates the Python constructor of this class (or derived classes) 
";

%feature("docstring")  IFormFactor::canSliceAnalytically "bool IFormFactor::canSliceAnalytically(const IRotation *rot) const
IFormFactor::canSliceAnalytically
Default implementation only allows rotations along z-axis. 
";

%feature("docstring")  IFormFactor::formfactor_pol "SpinMatrix IFormFactor::formfactor_pol(C3 q) const
IFormFactor::formfactor_pol
Returns scattering amplitude for complex scattering wavevector q=k_i-k_f in case of matrix interactions. Default implementation calls formfactor_at_bottom(q) and multiplies with the unit matrix. 
";


// File: classIFormFactorPolyhedron.xml
%feature("docstring") IFormFactorPolyhedron "

A polyhedron, for form factor computation.

C++ includes: IFormFactorPolyhedron.h
";

%feature("docstring")  IFormFactorPolyhedron::IFormFactorPolyhedron "IFormFactorPolyhedron::IFormFactorPolyhedron(const std::vector< double > &PValues)
IFormFactorPolyhedron::IFormFactorPolyhedron
The mathematics implemented here is described in full detail in a paper by Joachim Wuttke, entitled \"Form factor (Fourier shape transform) of polygon and polyhedron.\" 
";

%feature("docstring")  IFormFactorPolyhedron::~IFormFactorPolyhedron "IFormFactorPolyhedron::~IFormFactorPolyhedron() override
IFormFactorPolyhedron::~IFormFactorPolyhedron";

%feature("docstring")  IFormFactorPolyhedron::bottomZ "double IFormFactorPolyhedron::bottomZ(const IRotation *rotation) const override
IFormFactorPolyhedron::bottomZ";

%feature("docstring")  IFormFactorPolyhedron::topZ "double IFormFactorPolyhedron::topZ(const IRotation *rotation) const override
IFormFactorPolyhedron::topZ";

%feature("docstring")  IFormFactorPolyhedron::formfactor_at_bottom "complex_t IFormFactorPolyhedron::formfactor_at_bottom(C3 q) const override
IFormFactorPolyhedron::formfactor_at_bottom";

%feature("docstring")  IFormFactorPolyhedron::volume "double IFormFactorPolyhedron::volume() const override
IFormFactorPolyhedron::volume";

%feature("docstring")  IFormFactorPolyhedron::radialExtension "double IFormFactorPolyhedron::radialExtension() const override
IFormFactorPolyhedron::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  IFormFactorPolyhedron::assert_platonic "void IFormFactorPolyhedron::assert_platonic() const
IFormFactorPolyhedron::assert_platonic
Assertions for Platonic solid. 
";


// File: classIFormFactorPrism.xml
%feature("docstring") IFormFactorPrism "

A prism with a polygonal base, for form factor computation.

C++ includes: IFormFactorPrism.h
";

%feature("docstring")  IFormFactorPrism::IFormFactorPrism "IFormFactorPrism::IFormFactorPrism(const std::vector< double > &PValues)
IFormFactorPrism::IFormFactorPrism";

%feature("docstring")  IFormFactorPrism::~IFormFactorPrism "IFormFactorPrism::~IFormFactorPrism() override
IFormFactorPrism::~IFormFactorPrism";

%feature("docstring")  IFormFactorPrism::bottomZ "double IFormFactorPrism::bottomZ(const IRotation *rotation) const override
IFormFactorPrism::bottomZ";

%feature("docstring")  IFormFactorPrism::topZ "double IFormFactorPrism::topZ(const IRotation *rotation) const override
IFormFactorPrism::topZ";

%feature("docstring")  IFormFactorPrism::formfactor_at_bottom "complex_t IFormFactorPrism::formfactor_at_bottom(C3 q) const override
IFormFactorPrism::formfactor_at_bottom
Returns the form factor F(q) of this polyhedron, respecting the offset height/2. 
";

%feature("docstring")  IFormFactorPrism::volume "double IFormFactorPrism::volume() const override
IFormFactorPrism::volume
Returns the volume of this prism. 
";

%feature("docstring")  IFormFactorPrism::radialExtension "double IFormFactorPrism::radialExtension() const override
IFormFactorPrism::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  IFormFactorPrism::height "virtual double IFormFactorPrism::height() const =0
IFormFactorPrism::height";


// File: classIInterference.xml
%feature("docstring") IInterference "

Abstract base class of interference functions.

C++ includes: IInterference.h
";

%feature("docstring")  IInterference::clone "IInterference * IInterference::clone() const override=0
IInterference::clone";

%feature("docstring")  IInterference::structureFactor "double IInterference::structureFactor(R3 q, double outer_iff=1.0) const
IInterference::structureFactor
The interference function for a given wavevector transfer. 
";

%feature("docstring")  IInterference::setPositionVariance "void IInterference::setPositionVariance(double var)
IInterference::setPositionVariance
Sets the variance of the position for the calculation of the DW factor It is defined as the variance in each relevant dimension 
";

%feature("docstring")  IInterference::positionVariance "double IInterference::positionVariance() const
IInterference::positionVariance
Returns the position variance. 
";

%feature("docstring")  IInterference::particleDensity "virtual double IInterference::particleDensity() const
IInterference::particleDensity
If defined by this interference function's parameters, returns the particle density (per area). Otherwise, returns zero or a user-defined value 
";

%feature("docstring")  IInterference::supportsMultilayer "virtual bool IInterference::supportsMultilayer() const
IInterference::supportsMultilayer
Indicates if this interference function can be used with a sample (DWBA mode) 
";

%feature("docstring")  IInterference::DWfactor "double IInterference::DWfactor(R3 q) const
IInterference::DWfactor
structureFactors the Debye-Waller factor for a given wavevector transfer 
";


// File: classInterference1DLattice.xml
%feature("docstring") Interference1DLattice "

Interference function of a 1D lattice.

C++ includes: Interference1DLattice.h
";

%feature("docstring")  Interference1DLattice::Interference1DLattice "Interference1DLattice::Interference1DLattice(double length, double xi)
Interference1DLattice::Interference1DLattice
Constructor of interference function of one-dimensional lattice.

Parameters:
-----------

length: 
lattice constant in nanometers

xi: 
rotation of lattice with respect to x-axis in radians 
";

%feature("docstring")  Interference1DLattice::~Interference1DLattice "Interference1DLattice::~Interference1DLattice() override
Interference1DLattice::~Interference1DLattice";

%feature("docstring")  Interference1DLattice::clone "Interference1DLattice * Interference1DLattice::clone() const override
Interference1DLattice::clone";

%feature("docstring")  Interference1DLattice::className "std::string Interference1DLattice::className() const final
Interference1DLattice::className";

%feature("docstring")  Interference1DLattice::parDefs "std::vector< ParaMeta > Interference1DLattice::parDefs() const final
Interference1DLattice::parDefs";

%feature("docstring")  Interference1DLattice::setDecayFunction "void Interference1DLattice::setDecayFunction(const IProfile1D &decay)
Interference1DLattice::setDecayFunction
Sets one-dimensional decay function.

Parameters:
-----------

decay: 
one-dimensional decay function in reciprocal space 
";

%feature("docstring")  Interference1DLattice::length "double Interference1DLattice::length() const
Interference1DLattice::length";

%feature("docstring")  Interference1DLattice::xi "double Interference1DLattice::xi() const
Interference1DLattice::xi";

%feature("docstring")  Interference1DLattice::nodeChildren "std::vector< const INode * > Interference1DLattice::nodeChildren() const override
Interference1DLattice::nodeChildren";


// File: classInterference2DLattice.xml
%feature("docstring") Interference2DLattice "

Interference function of a 2D lattice.

C++ includes: Interference2DLattice.h
";

%feature("docstring")  Interference2DLattice::Interference2DLattice "Interference2DLattice::Interference2DLattice(const Lattice2D &lattice)
Interference2DLattice::Interference2DLattice";

%feature("docstring")  Interference2DLattice::~Interference2DLattice "Interference2DLattice::~Interference2DLattice() override
Interference2DLattice::~Interference2DLattice";

%feature("docstring")  Interference2DLattice::clone "Interference2DLattice * Interference2DLattice::clone() const override
Interference2DLattice::clone";

%feature("docstring")  Interference2DLattice::className "std::string Interference2DLattice::className() const final
Interference2DLattice::className";

%feature("docstring")  Interference2DLattice::setDecayFunction "void Interference2DLattice::setDecayFunction(const IProfile2D &decay)
Interference2DLattice::setDecayFunction
Sets two-dimensional decay function.

Parameters:
-----------

decay: 
two-dimensional decay function in reciprocal space 
";

%feature("docstring")  Interference2DLattice::setIntegrationOverXi "void Interference2DLattice::setIntegrationOverXi(bool integrate_xi)
Interference2DLattice::setIntegrationOverXi";

%feature("docstring")  Interference2DLattice::integrationOverXi "bool Interference2DLattice::integrationOverXi() const
Interference2DLattice::integrationOverXi";

%feature("docstring")  Interference2DLattice::lattice "const Lattice2D & Interference2DLattice::lattice() const
Interference2DLattice::lattice";

%feature("docstring")  Interference2DLattice::particleDensity "double Interference2DLattice::particleDensity() const override
Interference2DLattice::particleDensity
Returns the particle density associated with this 2d lattice. 
";

%feature("docstring")  Interference2DLattice::nodeChildren "std::vector< const INode * > Interference2DLattice::nodeChildren() const override
Interference2DLattice::nodeChildren";


// File: classInterference2DParaCrystal.xml
%feature("docstring") Interference2DParaCrystal "

Interference function of a 2D paracrystal.

C++ includes: Interference2DParaCrystal.h
";

%feature("docstring")  Interference2DParaCrystal::Interference2DParaCrystal "Interference2DParaCrystal::Interference2DParaCrystal(const Lattice2D &lattice, double damping_length, double domain_size_1, double domain_size_2)
Interference2DParaCrystal::Interference2DParaCrystal";

%feature("docstring")  Interference2DParaCrystal::~Interference2DParaCrystal "Interference2DParaCrystal::~Interference2DParaCrystal() override
Interference2DParaCrystal::~Interference2DParaCrystal";

%feature("docstring")  Interference2DParaCrystal::clone "Interference2DParaCrystal * Interference2DParaCrystal::clone() const override
Interference2DParaCrystal::clone";

%feature("docstring")  Interference2DParaCrystal::className "std::string Interference2DParaCrystal::className() const final
Interference2DParaCrystal::className";

%feature("docstring")  Interference2DParaCrystal::parDefs "std::vector< ParaMeta > Interference2DParaCrystal::parDefs() const final
Interference2DParaCrystal::parDefs";

%feature("docstring")  Interference2DParaCrystal::setDomainSizes "void Interference2DParaCrystal::setDomainSizes(double size_1, double size_2)
Interference2DParaCrystal::setDomainSizes
Sets the sizes of coherence domains.

Parameters:
-----------

size_1: 
coherence domain size along the first basis vector in nanometers

size_2: 
coherence domain size along the second basis vector in nanometers 
";

%feature("docstring")  Interference2DParaCrystal::setProbabilityDistributions "void Interference2DParaCrystal::setProbabilityDistributions(const IProfile2D &pdf_1, const IProfile2D &pdf_2)
Interference2DParaCrystal::setProbabilityDistributions
Sets the probability distributions (Fourier transformed) for the two lattice directions.

Parameters:
-----------

pdf_1: 
probability distribution in first lattice direction

pdf_2: 
probability distribution in second lattice direction 
";

%feature("docstring")  Interference2DParaCrystal::setDampingLength "void Interference2DParaCrystal::setDampingLength(double damping_length)
Interference2DParaCrystal::setDampingLength
Sets the damping length.

Parameters:
-----------

damping_length: 
the damping (coherence) length of the paracrystal in nanometers 
";

%feature("docstring")  Interference2DParaCrystal::domainSizes "std::vector< double > Interference2DParaCrystal::domainSizes() const
Interference2DParaCrystal::domainSizes";

%feature("docstring")  Interference2DParaCrystal::setIntegrationOverXi "void Interference2DParaCrystal::setIntegrationOverXi(bool integrate_xi)
Interference2DParaCrystal::setIntegrationOverXi
Enables/disables averaging over the lattice rotation angle.

Parameters:
-----------

integrate_xi: 
integration flag 
";

%feature("docstring")  Interference2DParaCrystal::integrationOverXi "bool Interference2DParaCrystal::integrationOverXi() const
Interference2DParaCrystal::integrationOverXi";

%feature("docstring")  Interference2DParaCrystal::dampingLength "double Interference2DParaCrystal::dampingLength() const
Interference2DParaCrystal::dampingLength";

%feature("docstring")  Interference2DParaCrystal::lattice "const Lattice2D & Interference2DParaCrystal::lattice() const
Interference2DParaCrystal::lattice";

%feature("docstring")  Interference2DParaCrystal::particleDensity "double Interference2DParaCrystal::particleDensity() const override
Interference2DParaCrystal::particleDensity
If defined by this interference function's parameters, returns the particle density (per area). Otherwise, returns zero or a user-defined value 
";

%feature("docstring")  Interference2DParaCrystal::nodeChildren "std::vector< const INode * > Interference2DParaCrystal::nodeChildren() const override
Interference2DParaCrystal::nodeChildren";

%feature("docstring")  Interference2DParaCrystal::pdf1 "const IProfile2D * Interference2DParaCrystal::pdf1() const
Interference2DParaCrystal::pdf1";

%feature("docstring")  Interference2DParaCrystal::pdf2 "const IProfile2D * Interference2DParaCrystal::pdf2() const
Interference2DParaCrystal::pdf2";


// File: classInterference2DSuperLattice.xml
%feature("docstring") Interference2DSuperLattice "

Interference function of a 2D superlattice with a configurable interference function for each lattice site.

C++ includes: Interference2DSuperLattice.h
";

%feature("docstring")  Interference2DSuperLattice::Interference2DSuperLattice "Interference2DSuperLattice::Interference2DSuperLattice(const Lattice2D &lattice, unsigned size_1, unsigned size_2)
Interference2DSuperLattice::Interference2DSuperLattice";

%feature("docstring")  Interference2DSuperLattice::Interference2DSuperLattice "Interference2DSuperLattice::Interference2DSuperLattice(double length_1, double length_2, double alpha, double xi, unsigned size_1, unsigned size_2)
Interference2DSuperLattice::Interference2DSuperLattice
Constructor of two-dimensional interference function.

Parameters:
-----------

length_1: 
length of first lattice vector in nanometers

length_2: 
length of second lattice vector in nanometers

alpha: 
angle between lattice vectors in radians

xi: 
rotation of lattice with respect to x-axis (beam direction) in radians

size_1: 
correlation length in direction 1

size_2: 
correlation length in direction 2 
";

%feature("docstring")  Interference2DSuperLattice::~Interference2DSuperLattice "Interference2DSuperLattice::~Interference2DSuperLattice() override
Interference2DSuperLattice::~Interference2DSuperLattice";

%feature("docstring")  Interference2DSuperLattice::clone "Interference2DSuperLattice * Interference2DSuperLattice::clone() const override
Interference2DSuperLattice::clone";

%feature("docstring")  Interference2DSuperLattice::className "std::string Interference2DSuperLattice::className() const final
Interference2DSuperLattice::className";

%feature("docstring")  Interference2DSuperLattice::parDefs "std::vector< ParaMeta > Interference2DSuperLattice::parDefs() const final
Interference2DSuperLattice::parDefs";

%feature("docstring")  Interference2DSuperLattice::setSubstructureIFF "void Interference2DSuperLattice::setSubstructureIFF(const IInterference &sub_iff)
Interference2DSuperLattice::setSubstructureIFF";

%feature("docstring")  Interference2DSuperLattice::substructureIFF "const IInterference & Interference2DSuperLattice::substructureIFF() const
Interference2DSuperLattice::substructureIFF";

%feature("docstring")  Interference2DSuperLattice::structureFactor "double Interference2DSuperLattice::structureFactor(R3 q, double outer_iff=1.0) const override
Interference2DSuperLattice::structureFactor
The interference function for a given wavevector transfer. 
";

%feature("docstring")  Interference2DSuperLattice::domainSize1 "unsigned Interference2DSuperLattice::domainSize1() const
Interference2DSuperLattice::domainSize1";

%feature("docstring")  Interference2DSuperLattice::domainSize2 "unsigned Interference2DSuperLattice::domainSize2() const
Interference2DSuperLattice::domainSize2";

%feature("docstring")  Interference2DSuperLattice::setIntegrationOverXi "void Interference2DSuperLattice::setIntegrationOverXi(bool integrate_xi)
Interference2DSuperLattice::setIntegrationOverXi";

%feature("docstring")  Interference2DSuperLattice::integrationOverXi "bool Interference2DSuperLattice::integrationOverXi() const
Interference2DSuperLattice::integrationOverXi";

%feature("docstring")  Interference2DSuperLattice::lattice "const Lattice2D & Interference2DSuperLattice::lattice() const
Interference2DSuperLattice::lattice";

%feature("docstring")  Interference2DSuperLattice::nodeChildren "std::vector< const INode * > Interference2DSuperLattice::nodeChildren() const override
Interference2DSuperLattice::nodeChildren";


// File: classInterference3DLattice.xml
%feature("docstring") Interference3DLattice "

Interference function of a 3D lattice.

C++ includes: Interference3DLattice.h
";

%feature("docstring")  Interference3DLattice::Interference3DLattice "Interference3DLattice::Interference3DLattice(const Lattice3D &lattice)
Interference3DLattice::Interference3DLattice";

%feature("docstring")  Interference3DLattice::~Interference3DLattice "Interference3DLattice::~Interference3DLattice() override
Interference3DLattice::~Interference3DLattice";

%feature("docstring")  Interference3DLattice::clone "Interference3DLattice * Interference3DLattice::clone() const override
Interference3DLattice::clone";

%feature("docstring")  Interference3DLattice::className "std::string Interference3DLattice::className() const final
Interference3DLattice::className";

%feature("docstring")  Interference3DLattice::setPeakShape "void Interference3DLattice::setPeakShape(const IPeakShape &peak_shape)
Interference3DLattice::setPeakShape";

%feature("docstring")  Interference3DLattice::lattice "const Lattice3D & Interference3DLattice::lattice() const
Interference3DLattice::lattice";

%feature("docstring")  Interference3DLattice::supportsMultilayer "bool Interference3DLattice::supportsMultilayer() const override
Interference3DLattice::supportsMultilayer
Indicates if this interference function can be used with a sample (DWBA mode) 
";

%feature("docstring")  Interference3DLattice::nodeChildren "std::vector< const INode * > Interference3DLattice::nodeChildren() const override
Interference3DLattice::nodeChildren";


// File: classInterferenceFinite2DLattice.xml
%feature("docstring") InterferenceFinite2DLattice "

Interference function of a finite 2D lattice.

C++ includes: InterferenceFinite2DLattice.h
";

%feature("docstring")  InterferenceFinite2DLattice::InterferenceFinite2DLattice "InterferenceFinite2DLattice::InterferenceFinite2DLattice(const Lattice2D &lattice, unsigned N_1, unsigned N_2)
InterferenceFinite2DLattice::InterferenceFinite2DLattice
Constructor of two-dimensional finite lattice interference function.

Parameters:
-----------

lattice: 
object specifying a 2d lattice structure

N_1: 
number of lattice cells in the first lattice direction

N_2: 
number of lattice cells in the second lattice direction 
";

%feature("docstring")  InterferenceFinite2DLattice::~InterferenceFinite2DLattice "InterferenceFinite2DLattice::~InterferenceFinite2DLattice() override
InterferenceFinite2DLattice::~InterferenceFinite2DLattice";

%feature("docstring")  InterferenceFinite2DLattice::clone "InterferenceFinite2DLattice * InterferenceFinite2DLattice::clone() const override
InterferenceFinite2DLattice::clone";

%feature("docstring")  InterferenceFinite2DLattice::className "std::string InterferenceFinite2DLattice::className() const final
InterferenceFinite2DLattice::className";

%feature("docstring")  InterferenceFinite2DLattice::numberUnitCells1 "unsigned InterferenceFinite2DLattice::numberUnitCells1() const
InterferenceFinite2DLattice::numberUnitCells1";

%feature("docstring")  InterferenceFinite2DLattice::numberUnitCells2 "unsigned InterferenceFinite2DLattice::numberUnitCells2() const
InterferenceFinite2DLattice::numberUnitCells2";

%feature("docstring")  InterferenceFinite2DLattice::setIntegrationOverXi "void InterferenceFinite2DLattice::setIntegrationOverXi(bool integrate_xi)
InterferenceFinite2DLattice::setIntegrationOverXi";

%feature("docstring")  InterferenceFinite2DLattice::integrationOverXi "bool InterferenceFinite2DLattice::integrationOverXi() const
InterferenceFinite2DLattice::integrationOverXi";

%feature("docstring")  InterferenceFinite2DLattice::lattice "const Lattice2D & InterferenceFinite2DLattice::lattice() const
InterferenceFinite2DLattice::lattice";

%feature("docstring")  InterferenceFinite2DLattice::particleDensity "double InterferenceFinite2DLattice::particleDensity() const override
InterferenceFinite2DLattice::particleDensity
Returns the particle density associated with this 2d lattice. 
";

%feature("docstring")  InterferenceFinite2DLattice::nodeChildren "std::vector< const INode * > InterferenceFinite2DLattice::nodeChildren() const override
InterferenceFinite2DLattice::nodeChildren";


// File: classInterferenceFinite3DLattice.xml
%feature("docstring") InterferenceFinite3DLattice "

Interference function of a finite 3D lattice.

C++ includes: InterferenceFinite3DLattice.h
";

%feature("docstring")  InterferenceFinite3DLattice::InterferenceFinite3DLattice "InterferenceFinite3DLattice::InterferenceFinite3DLattice(const Lattice3D &lattice, unsigned N_1, unsigned N_2, unsigned N_3)
InterferenceFinite3DLattice::InterferenceFinite3DLattice";

%feature("docstring")  InterferenceFinite3DLattice::~InterferenceFinite3DLattice "InterferenceFinite3DLattice::~InterferenceFinite3DLattice() override
InterferenceFinite3DLattice::~InterferenceFinite3DLattice";

%feature("docstring")  InterferenceFinite3DLattice::clone "InterferenceFinite3DLattice * InterferenceFinite3DLattice::clone() const override
InterferenceFinite3DLattice::clone";

%feature("docstring")  InterferenceFinite3DLattice::className "std::string InterferenceFinite3DLattice::className() const final
InterferenceFinite3DLattice::className";

%feature("docstring")  InterferenceFinite3DLattice::numberUnitCells1 "unsigned InterferenceFinite3DLattice::numberUnitCells1() const
InterferenceFinite3DLattice::numberUnitCells1";

%feature("docstring")  InterferenceFinite3DLattice::numberUnitCells2 "unsigned InterferenceFinite3DLattice::numberUnitCells2() const
InterferenceFinite3DLattice::numberUnitCells2";

%feature("docstring")  InterferenceFinite3DLattice::numberUnitCells3 "unsigned InterferenceFinite3DLattice::numberUnitCells3() const
InterferenceFinite3DLattice::numberUnitCells3";

%feature("docstring")  InterferenceFinite3DLattice::lattice "const Lattice3D & InterferenceFinite3DLattice::lattice() const
InterferenceFinite3DLattice::lattice";

%feature("docstring")  InterferenceFinite3DLattice::supportsMultilayer "bool InterferenceFinite3DLattice::supportsMultilayer() const override
InterferenceFinite3DLattice::supportsMultilayer
Indicates if this interference function can be used with a sample (DWBA mode) 
";

%feature("docstring")  InterferenceFinite3DLattice::nodeChildren "std::vector< const INode * > InterferenceFinite3DLattice::nodeChildren() const override
InterferenceFinite3DLattice::nodeChildren";


// File: classInterferenceHardDisk.xml
%feature("docstring") InterferenceHardDisk "

Percus-Yevick hard disk interference function.

M.S. Ripoll & C.F. Tejero (1995) Approximate analytical expression for the direct correlation function of hard discs within the Percus-Yevick equation, Molecular Physics, 85:2, 423-428, DOI: 10.1080/00268979500101211

C++ includes: InterferenceHardDisk.h
";

%feature("docstring")  InterferenceHardDisk::InterferenceHardDisk "InterferenceHardDisk::InterferenceHardDisk(double radius, double density, double position_var=0)
InterferenceHardDisk::InterferenceHardDisk";

%feature("docstring")  InterferenceHardDisk::~InterferenceHardDisk "InterferenceHardDisk::~InterferenceHardDisk() override=default
InterferenceHardDisk::~InterferenceHardDisk";

%feature("docstring")  InterferenceHardDisk::parDefs "std::vector< ParaMeta > InterferenceHardDisk::parDefs() const final
InterferenceHardDisk::parDefs";

%feature("docstring")  InterferenceHardDisk::clone "InterferenceHardDisk * InterferenceHardDisk::clone() const override
InterferenceHardDisk::clone";

%feature("docstring")  InterferenceHardDisk::className "std::string InterferenceHardDisk::className() const final
InterferenceHardDisk::className";

%feature("docstring")  InterferenceHardDisk::particleDensity "double InterferenceHardDisk::particleDensity() const override
InterferenceHardDisk::particleDensity
If defined by this interference function's parameters, returns the particle density (per area). Otherwise, returns zero or a user-defined value 
";

%feature("docstring")  InterferenceHardDisk::radius "double InterferenceHardDisk::radius() const
InterferenceHardDisk::radius";

%feature("docstring")  InterferenceHardDisk::density "double InterferenceHardDisk::density() const
InterferenceHardDisk::density";


// File: classInterferenceNone.xml
%feature("docstring") InterferenceNone "

Default interference function (i.e. absence of any interference).

C++ includes: InterferenceNone.h
";

%feature("docstring")  InterferenceNone::InterferenceNone "InterferenceNone::InterferenceNone()
InterferenceNone::InterferenceNone";

%feature("docstring")  InterferenceNone::clone "InterferenceNone * InterferenceNone::clone() const override
InterferenceNone::clone";

%feature("docstring")  InterferenceNone::className "std::string InterferenceNone::className() const final
InterferenceNone::className";


// File: classInterferenceRadialParaCrystal.xml
%feature("docstring") InterferenceRadialParaCrystal "

Interference function of radial paracrystal.

C++ includes: InterferenceRadialParaCrystal.h
";

%feature("docstring")  InterferenceRadialParaCrystal::InterferenceRadialParaCrystal "InterferenceRadialParaCrystal::InterferenceRadialParaCrystal(double peak_distance, double damping_length)
InterferenceRadialParaCrystal::InterferenceRadialParaCrystal
Constructor of interference function of radial paracrystal.

Parameters:
-----------

peak_distance: 
average distance to the next neighbor in nanometers

damping_length: 
the damping (coherence) length of the paracrystal in nanometers 
";

%feature("docstring")  InterferenceRadialParaCrystal::clone "InterferenceRadialParaCrystal * InterferenceRadialParaCrystal::clone() const override
InterferenceRadialParaCrystal::clone";

%feature("docstring")  InterferenceRadialParaCrystal::className "std::string InterferenceRadialParaCrystal::className() const final
InterferenceRadialParaCrystal::className";

%feature("docstring")  InterferenceRadialParaCrystal::parDefs "std::vector< ParaMeta > InterferenceRadialParaCrystal::parDefs() const final
InterferenceRadialParaCrystal::parDefs";

%feature("docstring")  InterferenceRadialParaCrystal::setKappa "void InterferenceRadialParaCrystal::setKappa(double kappa)
InterferenceRadialParaCrystal::setKappa
Sets size spacing coupling parameter of the Size Spacing Correlation Approximation. 
";

%feature("docstring")  InterferenceRadialParaCrystal::kappa "double InterferenceRadialParaCrystal::kappa() const
InterferenceRadialParaCrystal::kappa";

%feature("docstring")  InterferenceRadialParaCrystal::setDomainSize "void InterferenceRadialParaCrystal::setDomainSize(double size)
InterferenceRadialParaCrystal::setDomainSize
Sets domain size (finite size corrections).

Parameters:
-----------

size: 
size of coherence domain along the lattice main axis in nanometers 
";

%feature("docstring")  InterferenceRadialParaCrystal::domainSize "double InterferenceRadialParaCrystal::domainSize() const
InterferenceRadialParaCrystal::domainSize";

%feature("docstring")  InterferenceRadialParaCrystal::FTPDF "complex_t InterferenceRadialParaCrystal::FTPDF(double qpar) const
InterferenceRadialParaCrystal::FTPDF";

%feature("docstring")  InterferenceRadialParaCrystal::setProbabilityDistribution "void InterferenceRadialParaCrystal::setProbabilityDistribution(const IProfile1D &pdf)
InterferenceRadialParaCrystal::setProbabilityDistribution
Sets one-dimensional probability distribution.

Parameters:
-----------

pdf: 
probability distribution (Fourier transform of probability density) 
";

%feature("docstring")  InterferenceRadialParaCrystal::peakDistance "double InterferenceRadialParaCrystal::peakDistance() const
InterferenceRadialParaCrystal::peakDistance";

%feature("docstring")  InterferenceRadialParaCrystal::dampingLength "double InterferenceRadialParaCrystal::dampingLength() const
InterferenceRadialParaCrystal::dampingLength";

%feature("docstring")  InterferenceRadialParaCrystal::nodeChildren "std::vector< const INode * > InterferenceRadialParaCrystal::nodeChildren() const override
InterferenceRadialParaCrystal::nodeChildren";

%feature("docstring")  InterferenceRadialParaCrystal::randomSample "double InterferenceRadialParaCrystal::randomSample() const
InterferenceRadialParaCrystal::randomSample";


// File: classInterferenceTwin.xml
%feature("docstring") InterferenceTwin "

Interference function for two particles at a mean distance and given standard deviation from each other in a given direction. TODO: RENAME (has nothing to do with crystallographic twin)

C++ includes: InterferenceTwin.h
";

%feature("docstring")  InterferenceTwin::InterferenceTwin "InterferenceTwin::InterferenceTwin(const R3 &direction, double mean_distance, double std_dev)
InterferenceTwin::InterferenceTwin";

%feature("docstring")  InterferenceTwin::clone "InterferenceTwin * InterferenceTwin::clone() const override
InterferenceTwin::clone";

%feature("docstring")  InterferenceTwin::className "std::string InterferenceTwin::className() const final
InterferenceTwin::className";

%feature("docstring")  InterferenceTwin::parDefs "std::vector< ParaMeta > InterferenceTwin::parDefs() const final
InterferenceTwin::parDefs";

%feature("docstring")  InterferenceTwin::direction "R3 InterferenceTwin::direction() const
InterferenceTwin::direction";

%feature("docstring")  InterferenceTwin::meanDistance "double InterferenceTwin::meanDistance() const
InterferenceTwin::meanDistance";

%feature("docstring")  InterferenceTwin::stdDev "double InterferenceTwin::stdDev() const
InterferenceTwin::stdDev";


// File: classIParticle.xml
%feature("docstring") IParticle "

Abstract base class for  Particle,  ParticleComposition,  ParticleCoreShell,  MesoCrystal. Provides position/rotation and form factor. Abundance is inherited from  IParticle.

C++ includes: IParticle.h
";

%feature("docstring")  IParticle::~IParticle "IParticle::~IParticle() override
IParticle::~IParticle";

%feature("docstring")  IParticle::clone "IParticle * IParticle::clone() const override=0
IParticle::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  IParticle::nodeChildren "std::vector< const INode * > IParticle::nodeChildren() const override
IParticle::nodeChildren";

%feature("docstring")  IParticle::abundance "double IParticle::abundance() const
IParticle::abundance";

%feature("docstring")  IParticle::setAbundance "void IParticle::setAbundance(double abundance)
IParticle::setAbundance
Sets particle abundance.

Parameters:
-----------

abundance: 
proportion of this type of particles normalized to the total number of particles in the layout. 
";

%feature("docstring")  IParticle::particlePosition "R3 IParticle::particlePosition() const
IParticle::particlePosition
Returns particle position. 
";

%feature("docstring")  IParticle::setParticlePosition "void IParticle::setParticlePosition(R3 position)
IParticle::setParticlePosition
Sets relative position of the particle's reference point in the coordinate system of parent.

Parameters:
-----------

position: 
relative position vector (components are in nanometers) 
";

%feature("docstring")  IParticle::setParticlePosition "void IParticle::setParticlePosition(double x, double y, double z)
IParticle::setParticlePosition
Sets relative position of the particle's reference point in the coordinate system of parent.

Parameters:
-----------

x: 
x-coordinate in nanometers

y: 
y-coordinate in nanometers

z: 
z-coordinate in nanometers 
";

%feature("docstring")  IParticle::translate "IParticle * IParticle::translate(R3 translation)
IParticle::translate
Translates the particle, and returns this. 
";

%feature("docstring")  IParticle::rotation "const IRotation * IParticle::rotation() const
IParticle::rotation
Returns rotation object. 
";

%feature("docstring")  IParticle::setRotation "void IParticle::setRotation(const IRotation &rotation)
IParticle::setRotation
Sets transformation. 
";

%feature("docstring")  IParticle::rotate "IParticle * IParticle::rotate(const IRotation &rotation)
IParticle::rotate
Rotates the particle, and returns this. 
";

%feature("docstring")  IParticle::decompose "std::vector< std::unique_ptr< IParticle > > IParticle::decompose() const
IParticle::decompose
Decompose in constituent  IParticle objects. 
";

%feature("docstring")  IParticle::validate "std::string IParticle::validate() const override=0
IParticle::validate";


// File: classIPeakShape.xml
%feature("docstring") IPeakShape "

Abstract base class class that defines the peak shape of a Bragg peak.

C++ includes: IPeakShape.h
";

%feature("docstring")  IPeakShape::IPeakShape "IPeakShape::IPeakShape()=default
IPeakShape::IPeakShape";

%feature("docstring")  IPeakShape::IPeakShape "IPeakShape::IPeakShape(const std::vector< double > &PValues)
IPeakShape::IPeakShape";

%feature("docstring")  IPeakShape::~IPeakShape "IPeakShape::~IPeakShape() override
IPeakShape::~IPeakShape";

%feature("docstring")  IPeakShape::clone "IPeakShape * IPeakShape::clone() const override=0
IPeakShape::clone";

%feature("docstring")  IPeakShape::peakDistribution "virtual double IPeakShape::peakDistribution(R3 q, R3 q_lattice_point) const =0
IPeakShape::peakDistribution
Peak shape at q from a reciprocal lattice point at q_lattice_point. 
";

%feature("docstring")  IPeakShape::angularDisorder "virtual bool IPeakShape::angularDisorder() const
IPeakShape::angularDisorder
Indicates if the peak shape encodes angular disorder, in which case all peaks in a spherical shell are needed 
";


// File: classIProfile1D.xml
%feature("docstring") IProfile1D "

Interface for a one-dimensional distribution, with normalization adjusted so that the Fourier transform standardizedFT(q) is a decay function that starts at standardizedFT(0)=1.

C++ includes: Profiles1D.h
";

%feature("docstring")  IProfile1D::IProfile1D "IProfile1D::IProfile1D(const std::vector< double > &PValues)
IProfile1D::IProfile1D";

%feature("docstring")  IProfile1D::clone "IProfile1D * IProfile1D::clone() const override=0
IProfile1D::clone";

%feature("docstring")  IProfile1D::parDefs "std::vector< ParaMeta > IProfile1D::parDefs() const override
IProfile1D::parDefs";

%feature("docstring")  IProfile1D::standardizedFT "virtual double IProfile1D::standardizedFT(double q) const =0
IProfile1D::standardizedFT
Returns Fourier transform of the normalized distribution; is a decay function starting at standardizedFT(0)=1. 
";

%feature("docstring")  IProfile1D::decayFT "virtual double IProfile1D::decayFT(double q) const =0
IProfile1D::decayFT
Returns Fourier transform of the distribution scaled as decay function f(x)/f(0). 
";

%feature("docstring")  IProfile1D::omega "double IProfile1D::omega() const
IProfile1D::omega";

%feature("docstring")  IProfile1D::decayLength "double IProfile1D::decayLength() const
IProfile1D::decayLength";

%feature("docstring")  IProfile1D::qSecondDerivative "virtual double IProfile1D::qSecondDerivative() const =0
IProfile1D::qSecondDerivative
Returns the negative of the second order derivative in q space around q=0. 
";

%feature("docstring")  IProfile1D::createSampler "virtual std::unique_ptr< IDistribution1DSampler > IProfile1D::createSampler() const =0
IProfile1D::createSampler";

%feature("docstring")  IProfile1D::pythonConstructor "std::string IProfile1D::pythonConstructor() const
IProfile1D::pythonConstructor
Creates the Python constructor of this class (or derived classes) 
";

%feature("docstring")  IProfile1D::validate "std::string IProfile1D::validate() const override
IProfile1D::validate";


// File: classIProfile2D.xml
%feature("docstring") IProfile2D "

Interface for two-dimensional distributions in Fourier space.

C++ includes: Profiles2D.h
";

%feature("docstring")  IProfile2D::IProfile2D "IProfile2D::IProfile2D(const std::vector< double > &PValues)
IProfile2D::IProfile2D";

%feature("docstring")  IProfile2D::clone "IProfile2D * IProfile2D::clone() const override=0
IProfile2D::clone";

%feature("docstring")  IProfile2D::parDefs "std::vector< ParaMeta > IProfile2D::parDefs() const override
IProfile2D::parDefs";

%feature("docstring")  IProfile2D::omegaX "double IProfile2D::omegaX() const
IProfile2D::omegaX";

%feature("docstring")  IProfile2D::omegaY "double IProfile2D::omegaY() const
IProfile2D::omegaY";

%feature("docstring")  IProfile2D::decayLengthX "double IProfile2D::decayLengthX() const
IProfile2D::decayLengthX";

%feature("docstring")  IProfile2D::decayLengthY "double IProfile2D::decayLengthY() const
IProfile2D::decayLengthY";

%feature("docstring")  IProfile2D::gamma "double IProfile2D::gamma() const
IProfile2D::gamma";

%feature("docstring")  IProfile2D::delta "double IProfile2D::delta() const
IProfile2D::delta
Angle in direct space between X- and Y-axis of distribution. 
";

%feature("docstring")  IProfile2D::standardizedFT2D "virtual double IProfile2D::standardizedFT2D(double qx, double qy) const =0
IProfile2D::standardizedFT2D
Fourier transformed distribution for q in X,Y coordinates the original distribution (in real space) is assumed to be normalized: total integral is equal to 1 
";

%feature("docstring")  IProfile2D::decayFT2D "virtual double IProfile2D::decayFT2D(double qx, double qy) const =0
IProfile2D::decayFT2D";

%feature("docstring")  IProfile2D::createSampler "virtual std::unique_ptr< IDistribution2DSampler > IProfile2D::createSampler() const =0
IProfile2D::createSampler";

%feature("docstring")  IProfile2D::pythonConstructor "std::string IProfile2D::pythonConstructor() const
IProfile2D::pythonConstructor
Creates the Python constructor of this class (or derived classes) 
";

%feature("docstring")  IProfile2D::validate "std::string IProfile2D::validate() const override
IProfile2D::validate";


// File: classIProfileRectangularRipple.xml
%feature("docstring") IProfileRectangularRipple "

Base class for form factors with a rectangular ripple (bar) profile in the yz plane.

C++ includes: IProfileRipple.h
";

%feature("docstring")  IProfileRectangularRipple::IProfileRectangularRipple "IProfileRectangularRipple::IProfileRectangularRipple(const std::vector< double > &PValues)
IProfileRectangularRipple::IProfileRectangularRipple";


// File: classIProfileRipple.xml
%feature("docstring") IProfileRipple "

Base class for form factors with a cosine ripple profile in the yz plane.

C++ includes: IProfileRipple.h
";

%feature("docstring")  IProfileRipple::IProfileRipple "IProfileRipple::IProfileRipple(const std::vector< double > &PValues)
IProfileRipple::IProfileRipple";

%feature("docstring")  IProfileRipple::length "double IProfileRipple::length() const
IProfileRipple::length";

%feature("docstring")  IProfileRipple::height "double IProfileRipple::height() const
IProfileRipple::height";

%feature("docstring")  IProfileRipple::width "double IProfileRipple::width() const
IProfileRipple::width";

%feature("docstring")  IProfileRipple::radialExtension "double IProfileRipple::radialExtension() const override
IProfileRipple::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  IProfileRipple::formfactor_at_bottom "complex_t IProfileRipple::formfactor_at_bottom(C3 q) const override
IProfileRipple::formfactor_at_bottom";

%feature("docstring")  IProfileRipple::validate "std::string IProfileRipple::validate() const override
IProfileRipple::validate";


// File: classIRegistry.xml
%feature("docstring") IRegistry "

Templated object registry.

C++ includes: IRegistry.h
";

%feature("docstring")  IRegistry::getItem "const ValueType * IRegistry< ValueType >::getItem(const std::string &key) const
IRegistry::getItem";

%feature("docstring")  IRegistry::keys "std::vector< std::string > IRegistry< ValueType >::keys() const
IRegistry::keys";

%feature("docstring")  IRegistry::size "size_t IRegistry< ValueType >::size() const
IRegistry::size";


// File: classIRotation.xml
%feature("docstring") IRotation "

Abstract base class for rotations.

C++ includes: Rotations.h
";

%feature("docstring")  IRotation::IRotation "IRotation::IRotation(const std::vector< double > &PValues)
IRotation::IRotation";

%feature("docstring")  IRotation::clone "IRotation * IRotation::clone() const override=0
IRotation::clone";

%feature("docstring")  IRotation::createInverse "virtual IRotation * IRotation::createInverse() const =0
IRotation::createInverse
Returns a new  IRotation object that is the current object's inverse. 
";

%feature("docstring")  IRotation::rotMatrix "virtual RotMatrix IRotation::rotMatrix() const =0
IRotation::rotMatrix
Returns transformation. 
";

%feature("docstring")  IRotation::transformed "R3 IRotation::transformed(const R3 &v) const
IRotation::transformed";

%feature("docstring")  IRotation::isIdentity "bool IRotation::isIdentity() const
IRotation::isIdentity
Returns true if rotation matrix is identity matrix (no rotations) 
";

%feature("docstring")  IRotation::zInvariant "bool IRotation::zInvariant() const
IRotation::zInvariant";


// File: classISampleNode.xml
%feature("docstring") ISampleNode "

Abstract base class for sample components and properties related to scattering.

C++ includes: ISampleNode.h
";

%feature("docstring")  ISampleNode::ISampleNode "ISampleNode::ISampleNode()=default
ISampleNode::ISampleNode";

%feature("docstring")  ISampleNode::ISampleNode "ISampleNode::ISampleNode(const std::vector< double > &PValues)
ISampleNode::ISampleNode";

%feature("docstring")  ISampleNode::clone "ISampleNode * ISampleNode::clone() const override=0
ISampleNode::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  ISampleNode::material "virtual const Material * ISampleNode::material() const
ISampleNode::material
Returns nullptr, unless overwritten to return a specific material. 
";

%feature("docstring")  ISampleNode::containedMaterials "std::vector< const Material * > ISampleNode::containedMaterials() const
ISampleNode::containedMaterials
Returns set of unique materials contained in this  ISampleNode. 
";

%feature("docstring")  ISampleNode::isMagnetic "bool ISampleNode::isMagnetic() const
ISampleNode::isMagnetic
Returns true if there is any magnetic material in this  ISampleNode. 
";


// File: classISawtoothRipple.xml
%feature("docstring") ISawtoothRipple "

Base class for form factors with a triangular ripple profile in the yz plane.

C++ includes: IProfileRipple.h
";

%feature("docstring")  ISawtoothRipple::ISawtoothRipple "ISawtoothRipple::ISawtoothRipple(const std::vector< double > &PValues)
ISawtoothRipple::ISawtoothRipple";

%feature("docstring")  ISawtoothRipple::asymmetry "double ISawtoothRipple::asymmetry() const
ISawtoothRipple::asymmetry";


// File: classISelectionRule.xml
%feature("docstring") ISelectionRule "

Abstract base class for selection rules.

C++ includes: ISelectionRule.h
";

%feature("docstring")  ISelectionRule::~ISelectionRule "virtual ISelectionRule::~ISelectionRule()=default
ISelectionRule::~ISelectionRule";

%feature("docstring")  ISelectionRule::clone "virtual ISelectionRule * ISelectionRule::clone() const =0
ISelectionRule::clone";

%feature("docstring")  ISelectionRule::coordinateSelected "virtual bool ISelectionRule::coordinateSelected(const I3 &coordinate) const =0
ISelectionRule::coordinateSelected";


// File: classIShape3D.xml
%feature("docstring") IShape3D "

Abstract base class for different shapes.

In contrast to the form factors, these shapes only provide an interface for returning a set of vertices.

C++ includes: IShape3D.h
";

%feature("docstring")  IShape3D::IShape3D "IShape3D::IShape3D()=default
IShape3D::IShape3D";

%feature("docstring")  IShape3D::~IShape3D "virtual IShape3D::~IShape3D()=default
IShape3D::~IShape3D";

%feature("docstring")  IShape3D::vertices "std::vector< R3 > IShape3D::vertices() const
IShape3D::vertices
Retrieves a list of the vertices constituting this concrete shape. 
";


// File: classIsotropicGaussPeakShape.xml
%feature("docstring") IsotropicGaussPeakShape "

Class that implements an isotropic Gaussian peak shape of a Bragg peak.

C++ includes: IPeakShape.h
";

%feature("docstring")  IsotropicGaussPeakShape::IsotropicGaussPeakShape "IsotropicGaussPeakShape::IsotropicGaussPeakShape(double max_intensity, double domainsize)
IsotropicGaussPeakShape::IsotropicGaussPeakShape";

%feature("docstring")  IsotropicGaussPeakShape::~IsotropicGaussPeakShape "IsotropicGaussPeakShape::~IsotropicGaussPeakShape() override
IsotropicGaussPeakShape::~IsotropicGaussPeakShape";

%feature("docstring")  IsotropicGaussPeakShape::clone "IsotropicGaussPeakShape * IsotropicGaussPeakShape::clone() const override
IsotropicGaussPeakShape::clone";

%feature("docstring")  IsotropicGaussPeakShape::className "std::string IsotropicGaussPeakShape::className() const final
IsotropicGaussPeakShape::className";

%feature("docstring")  IsotropicGaussPeakShape::parDefs "std::vector< ParaMeta > IsotropicGaussPeakShape::parDefs() const final
IsotropicGaussPeakShape::parDefs";

%feature("docstring")  IsotropicGaussPeakShape::peakDistribution "double IsotropicGaussPeakShape::peakDistribution(R3 q, R3 q_lattice_point) const override
IsotropicGaussPeakShape::peakDistribution
Peak shape at q from a reciprocal lattice point at q_lattice_point. 
";


// File: classIsotropicLorentzPeakShape.xml
%feature("docstring") IsotropicLorentzPeakShape "

An isotropic Lorentzian peak shape of a Bragg peak.

C++ includes: IPeakShape.h
";

%feature("docstring")  IsotropicLorentzPeakShape::IsotropicLorentzPeakShape "IsotropicLorentzPeakShape::IsotropicLorentzPeakShape(double max_intensity, double domainsize)
IsotropicLorentzPeakShape::IsotropicLorentzPeakShape";

%feature("docstring")  IsotropicLorentzPeakShape::~IsotropicLorentzPeakShape "IsotropicLorentzPeakShape::~IsotropicLorentzPeakShape() override
IsotropicLorentzPeakShape::~IsotropicLorentzPeakShape";

%feature("docstring")  IsotropicLorentzPeakShape::clone "IsotropicLorentzPeakShape * IsotropicLorentzPeakShape::clone() const override
IsotropicLorentzPeakShape::clone";

%feature("docstring")  IsotropicLorentzPeakShape::className "std::string IsotropicLorentzPeakShape::className() const final
IsotropicLorentzPeakShape::className";

%feature("docstring")  IsotropicLorentzPeakShape::parDefs "std::vector< ParaMeta > IsotropicLorentzPeakShape::parDefs() const final
IsotropicLorentzPeakShape::parDefs";

%feature("docstring")  IsotropicLorentzPeakShape::peakDistribution "double IsotropicLorentzPeakShape::peakDistribution(R3 q, R3 q_lattice_point) const override
IsotropicLorentzPeakShape::peakDistribution
Peak shape at q from a reciprocal lattice point at q_lattice_point. 
";


// File: classLattice2D.xml
%feature("docstring") Lattice2D "

A two-dimensional Bravais lattice.

C++ includes: Lattice2D.h
";

%feature("docstring")  Lattice2D::Lattice2D "Lattice2D::Lattice2D(const std::vector< double > &PValues)
Lattice2D::Lattice2D";

%feature("docstring")  Lattice2D::Lattice2D "Lattice2D::Lattice2D(double xi)
Lattice2D::Lattice2D";

%feature("docstring")  Lattice2D::clone "Lattice2D * Lattice2D::clone() const override=0
Lattice2D::clone";

%feature("docstring")  Lattice2D::length1 "virtual double Lattice2D::length1() const =0
Lattice2D::length1";

%feature("docstring")  Lattice2D::length2 "virtual double Lattice2D::length2() const =0
Lattice2D::length2";

%feature("docstring")  Lattice2D::latticeAngle "virtual double Lattice2D::latticeAngle() const =0
Lattice2D::latticeAngle";

%feature("docstring")  Lattice2D::unitCellArea "virtual double Lattice2D::unitCellArea() const =0
Lattice2D::unitCellArea";

%feature("docstring")  Lattice2D::rotationAngle "double Lattice2D::rotationAngle() const
Lattice2D::rotationAngle";

%feature("docstring")  Lattice2D::reciprocalBases "Lattice2D::ReciprocalBases Lattice2D::reciprocalBases() const
Lattice2D::reciprocalBases";

%feature("docstring")  Lattice2D::setRotationEnabled "void Lattice2D::setRotationEnabled(bool enabled)
Lattice2D::setRotationEnabled";


// File: classLattice3D.xml
%feature("docstring") Lattice3D "

A Bravais lattice, characterized by three basis vectors, and optionally an  ISelectionRule.

C++ includes: Lattice3D.h
";

%feature("docstring")  Lattice3D::Lattice3D "Lattice3D::Lattice3D(R3 a, R3 b, R3 c)
Lattice3D::Lattice3D";

%feature("docstring")  Lattice3D::Lattice3D "Lattice3D::Lattice3D(const Lattice3D &lattice)
Lattice3D::Lattice3D";

%feature("docstring")  Lattice3D::~Lattice3D "Lattice3D::~Lattice3D() override
Lattice3D::~Lattice3D";

%feature("docstring")  Lattice3D::className "std::string Lattice3D::className() const final
Lattice3D::className";

%feature("docstring")  Lattice3D::rotated "Lattice3D Lattice3D::rotated(const RotMatrix &rotMatrix) const
Lattice3D::rotated
Creates rotated lattice. 
";

%feature("docstring")  Lattice3D::basisVectorA "R3 Lattice3D::basisVectorA() const
Lattice3D::basisVectorA
Returns basis vector a. 
";

%feature("docstring")  Lattice3D::basisVectorB "R3 Lattice3D::basisVectorB() const
Lattice3D::basisVectorB
Returns basis vector b. 
";

%feature("docstring")  Lattice3D::basisVectorC "R3 Lattice3D::basisVectorC() const
Lattice3D::basisVectorC
Returns basis vector c. 
";

%feature("docstring")  Lattice3D::getMillerDirection "R3 Lattice3D::getMillerDirection(double h, double k, double l) const
Lattice3D::getMillerDirection
Returns normalized direction corresponding to the given Miller indices.

Currently unused but may be useful for checks. 
";

%feature("docstring")  Lattice3D::unitCellVolume "double Lattice3D::unitCellVolume() const
Lattice3D::unitCellVolume
Returns the volume of the unit cell. 
";

%feature("docstring")  Lattice3D::reciprocalLatticeBasis "void Lattice3D::reciprocalLatticeBasis(R3 &ra, R3 &rb, R3 &rc) const
Lattice3D::reciprocalLatticeBasis
Returns the reciprocal basis vectors.

Currently only used in tests. 
";

%feature("docstring")  Lattice3D::nearestReciprocalLatticeVectorCoordinates "I3 Lattice3D::nearestReciprocalLatticeVectorCoordinates(R3 q) const
Lattice3D::nearestReciprocalLatticeVectorCoordinates
Returns the nearest reciprocal lattice point from a given vector. 
";

%feature("docstring")  Lattice3D::reciprocalLatticeVectorsWithinRadius "std::vector< R3 > Lattice3D::reciprocalLatticeVectorsWithinRadius(R3 q, double dq) const
Lattice3D::reciprocalLatticeVectorsWithinRadius
Returns a list of reciprocal lattice vectors within distance dq of a vector q. 
";

%feature("docstring")  Lattice3D::setSelectionRule "void Lattice3D::setSelectionRule(const ISelectionRule &selection_rule)
Lattice3D::setSelectionRule
Sets a selection rule for the reciprocal vectors. 
";


// File: classLayer.xml
%feature("docstring") Layer "

A layer in a  MultiLayer sample.

C++ includes: Layer.h
";

%feature("docstring")  Layer::Layer "Layer::Layer(Material material, double thickness=0)
Layer::Layer
Constructor of a layer with thickness and material

Parameters:
-----------

material: 
material the layer is made of

thickness: 
thickness of a layer in nanometers 
";

%feature("docstring")  Layer::~Layer "Layer::~Layer() override
Layer::~Layer";

%feature("docstring")  Layer::clone "Layer * Layer::clone() const override
Layer::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Layer::className "std::string Layer::className() const final
Layer::className";

%feature("docstring")  Layer::parDefs "std::vector< ParaMeta > Layer::parDefs() const final
Layer::parDefs";

%feature("docstring")  Layer::nodeChildren "std::vector< const INode * > Layer::nodeChildren() const override
Layer::nodeChildren";

%feature("docstring")  Layer::material "const Material * Layer::material() const override
Layer::material
Returns nullptr, unless overwritten to return a specific material. 
";

%feature("docstring")  Layer::thickness "double Layer::thickness() const
Layer::thickness";

%feature("docstring")  Layer::addLayout "void Layer::addLayout(const ParticleLayout &layout)
Layer::addLayout";

%feature("docstring")  Layer::numberOfLayouts "size_t Layer::numberOfLayouts() const
Layer::numberOfLayouts";

%feature("docstring")  Layer::layouts "std::vector< const ParticleLayout * > Layer::layouts() const
Layer::layouts";

%feature("docstring")  Layer::setNumberOfSlices "void Layer::setNumberOfSlices(unsigned int n_slices)
Layer::setNumberOfSlices";

%feature("docstring")  Layer::numberOfSlices "unsigned int Layer::numberOfSlices() const
Layer::numberOfSlices";

%feature("docstring")  Layer::validate "std::string Layer::validate() const override
Layer::validate";


// File: classLayerInterface.xml
%feature("docstring") LayerInterface "

Interface between two layers, possibly with roughness.

C++ includes: LayerInterface.h
";

%feature("docstring")  LayerInterface::~LayerInterface "LayerInterface::~LayerInterface() override
LayerInterface::~LayerInterface";

%feature("docstring")  LayerInterface::clone "LayerInterface * LayerInterface::clone() const override
LayerInterface::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  LayerInterface::className "std::string LayerInterface::className() const final
LayerInterface::className";

%feature("docstring")  LayerInterface::setRoughness "void LayerInterface::setRoughness(const LayerRoughness &roughness)
LayerInterface::setRoughness
Sets roughness of the interface. 
";

%feature("docstring")  LayerInterface::roughness "const LayerRoughness * LayerInterface::roughness() const
LayerInterface::roughness
Returns roughness of the interface. 
";

%feature("docstring")  LayerInterface::topLayer "const Layer * LayerInterface::topLayer() const
LayerInterface::topLayer";

%feature("docstring")  LayerInterface::bottomLayer "const Layer * LayerInterface::bottomLayer() const
LayerInterface::bottomLayer";

%feature("docstring")  LayerInterface::nodeChildren "std::vector< const INode * > LayerInterface::nodeChildren() const override
LayerInterface::nodeChildren";

%feature("docstring")  LayerInterface::validate "std::string LayerInterface::validate() const override
LayerInterface::validate";


// File: classLayerRoughness.xml
%feature("docstring") LayerRoughness "

A roughness of interface between two layers.

Based on the article \"X-ray reflection and transmission by rough surfaces\" by D. K. G. de Boer, Physical Review B 51, 5297 (1995)

C++ includes: LayerRoughness.h
";

%feature("docstring")  LayerRoughness::LayerRoughness "LayerRoughness::LayerRoughness(double sigma, double hurstParameter=0, double lateralCorrLength=0)
LayerRoughness::LayerRoughness
Constructor of layer roughness.

Parameters:
-----------

sigma: 
rms of the roughness in nanometers

hurstParameter: 
hurst parameter which describes how jagged the interface, dimensionless [0.0, 1.0], where 0.0 gives more spikes, 1.0 more smoothness

lateralCorrLength: 
lateral correlation length of the roughness in nanometers 
";

%feature("docstring")  LayerRoughness::LayerRoughness "LayerRoughness::LayerRoughness()
LayerRoughness::LayerRoughness";

%feature("docstring")  LayerRoughness::clone "LayerRoughness * LayerRoughness::clone() const override
LayerRoughness::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  LayerRoughness::className "std::string LayerRoughness::className() const final
LayerRoughness::className";

%feature("docstring")  LayerRoughness::parDefs "std::vector< ParaMeta > LayerRoughness::parDefs() const final
LayerRoughness::parDefs";

%feature("docstring")  LayerRoughness::spectralFunction "double LayerRoughness::spectralFunction(R3 kvec) const
LayerRoughness::spectralFunction
Returns power spectral density of the surface roughness.

Power spectral density of the surface roughness is a result of two-dimensional Fourier transform of the correlation function of the roughness profile.

Based on the article D.K.G. de Boer, Physical review B, Volume 51, Number 8, 15 February 1995 \"X-ray reflection and transmission by rough surfaces\" 
";

%feature("docstring")  LayerRoughness::corrFunction "double LayerRoughness::corrFunction(R3 k) const
LayerRoughness::corrFunction
Correlation function of the roughness profile. 
";

%feature("docstring")  LayerRoughness::setSigma "void LayerRoughness::setSigma(double sigma)
LayerRoughness::setSigma
Sets rms of roughness. 
";

%feature("docstring")  LayerRoughness::sigma "double LayerRoughness::sigma() const
LayerRoughness::sigma
Returns rms of roughness. 
";

%feature("docstring")  LayerRoughness::setHurstParameter "void LayerRoughness::setHurstParameter(double hurstParameter)
LayerRoughness::setHurstParameter
Sets hurst parameter. It describes how jagged the surface is. 
";

%feature("docstring")  LayerRoughness::hurst "double LayerRoughness::hurst() const
LayerRoughness::hurst
Returns hurst parameter. 
";

%feature("docstring")  LayerRoughness::setLatteralCorrLength "void LayerRoughness::setLatteralCorrLength(double lateralCorrLength)
LayerRoughness::setLatteralCorrLength
Sets lateral correlation length. 
";

%feature("docstring")  LayerRoughness::lateralCorrLength "double LayerRoughness::lateralCorrLength() const
LayerRoughness::lateralCorrLength
Returns lateral correlation length. 
";

%feature("docstring")  LayerRoughness::pythonConstructor "std::string LayerRoughness::pythonConstructor() const
LayerRoughness::pythonConstructor
Creates the Python constructor of this class. 
";


// File: classLongBoxGauss.xml
%feature("docstring") LongBoxGauss "

The form factor for a long rectangular box.

C++ includes: LongBoxGauss.h
";

%feature("docstring")  LongBoxGauss::LongBoxGauss "LongBoxGauss::LongBoxGauss(double length, double width, double height)
LongBoxGauss::LongBoxGauss";

%feature("docstring")  LongBoxGauss::LongBoxGauss "LongBoxGauss::LongBoxGauss(std::vector< double > P)
LongBoxGauss::LongBoxGauss";

%feature("docstring")  LongBoxGauss::clone "LongBoxGauss * LongBoxGauss::clone() const override
LongBoxGauss::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  LongBoxGauss::className "std::string LongBoxGauss::className() const final
LongBoxGauss::className";

%feature("docstring")  LongBoxGauss::parDefs "std::vector< ParaMeta > LongBoxGauss::parDefs() const final
LongBoxGauss::parDefs";

%feature("docstring")  LongBoxGauss::length "double LongBoxGauss::length() const
LongBoxGauss::length";

%feature("docstring")  LongBoxGauss::height "double LongBoxGauss::height() const
LongBoxGauss::height";

%feature("docstring")  LongBoxGauss::width "double LongBoxGauss::width() const
LongBoxGauss::width";

%feature("docstring")  LongBoxGauss::radialExtension "double LongBoxGauss::radialExtension() const override
LongBoxGauss::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  LongBoxGauss::formfactor_at_bottom "complex_t LongBoxGauss::formfactor_at_bottom(C3 q) const override
LongBoxGauss::formfactor_at_bottom";

%feature("docstring")  LongBoxGauss::validate "std::string LongBoxGauss::validate() const override
LongBoxGauss::validate";


// File: classLongBoxLorentz.xml
%feature("docstring") LongBoxLorentz "

The form factor for a long rectangular box.

C++ includes: LongBoxLorentz.h
";

%feature("docstring")  LongBoxLorentz::LongBoxLorentz "LongBoxLorentz::LongBoxLorentz(double length, double width, double height)
LongBoxLorentz::LongBoxLorentz";

%feature("docstring")  LongBoxLorentz::LongBoxLorentz "LongBoxLorentz::LongBoxLorentz(std::vector< double > P)
LongBoxLorentz::LongBoxLorentz";

%feature("docstring")  LongBoxLorentz::clone "LongBoxLorentz * LongBoxLorentz::clone() const override
LongBoxLorentz::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  LongBoxLorentz::className "std::string LongBoxLorentz::className() const final
LongBoxLorentz::className";

%feature("docstring")  LongBoxLorentz::parDefs "std::vector< ParaMeta > LongBoxLorentz::parDefs() const final
LongBoxLorentz::parDefs";

%feature("docstring")  LongBoxLorentz::length "double LongBoxLorentz::length() const
LongBoxLorentz::length";

%feature("docstring")  LongBoxLorentz::height "double LongBoxLorentz::height() const
LongBoxLorentz::height";

%feature("docstring")  LongBoxLorentz::width "double LongBoxLorentz::width() const
LongBoxLorentz::width";

%feature("docstring")  LongBoxLorentz::radialExtension "double LongBoxLorentz::radialExtension() const override
LongBoxLorentz::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  LongBoxLorentz::formfactor_at_bottom "complex_t LongBoxLorentz::formfactor_at_bottom(C3 q) const override
LongBoxLorentz::formfactor_at_bottom";

%feature("docstring")  LongBoxLorentz::validate "std::string LongBoxLorentz::validate() const override
LongBoxLorentz::validate";


// File: classLorentzFisherPeakShape.xml
%feature("docstring") LorentzFisherPeakShape "

A peak shape that is Lorentzian in the radial direction and uses the Mises-Fisher distribution in the angular direction.

C++ includes: IPeakShape.h
";

%feature("docstring")  LorentzFisherPeakShape::LorentzFisherPeakShape "LorentzFisherPeakShape::LorentzFisherPeakShape(double max_intensity, double radial_size, double kappa)
LorentzFisherPeakShape::LorentzFisherPeakShape";

%feature("docstring")  LorentzFisherPeakShape::~LorentzFisherPeakShape "LorentzFisherPeakShape::~LorentzFisherPeakShape() override
LorentzFisherPeakShape::~LorentzFisherPeakShape";

%feature("docstring")  LorentzFisherPeakShape::clone "LorentzFisherPeakShape * LorentzFisherPeakShape::clone() const override
LorentzFisherPeakShape::clone";

%feature("docstring")  LorentzFisherPeakShape::className "std::string LorentzFisherPeakShape::className() const final
LorentzFisherPeakShape::className";

%feature("docstring")  LorentzFisherPeakShape::parDefs "std::vector< ParaMeta > LorentzFisherPeakShape::parDefs() const final
LorentzFisherPeakShape::parDefs";

%feature("docstring")  LorentzFisherPeakShape::peakDistribution "double LorentzFisherPeakShape::peakDistribution(R3 q, R3 q_lattice_point) const override
LorentzFisherPeakShape::peakDistribution
Peak shape at q from a reciprocal lattice point at q_lattice_point. 
";

%feature("docstring")  LorentzFisherPeakShape::angularDisorder "bool LorentzFisherPeakShape::angularDisorder() const override
LorentzFisherPeakShape::angularDisorder
Indicates if the peak shape encodes angular disorder, in which case all peaks in a spherical shell are needed 
";


// File: classMagneticMaterialImpl.xml
%feature("docstring") MagneticMaterialImpl "

Basic implementation for magnetized material. Inherited by  RefractiveMaterialImpl and  MaterialBySLDImpl. Incorporates data and methods required to handle material magnetization.

C++ includes: MagneticMaterialImpl.h
";

%feature("docstring")  MagneticMaterialImpl::MagneticMaterialImpl "MagneticMaterialImpl::MagneticMaterialImpl(const std::string &name, R3 magnetization)
MagneticMaterialImpl::MagneticMaterialImpl
Constructs basic material with name and magnetization. 
";

%feature("docstring")  MagneticMaterialImpl::~MagneticMaterialImpl "MagneticMaterialImpl::~MagneticMaterialImpl() override=default
MagneticMaterialImpl::~MagneticMaterialImpl";

%feature("docstring")  MagneticMaterialImpl::clone "MagneticMaterialImpl * MagneticMaterialImpl::clone() const override=0
MagneticMaterialImpl::clone
Returns pointer to a copy of material. 
";

%feature("docstring")  MagneticMaterialImpl::inverted "MagneticMaterialImpl * MagneticMaterialImpl::inverted() const override
MagneticMaterialImpl::inverted
Constructs a material with inverted magnetization. 
";

%feature("docstring")  MagneticMaterialImpl::isScalarMaterial "bool MagneticMaterialImpl::isScalarMaterial() const override
MagneticMaterialImpl::isScalarMaterial
Indicates whether the interaction with the material is scalar. This means that different polarization states will be diffracted equally 
";

%feature("docstring")  MagneticMaterialImpl::isMagneticMaterial "bool MagneticMaterialImpl::isMagneticMaterial() const override
MagneticMaterialImpl::isMagneticMaterial";

%feature("docstring")  MagneticMaterialImpl::magnetization "R3 MagneticMaterialImpl::magnetization() const override
MagneticMaterialImpl::magnetization
Returns the magnetization (in A/m) 
";

%feature("docstring")  MagneticMaterialImpl::polarizedSubtrSLD "SpinMatrix MagneticMaterialImpl::polarizedSubtrSLD(const WavevectorInfo &wavevectors) const override
MagneticMaterialImpl::polarizedSubtrSLD
Returns (  $ \\\\pi/\\\\lambda^2 $ - sld) matrix with magnetization corrections. 
";

%feature("docstring")  MagneticMaterialImpl::rotatedMaterial "MagneticMaterialImpl * MagneticMaterialImpl::rotatedMaterial(const RotMatrix &transform) const override
MagneticMaterialImpl::rotatedMaterial";


// File: classMaterial.xml
%feature("docstring") Material "

A wrapper for underlying material implementation

C++ includes: Material.h
";

%feature("docstring")  Material::Material "Material::Material(std::unique_ptr< BaseMaterialImpl > &&material_impl)
Material::Material
Creates material with particular material implementation. 
";

%feature("docstring")  Material::Material "Material::Material(const Material &material)
Material::Material";

%feature("docstring")  Material::Material "Material::Material(Material &&material)=default
Material::Material";

%feature("docstring")  Material::inverted "Material Material::inverted() const
Material::inverted
Constructs a material with inverted magnetization. 
";

%feature("docstring")  Material::refractiveIndex "complex_t Material::refractiveIndex(double wavelength) const
Material::refractiveIndex
Returns refractive index. 
";

%feature("docstring")  Material::refractiveIndex2 "complex_t Material::refractiveIndex2(double wavelength) const
Material::refractiveIndex2
Returns squared refractive index. 
";

%feature("docstring")  Material::isScalarMaterial "bool Material::isScalarMaterial() const
Material::isScalarMaterial
Indicates whether the interaction with the material is scalar. This means that different polarization states will be diffracted equally 
";

%feature("docstring")  Material::isMagneticMaterial "bool Material::isMagneticMaterial() const
Material::isMagneticMaterial";

%feature("docstring")  Material::materialName "std::string Material::materialName() const
Material::materialName
Returns the name of material. 
";

%feature("docstring")  Material::typeID "MATERIAL_TYPES Material::typeID() const
Material::typeID
Returns the type of underlying material implementation. 
";

%feature("docstring")  Material::magnetization "R3 Material::magnetization() const
Material::magnetization
Get the magnetization (in A/m) 
";

%feature("docstring")  Material::materialData "complex_t Material::materialData() const
Material::materialData
Returns delta + i beta. 
";

%feature("docstring")  Material::isEmpty "bool Material::isEmpty() const
Material::isEmpty
Returns true if material underlying data is nullptr. 
";

%feature("docstring")  Material::isDefaultMaterial "bool Material::isDefaultMaterial() const
Material::isDefaultMaterial
Returns true if material has refractive index of (1.0, 0.0) and zero magnetization. 
";

%feature("docstring")  Material::scalarSubtrSLD "complex_t Material::scalarSubtrSLD(const WavevectorInfo &wavevectors) const
Material::scalarSubtrSLD
Returns (  $ \\\\pi/\\\\lambda^2 $ - sld), sld (in  $nm^{-2}$) being the scattering length density 
";

%feature("docstring")  Material::polarizedSubtrSLD "SpinMatrix Material::polarizedSubtrSLD(const WavevectorInfo &wavevectors) const
Material::polarizedSubtrSLD
Returns (  $ \\\\pi/\\\\lambda^2 $ - sld) matrix with magnetization corrections. 
";

%feature("docstring")  Material::rotatedMaterial "Material Material::rotatedMaterial(const RotMatrix &transform) const
Material::rotatedMaterial";


// File: classMaterialBySLDImpl.xml
%feature("docstring") MaterialBySLDImpl "

Material implementation based on wavelength-independent data (valid for a range of wavelengths)

C++ includes: MaterialBySLDImpl.h
";

%feature("docstring")  MaterialBySLDImpl::~MaterialBySLDImpl "MaterialBySLDImpl::~MaterialBySLDImpl() override=default
MaterialBySLDImpl::~MaterialBySLDImpl";

%feature("docstring")  MaterialBySLDImpl::clone "MaterialBySLDImpl * MaterialBySLDImpl::clone() const override
MaterialBySLDImpl::clone
Returns pointer to a copy of material. 
";

%feature("docstring")  MaterialBySLDImpl::refractiveIndex "complex_t MaterialBySLDImpl::refractiveIndex(double wavelength) const override
MaterialBySLDImpl::refractiveIndex
Returns refractive index. 
";

%feature("docstring")  MaterialBySLDImpl::refractiveIndex2 "complex_t MaterialBySLDImpl::refractiveIndex2(double wavelength) const override
MaterialBySLDImpl::refractiveIndex2
Returns squared refractive index. 
";

%feature("docstring")  MaterialBySLDImpl::materialData "complex_t MaterialBySLDImpl::materialData() const override
MaterialBySLDImpl::materialData
Returns underlying material data. 
";

%feature("docstring")  MaterialBySLDImpl::typeID "MATERIAL_TYPES MaterialBySLDImpl::typeID() const override
MaterialBySLDImpl::typeID
Returns type of material implementation. 
";

%feature("docstring")  MaterialBySLDImpl::scalarSubtrSLD "complex_t MaterialBySLDImpl::scalarSubtrSLD(double lambda0) const override
MaterialBySLDImpl::scalarSubtrSLD
Returns (  $ \\\\pi/\\\\lambda^2 $ - sld), sld (in  $nm^{-2}$) being the scattering length density 
";

%feature("docstring")  MaterialBySLDImpl::print "std::string MaterialBySLDImpl::print() const override
MaterialBySLDImpl::print
Prints object data. 
";


// File: classMesoCrystal.xml
%feature("docstring") MesoCrystal "

A particle with a crystalline inner structure, made of smaller particles, and an outer shape described by a particle form factor.

C++ includes: MesoCrystal.h
";

%feature("docstring")  MesoCrystal::MesoCrystal "MesoCrystal::MesoCrystal(const Crystal &crystal, const IFormFactor &formfactor)
MesoCrystal::MesoCrystal";

%feature("docstring")  MesoCrystal::~MesoCrystal "MesoCrystal::~MesoCrystal() override
MesoCrystal::~MesoCrystal";

%feature("docstring")  MesoCrystal::clone "MesoCrystal * MesoCrystal::clone() const override
MesoCrystal::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  MesoCrystal::className "std::string MesoCrystal::className() const final
MesoCrystal::className";

%feature("docstring")  MesoCrystal::nodeChildren "std::vector< const INode * > MesoCrystal::nodeChildren() const override
MesoCrystal::nodeChildren";

%feature("docstring")  MesoCrystal::outerShape "const IFormFactor * MesoCrystal::outerShape() const
MesoCrystal::outerShape";

%feature("docstring")  MesoCrystal::particleStructure "const Crystal & MesoCrystal::particleStructure() const
MesoCrystal::particleStructure";

%feature("docstring")  MesoCrystal::validate "std::string MesoCrystal::validate() const override
MesoCrystal::validate";


// File: classMisesFisherGaussPeakShape.xml
%feature("docstring") MisesFisherGaussPeakShape "

A peak shape that is Gaussian in the radial direction and a convolution of a Mises-Fisher distribution with a Mises distribution on the two-sphere.

C++ includes: IPeakShape.h
";

%feature("docstring")  MisesFisherGaussPeakShape::MisesFisherGaussPeakShape "MisesFisherGaussPeakShape::MisesFisherGaussPeakShape(double max_intensity, double radial_size, R3 zenith, double kappa_1, double kappa_2)
MisesFisherGaussPeakShape::MisesFisherGaussPeakShape";

%feature("docstring")  MisesFisherGaussPeakShape::~MisesFisherGaussPeakShape "MisesFisherGaussPeakShape::~MisesFisherGaussPeakShape() override
MisesFisherGaussPeakShape::~MisesFisherGaussPeakShape";

%feature("docstring")  MisesFisherGaussPeakShape::clone "MisesFisherGaussPeakShape * MisesFisherGaussPeakShape::clone() const override
MisesFisherGaussPeakShape::clone";

%feature("docstring")  MisesFisherGaussPeakShape::className "std::string MisesFisherGaussPeakShape::className() const final
MisesFisherGaussPeakShape::className";

%feature("docstring")  MisesFisherGaussPeakShape::parDefs "std::vector< ParaMeta > MisesFisherGaussPeakShape::parDefs() const final
MisesFisherGaussPeakShape::parDefs";

%feature("docstring")  MisesFisherGaussPeakShape::peakDistribution "double MisesFisherGaussPeakShape::peakDistribution(R3 q, R3 q_lattice_point) const override
MisesFisherGaussPeakShape::peakDistribution
Peak shape at q from a reciprocal lattice point at q_lattice_point. 
";

%feature("docstring")  MisesFisherGaussPeakShape::angularDisorder "bool MisesFisherGaussPeakShape::angularDisorder() const override
MisesFisherGaussPeakShape::angularDisorder
Indicates if the peak shape encodes angular disorder, in which case all peaks in a spherical shell are needed 
";


// File: classMisesGaussPeakShape.xml
%feature("docstring") MisesGaussPeakShape "

A peak shape that is a convolution of a Mises-Fisher distribution with a 3d Gaussian.

C++ includes: IPeakShape.h
";

%feature("docstring")  MisesGaussPeakShape::MisesGaussPeakShape "MisesGaussPeakShape::MisesGaussPeakShape(double max_intensity, double radial_size, R3 zenith, double kappa)
MisesGaussPeakShape::MisesGaussPeakShape";

%feature("docstring")  MisesGaussPeakShape::~MisesGaussPeakShape "MisesGaussPeakShape::~MisesGaussPeakShape() override
MisesGaussPeakShape::~MisesGaussPeakShape";

%feature("docstring")  MisesGaussPeakShape::clone "MisesGaussPeakShape * MisesGaussPeakShape::clone() const override
MisesGaussPeakShape::clone";

%feature("docstring")  MisesGaussPeakShape::className "std::string MisesGaussPeakShape::className() const final
MisesGaussPeakShape::className";

%feature("docstring")  MisesGaussPeakShape::parDefs "std::vector< ParaMeta > MisesGaussPeakShape::parDefs() const final
MisesGaussPeakShape::parDefs";

%feature("docstring")  MisesGaussPeakShape::peakDistribution "double MisesGaussPeakShape::peakDistribution(R3 q, R3 q_lattice_point) const override
MisesGaussPeakShape::peakDistribution
Peak shape at q from a reciprocal lattice point at q_lattice_point. 
";

%feature("docstring")  MisesGaussPeakShape::angularDisorder "bool MisesGaussPeakShape::angularDisorder() const override
MisesGaussPeakShape::angularDisorder
Indicates if the peak shape encodes angular disorder, in which case all peaks in a spherical shell are needed 
";


// File: classMultiLayer.xml
%feature("docstring") MultiLayer "

Our sample model: a stack of layers one below the other. Example of system of 4 layers (3 interfaces): //! vacuum      layer 0
//! ---------   interface 0    z=0.0
//! Fe, 20A     layer 1
//! ---------   interface 1    z=-20.0
//! Cr, 40A     layer 2
//! ---------   interface 2    z=-60.0
//! substrate   layer 3
//!

C++ includes: MultiLayer.h
";

%feature("docstring")  MultiLayer::MultiLayer "MultiLayer::MultiLayer(std::string name=\"Unnamed\")
MultiLayer::MultiLayer";

%feature("docstring")  MultiLayer::~MultiLayer "MultiLayer::~MultiLayer() override
MultiLayer::~MultiLayer";

%feature("docstring")  MultiLayer::clone "MultiLayer * MultiLayer::clone() const override
MultiLayer::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  MultiLayer::className "std::string MultiLayer::className() const final
MultiLayer::className";

%feature("docstring")  MultiLayer::numberOfLayers "size_t MultiLayer::numberOfLayers() const
MultiLayer::numberOfLayers";

%feature("docstring")  MultiLayer::addLayer "void MultiLayer::addLayer(const Layer &layer)
MultiLayer::addLayer
Adds layer with default (zero) roughness. 
";

%feature("docstring")  MultiLayer::addLayerWithTopRoughness "void MultiLayer::addLayerWithTopRoughness(const Layer &layer, const LayerRoughness &roughness)
MultiLayer::addLayerWithTopRoughness
Adds layer with top roughness. 
";

%feature("docstring")  MultiLayer::setRoughnessModel "void MultiLayer::setRoughnessModel(RoughnessModel roughnessModel)
MultiLayer::setRoughnessModel";

%feature("docstring")  MultiLayer::setCrossCorrLength "void MultiLayer::setCrossCorrLength(double crossCorrLength)
MultiLayer::setCrossCorrLength
Sets cross correlation length of roughnesses between interfaces. 
";

%feature("docstring")  MultiLayer::setExternalField "void MultiLayer::setExternalField(R3 ext_field)
MultiLayer::setExternalField
Sets the external field applied to the sample (units: A/m) 
";

%feature("docstring")  MultiLayer::layer "const Layer * MultiLayer::layer(size_t i_layer) const
MultiLayer::layer
Returns layer with given index. 
";

%feature("docstring")  MultiLayer::layerInterface "const LayerInterface * MultiLayer::layerInterface(size_t i_interface) const
MultiLayer::layerInterface
Returns interface with given index. 
";

%feature("docstring")  MultiLayer::roughnessModel "RoughnessModel MultiLayer::roughnessModel() const
MultiLayer::roughnessModel";

%feature("docstring")  MultiLayer::crossCorrLength "double MultiLayer::crossCorrLength() const
MultiLayer::crossCorrLength
Returns cross correlation length of roughnesses between interfaces. 
";

%feature("docstring")  MultiLayer::externalField "R3 MultiLayer::externalField() const
MultiLayer::externalField
Returns the external field applied to the sample (units: A/m) 
";

%feature("docstring")  MultiLayer::nodeChildren "std::vector< const INode * > MultiLayer::nodeChildren() const override
MultiLayer::nodeChildren";

%feature("docstring")  MultiLayer::setSampleName "void MultiLayer::setSampleName(const std::string &name)
MultiLayer::setSampleName";

%feature("docstring")  MultiLayer::sampleName "const std::string & MultiLayer::sampleName() const
MultiLayer::sampleName";

%feature("docstring")  MultiLayer::validate "std::string MultiLayer::validate() const override
MultiLayer::validate";


// File: structOneAdmixture.xml
%feature("docstring") OneAdmixture "

An admixture to a slice, consisting of a certain volume fraction of a homogeneous material.

C++ includes: Admixtures.h
";


// File: classParticle.xml
%feature("docstring") Particle "

A particle with a form factor and refractive index.

C++ includes: Particle.h
";

%feature("docstring")  Particle::Particle "Particle::Particle(Material material, const IFormFactor &formfactor)
Particle::Particle";

%feature("docstring")  Particle::Particle "Particle::Particle(Material material, const IFormFactor &formfactor, const IRotation &rotation)
Particle::Particle";

%feature("docstring")  Particle::~Particle "Particle::~Particle() override
Particle::~Particle";

%feature("docstring")  Particle::clone "Particle * Particle::clone() const override
Particle::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Particle::className "std::string Particle::className() const override
Particle::className";

%feature("docstring")  Particle::nodeChildren "std::vector< const INode * > Particle::nodeChildren() const override
Particle::nodeChildren";

%feature("docstring")  Particle::material "const Material * Particle::material() const override
Particle::material
Returns nullptr, unless overwritten to return a specific material. 
";

%feature("docstring")  Particle::formfactor_at_bottom "const IFormFactor * Particle::formfactor_at_bottom() const
Particle::formfactor_at_bottom";

%feature("docstring")  Particle::validate "std::string Particle::validate() const override
Particle::validate";


// File: classParticleComposition.xml
%feature("docstring") ParticleComposition "

A composition of particles at fixed positions

C++ includes: ParticleComposition.h
";

%feature("docstring")  ParticleComposition::ParticleComposition "ParticleComposition::ParticleComposition()
ParticleComposition::ParticleComposition";

%feature("docstring")  ParticleComposition::~ParticleComposition "ParticleComposition::~ParticleComposition() override
ParticleComposition::~ParticleComposition";

%feature("docstring")  ParticleComposition::clone "ParticleComposition * ParticleComposition::clone() const override
ParticleComposition::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  ParticleComposition::className "std::string ParticleComposition::className() const final
ParticleComposition::className";

%feature("docstring")  ParticleComposition::nodeChildren "std::vector< const INode * > ParticleComposition::nodeChildren() const override
ParticleComposition::nodeChildren";

%feature("docstring")  ParticleComposition::decompose "std::vector< std::unique_ptr< IParticle > > ParticleComposition::decompose() const override
ParticleComposition::decompose
Decompose in constituent  IParticle objects. 
";

%feature("docstring")  ParticleComposition::addParticle "void ParticleComposition::addParticle(const IParticle &particle)
ParticleComposition::addParticle";

%feature("docstring")  ParticleComposition::addParticle "void ParticleComposition::addParticle(const IParticle &particle, R3 position)
ParticleComposition::addParticle";

%feature("docstring")  ParticleComposition::addParticles "void ParticleComposition::addParticles(const IParticle &particle, std::vector< R3 > positions)
ParticleComposition::addParticles";

%feature("docstring")  ParticleComposition::nbrParticles "size_t ParticleComposition::nbrParticles() const
ParticleComposition::nbrParticles
Returns number of different particles. 
";

%feature("docstring")  ParticleComposition::particles "std::vector< const IParticle * > ParticleComposition::particles() const
ParticleComposition::particles";

%feature("docstring")  ParticleComposition::validate "std::string ParticleComposition::validate() const override
ParticleComposition::validate";


// File: classParticleCoreShell.xml
%feature("docstring") ParticleCoreShell "

A particle with a core/shell geometry.

C++ includes: ParticleCoreShell.h
";

%feature("docstring")  ParticleCoreShell::ParticleCoreShell "ParticleCoreShell::ParticleCoreShell(const Particle &shell, const Particle &core, R3 relative_core_position=R3(0.0, 0.0, 0.0))
ParticleCoreShell::ParticleCoreShell";

%feature("docstring")  ParticleCoreShell::~ParticleCoreShell "ParticleCoreShell::~ParticleCoreShell() override
ParticleCoreShell::~ParticleCoreShell";

%feature("docstring")  ParticleCoreShell::clone "ParticleCoreShell * ParticleCoreShell::clone() const override
ParticleCoreShell::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  ParticleCoreShell::className "std::string ParticleCoreShell::className() const final
ParticleCoreShell::className";

%feature("docstring")  ParticleCoreShell::nodeChildren "std::vector< const INode * > ParticleCoreShell::nodeChildren() const override
ParticleCoreShell::nodeChildren";

%feature("docstring")  ParticleCoreShell::shellParticle "const Particle * ParticleCoreShell::shellParticle() const
ParticleCoreShell::shellParticle";

%feature("docstring")  ParticleCoreShell::coreParticle "const Particle * ParticleCoreShell::coreParticle() const
ParticleCoreShell::coreParticle";

%feature("docstring")  ParticleCoreShell::validate "std::string ParticleCoreShell::validate() const override
ParticleCoreShell::validate";


// File: classParticleLayout.xml
%feature("docstring") ParticleLayout "

Decorator class that adds particles to  ISampleNode objects.

C++ includes: ParticleLayout.h
";

%feature("docstring")  ParticleLayout::ParticleLayout "ParticleLayout::ParticleLayout()
ParticleLayout::ParticleLayout";

%feature("docstring")  ParticleLayout::ParticleLayout "ParticleLayout::ParticleLayout(const IParticle &particle, double abundance=-1.0)
ParticleLayout::ParticleLayout";

%feature("docstring")  ParticleLayout::~ParticleLayout "ParticleLayout::~ParticleLayout() override
ParticleLayout::~ParticleLayout";

%feature("docstring")  ParticleLayout::clone "ParticleLayout * ParticleLayout::clone() const override
ParticleLayout::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  ParticleLayout::className "std::string ParticleLayout::className() const final
ParticleLayout::className";

%feature("docstring")  ParticleLayout::parDefs "std::vector< ParaMeta > ParticleLayout::parDefs() const final
ParticleLayout::parDefs";

%feature("docstring")  ParticleLayout::nodeChildren "std::vector< const INode * > ParticleLayout::nodeChildren() const override
ParticleLayout::nodeChildren";

%feature("docstring")  ParticleLayout::addParticle "void ParticleLayout::addParticle(const IParticle &particle, double abundance=-1.0)
ParticleLayout::addParticle
Adds particle to the layout with abundance, position and the rotation defined.

Parameters:
-----------

particle: 
to be added

abundance: 
 Particle abundance 
";

%feature("docstring")  ParticleLayout::particles "std::vector< const IParticle * > ParticleLayout::particles() const
ParticleLayout::particles";

%feature("docstring")  ParticleLayout::interferenceFunction "const IInterference * ParticleLayout::interferenceFunction() const
ParticleLayout::interferenceFunction";

%feature("docstring")  ParticleLayout::totalAbundance "double ParticleLayout::totalAbundance() const
ParticleLayout::totalAbundance";

%feature("docstring")  ParticleLayout::setInterference "void ParticleLayout::setInterference(const IInterference &interparticle)
ParticleLayout::setInterference
Adds interference functions. 
";

%feature("docstring")  ParticleLayout::totalParticleSurfaceDensity "double ParticleLayout::totalParticleSurfaceDensity() const
ParticleLayout::totalParticleSurfaceDensity";

%feature("docstring")  ParticleLayout::setTotalParticleSurfaceDensity "void ParticleLayout::setTotalParticleSurfaceDensity(double particle_density)
ParticleLayout::setTotalParticleSurfaceDensity
Sets total particle surface density.

Parameters:
-----------

particle_density: 
number of particles per square nanometer 
";

%feature("docstring")  ParticleLayout::weight "double ParticleLayout::weight() const
ParticleLayout::weight
Returns the relative weight of this layout. 
";

%feature("docstring")  ParticleLayout::setWeight "void ParticleLayout::setWeight(double weight)
ParticleLayout::setWeight
Sets the relative weight of this layout. 
";

%feature("docstring")  ParticleLayout::weightedParticleSurfaceDensity "double ParticleLayout::weightedParticleSurfaceDensity() const
ParticleLayout::weightedParticleSurfaceDensity";

%feature("docstring")  ParticleLayout::validate "std::string ParticleLayout::validate() const override
ParticleLayout::validate";


// File: classPlatonicOctahedron.xml
%feature("docstring") PlatonicOctahedron "

A truncated bifrustum with quadratic base.

C++ includes: PlatonicOctahedron.h
";

%feature("docstring")  PlatonicOctahedron::PlatonicOctahedron "PlatonicOctahedron::PlatonicOctahedron(double edge)
PlatonicOctahedron::PlatonicOctahedron";

%feature("docstring")  PlatonicOctahedron::PlatonicOctahedron "PlatonicOctahedron::PlatonicOctahedron(std::vector< double > P)
PlatonicOctahedron::PlatonicOctahedron";

%feature("docstring")  PlatonicOctahedron::clone "PlatonicOctahedron * PlatonicOctahedron::clone() const override
PlatonicOctahedron::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  PlatonicOctahedron::className "std::string PlatonicOctahedron::className() const final
PlatonicOctahedron::className";

%feature("docstring")  PlatonicOctahedron::parDefs "std::vector< ParaMeta > PlatonicOctahedron::parDefs() const final
PlatonicOctahedron::parDefs";

%feature("docstring")  PlatonicOctahedron::edge "double PlatonicOctahedron::edge() const
PlatonicOctahedron::edge";

%feature("docstring")  PlatonicOctahedron::height "double PlatonicOctahedron::height() const
PlatonicOctahedron::height";

%feature("docstring")  PlatonicOctahedron::validate "std::string PlatonicOctahedron::validate() const override
PlatonicOctahedron::validate";


// File: classPlatonicTetrahedron.xml
%feature("docstring") PlatonicTetrahedron "

A frustum with equilateral trigonal base.

C++ includes: PlatonicTetrahedron.h
";

%feature("docstring")  PlatonicTetrahedron::PlatonicTetrahedron "PlatonicTetrahedron::PlatonicTetrahedron(double edge)
PlatonicTetrahedron::PlatonicTetrahedron";

%feature("docstring")  PlatonicTetrahedron::PlatonicTetrahedron "PlatonicTetrahedron::PlatonicTetrahedron(std::vector< double > P)
PlatonicTetrahedron::PlatonicTetrahedron";

%feature("docstring")  PlatonicTetrahedron::clone "PlatonicTetrahedron * PlatonicTetrahedron::clone() const override
PlatonicTetrahedron::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  PlatonicTetrahedron::className "std::string PlatonicTetrahedron::className() const final
PlatonicTetrahedron::className";

%feature("docstring")  PlatonicTetrahedron::parDefs "std::vector< ParaMeta > PlatonicTetrahedron::parDefs() const final
PlatonicTetrahedron::parDefs";

%feature("docstring")  PlatonicTetrahedron::edge "double PlatonicTetrahedron::edge() const
PlatonicTetrahedron::edge";

%feature("docstring")  PlatonicTetrahedron::height "double PlatonicTetrahedron::height() const
PlatonicTetrahedron::height";

%feature("docstring")  PlatonicTetrahedron::validate "std::string PlatonicTetrahedron::validate() const override
PlatonicTetrahedron::validate";


// File: classPrism3.xml
%feature("docstring") Prism3 "

A prism based on an equilateral triangle.

C++ includes: Prism3.h
";

%feature("docstring")  Prism3::Prism3 "Prism3::Prism3(double base_edge, double height)
Prism3::Prism3";

%feature("docstring")  Prism3::Prism3 "Prism3::Prism3(std::vector< double > P)
Prism3::Prism3";

%feature("docstring")  Prism3::clone "Prism3 * Prism3::clone() const override
Prism3::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Prism3::className "std::string Prism3::className() const final
Prism3::className";

%feature("docstring")  Prism3::parDefs "std::vector< ParaMeta > Prism3::parDefs() const final
Prism3::parDefs";

%feature("docstring")  Prism3::baseEdge "double Prism3::baseEdge() const
Prism3::baseEdge";

%feature("docstring")  Prism3::height "double Prism3::height() const override
Prism3::height";

%feature("docstring")  Prism3::validate "std::string Prism3::validate() const override
Prism3::validate";


// File: classPrism6.xml
%feature("docstring") Prism6 "

A prism based on a regular hexagonal.

C++ includes: Prism6.h
";

%feature("docstring")  Prism6::Prism6 "Prism6::Prism6(double base_edge, double height)
Prism6::Prism6";

%feature("docstring")  Prism6::Prism6 "Prism6::Prism6(std::vector< double > P)
Prism6::Prism6";

%feature("docstring")  Prism6::clone "Prism6 * Prism6::clone() const override
Prism6::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Prism6::className "std::string Prism6::className() const final
Prism6::className";

%feature("docstring")  Prism6::parDefs "std::vector< ParaMeta > Prism6::parDefs() const final
Prism6::parDefs";

%feature("docstring")  Prism6::baseEdge "double Prism6::baseEdge() const
Prism6::baseEdge";

%feature("docstring")  Prism6::height "double Prism6::height() const override
Prism6::height";

%feature("docstring")  Prism6::validate "std::string Prism6::validate() const override
Prism6::validate";


// File: classProfile1DCauchy.xml
%feature("docstring") Profile1DCauchy "

Exponential  IProfile1D exp(-|omega*x|); its Fourier transform standardizedFT(q) is a Cauchy-Lorentzian starting at standardizedFT(0)=1.

C++ includes: Profiles1D.h
";

%feature("docstring")  Profile1DCauchy::Profile1DCauchy "Profile1DCauchy::Profile1DCauchy(std::vector< double > P)
Profile1DCauchy::Profile1DCauchy";

%feature("docstring")  Profile1DCauchy::Profile1DCauchy "Profile1DCauchy::Profile1DCauchy(double omega)
Profile1DCauchy::Profile1DCauchy";

%feature("docstring")  Profile1DCauchy::clone "Profile1DCauchy * Profile1DCauchy::clone() const override
Profile1DCauchy::clone";

%feature("docstring")  Profile1DCauchy::className "std::string Profile1DCauchy::className() const final
Profile1DCauchy::className";

%feature("docstring")  Profile1DCauchy::standardizedFT "double Profile1DCauchy::standardizedFT(double q) const override
Profile1DCauchy::standardizedFT
Returns Fourier transform of the normalized distribution; is a decay function starting at standardizedFT(0)=1. 
";

%feature("docstring")  Profile1DCauchy::decayFT "double Profile1DCauchy::decayFT(double q) const override
Profile1DCauchy::decayFT
Returns Fourier transform of the distribution scaled as decay function f(x)/f(0). 
";

%feature("docstring")  Profile1DCauchy::qSecondDerivative "double Profile1DCauchy::qSecondDerivative() const override
Profile1DCauchy::qSecondDerivative
Returns the negative of the second order derivative in q space around q=0. 
";

%feature("docstring")  Profile1DCauchy::createSampler "std::unique_ptr< IDistribution1DSampler > Profile1DCauchy::createSampler() const override
Profile1DCauchy::createSampler";


// File: classProfile1DCosine.xml
%feature("docstring") Profile1DCosine "

IProfile1D consisting of one cosine wave [1+cos(pi*x/omega) if |x|<omega, and 0 otherwise]; its Fourier transform standardizedFT(q) starts at standardizedFT(0)=1.

C++ includes: Profiles1D.h
";

%feature("docstring")  Profile1DCosine::Profile1DCosine "Profile1DCosine::Profile1DCosine(std::vector< double > P)
Profile1DCosine::Profile1DCosine";

%feature("docstring")  Profile1DCosine::Profile1DCosine "Profile1DCosine::Profile1DCosine(double omega)
Profile1DCosine::Profile1DCosine";

%feature("docstring")  Profile1DCosine::clone "Profile1DCosine * Profile1DCosine::clone() const override
Profile1DCosine::clone";

%feature("docstring")  Profile1DCosine::className "std::string Profile1DCosine::className() const final
Profile1DCosine::className";

%feature("docstring")  Profile1DCosine::standardizedFT "double Profile1DCosine::standardizedFT(double q) const override
Profile1DCosine::standardizedFT
Returns Fourier transform of the normalized distribution; is a decay function starting at standardizedFT(0)=1. 
";

%feature("docstring")  Profile1DCosine::decayFT "double Profile1DCosine::decayFT(double q) const override
Profile1DCosine::decayFT
Returns Fourier transform of the distribution scaled as decay function f(x)/f(0). 
";

%feature("docstring")  Profile1DCosine::qSecondDerivative "double Profile1DCosine::qSecondDerivative() const override
Profile1DCosine::qSecondDerivative
Returns the negative of the second order derivative in q space around q=0. 
";

%feature("docstring")  Profile1DCosine::createSampler "std::unique_ptr< IDistribution1DSampler > Profile1DCosine::createSampler() const override
Profile1DCosine::createSampler";


// File: classProfile1DGate.xml
%feature("docstring") Profile1DGate "

Square gate  IProfile1D; its Fourier transform standardizedFT(q) is a sinc function starting at standardizedFT(0)=1.

C++ includes: Profiles1D.h
";

%feature("docstring")  Profile1DGate::Profile1DGate "Profile1DGate::Profile1DGate(std::vector< double > P)
Profile1DGate::Profile1DGate";

%feature("docstring")  Profile1DGate::Profile1DGate "Profile1DGate::Profile1DGate(double omega)
Profile1DGate::Profile1DGate";

%feature("docstring")  Profile1DGate::clone "Profile1DGate * Profile1DGate::clone() const override
Profile1DGate::clone";

%feature("docstring")  Profile1DGate::className "std::string Profile1DGate::className() const final
Profile1DGate::className";

%feature("docstring")  Profile1DGate::standardizedFT "double Profile1DGate::standardizedFT(double q) const override
Profile1DGate::standardizedFT
Returns Fourier transform of the normalized distribution; is a decay function starting at standardizedFT(0)=1. 
";

%feature("docstring")  Profile1DGate::decayFT "double Profile1DGate::decayFT(double q) const override
Profile1DGate::decayFT
Returns Fourier transform of the distribution scaled as decay function f(x)/f(0). 
";

%feature("docstring")  Profile1DGate::qSecondDerivative "double Profile1DGate::qSecondDerivative() const override
Profile1DGate::qSecondDerivative
Returns the negative of the second order derivative in q space around q=0. 
";

%feature("docstring")  Profile1DGate::createSampler "std::unique_ptr< IDistribution1DSampler > Profile1DGate::createSampler() const override
Profile1DGate::createSampler";


// File: classProfile1DGauss.xml
%feature("docstring") Profile1DGauss "

Gaussian  IProfile1D; its Fourier transform standardizedFT(q) is a Gaussian starting at standardizedFT(0)=1.

C++ includes: Profiles1D.h
";

%feature("docstring")  Profile1DGauss::Profile1DGauss "Profile1DGauss::Profile1DGauss(std::vector< double > P)
Profile1DGauss::Profile1DGauss";

%feature("docstring")  Profile1DGauss::Profile1DGauss "Profile1DGauss::Profile1DGauss(double omega)
Profile1DGauss::Profile1DGauss";

%feature("docstring")  Profile1DGauss::clone "Profile1DGauss * Profile1DGauss::clone() const override
Profile1DGauss::clone";

%feature("docstring")  Profile1DGauss::className "std::string Profile1DGauss::className() const final
Profile1DGauss::className";

%feature("docstring")  Profile1DGauss::standardizedFT "double Profile1DGauss::standardizedFT(double q) const override
Profile1DGauss::standardizedFT
Returns Fourier transform of the normalized distribution; is a decay function starting at standardizedFT(0)=1. 
";

%feature("docstring")  Profile1DGauss::decayFT "double Profile1DGauss::decayFT(double q) const override
Profile1DGauss::decayFT
Returns Fourier transform of the distribution scaled as decay function f(x)/f(0). 
";

%feature("docstring")  Profile1DGauss::qSecondDerivative "double Profile1DGauss::qSecondDerivative() const override
Profile1DGauss::qSecondDerivative
Returns the negative of the second order derivative in q space around q=0. 
";

%feature("docstring")  Profile1DGauss::createSampler "std::unique_ptr< IDistribution1DSampler > Profile1DGauss::createSampler() const override
Profile1DGauss::createSampler";


// File: classProfile1DTriangle.xml
%feature("docstring") Profile1DTriangle "

Triangle  IProfile1D [1-|x|/omega if |x|<omega, and 0 otherwise]; its Fourier transform standardizedFT(q) is a squared sinc function starting at standardizedFT(0)=1.

C++ includes: Profiles1D.h
";

%feature("docstring")  Profile1DTriangle::Profile1DTriangle "Profile1DTriangle::Profile1DTriangle(std::vector< double > P)
Profile1DTriangle::Profile1DTriangle";

%feature("docstring")  Profile1DTriangle::Profile1DTriangle "Profile1DTriangle::Profile1DTriangle(double omega)
Profile1DTriangle::Profile1DTriangle";

%feature("docstring")  Profile1DTriangle::clone "Profile1DTriangle * Profile1DTriangle::clone() const override
Profile1DTriangle::clone";

%feature("docstring")  Profile1DTriangle::className "std::string Profile1DTriangle::className() const final
Profile1DTriangle::className";

%feature("docstring")  Profile1DTriangle::standardizedFT "double Profile1DTriangle::standardizedFT(double q) const override
Profile1DTriangle::standardizedFT
Returns Fourier transform of the normalized distribution; is a decay function starting at standardizedFT(0)=1. 
";

%feature("docstring")  Profile1DTriangle::decayFT "double Profile1DTriangle::decayFT(double q) const override
Profile1DTriangle::decayFT
Returns Fourier transform of the distribution scaled as decay function f(x)/f(0). 
";

%feature("docstring")  Profile1DTriangle::qSecondDerivative "double Profile1DTriangle::qSecondDerivative() const override
Profile1DTriangle::qSecondDerivative
Returns the negative of the second order derivative in q space around q=0. 
";

%feature("docstring")  Profile1DTriangle::createSampler "std::unique_ptr< IDistribution1DSampler > Profile1DTriangle::createSampler() const override
Profile1DTriangle::createSampler";


// File: classProfile1DVoigt.xml
%feature("docstring") Profile1DVoigt "

IProfile1D that provides a Fourier transform standardizedFT(q) in form of a pseudo-Voigt decay function eta*Gauss + (1-eta)*Cauchy, with both components starting at 1 for q=0.

C++ includes: Profiles1D.h
";

%feature("docstring")  Profile1DVoigt::Profile1DVoigt "Profile1DVoigt::Profile1DVoigt(std::vector< double > P)
Profile1DVoigt::Profile1DVoigt";

%feature("docstring")  Profile1DVoigt::Profile1DVoigt "Profile1DVoigt::Profile1DVoigt(double omega, double eta)
Profile1DVoigt::Profile1DVoigt";

%feature("docstring")  Profile1DVoigt::clone "Profile1DVoigt * Profile1DVoigt::clone() const override
Profile1DVoigt::clone";

%feature("docstring")  Profile1DVoigt::className "std::string Profile1DVoigt::className() const final
Profile1DVoigt::className";

%feature("docstring")  Profile1DVoigt::parDefs "std::vector< ParaMeta > Profile1DVoigt::parDefs() const final
Profile1DVoigt::parDefs";

%feature("docstring")  Profile1DVoigt::standardizedFT "double Profile1DVoigt::standardizedFT(double q) const override
Profile1DVoigt::standardizedFT
Returns Fourier transform of the normalized distribution; is a decay function starting at standardizedFT(0)=1. 
";

%feature("docstring")  Profile1DVoigt::decayFT "double Profile1DVoigt::decayFT(double q) const override
Profile1DVoigt::decayFT
Returns Fourier transform of the distribution scaled as decay function f(x)/f(0). 
";

%feature("docstring")  Profile1DVoigt::eta "double Profile1DVoigt::eta() const
Profile1DVoigt::eta";

%feature("docstring")  Profile1DVoigt::qSecondDerivative "double Profile1DVoigt::qSecondDerivative() const override
Profile1DVoigt::qSecondDerivative
Returns the negative of the second order derivative in q space around q=0. 
";

%feature("docstring")  Profile1DVoigt::createSampler "std::unique_ptr< IDistribution1DSampler > Profile1DVoigt::createSampler() const override
Profile1DVoigt::createSampler";

%feature("docstring")  Profile1DVoigt::pythonConstructor "std::string Profile1DVoigt::pythonConstructor() const override
Profile1DVoigt::pythonConstructor
Creates the Python constructor of this class (or derived classes) 
";

%feature("docstring")  Profile1DVoigt::validate "std::string Profile1DVoigt::validate() const override
Profile1DVoigt::validate";


// File: classProfile2DCauchy.xml
%feature("docstring") Profile2DCauchy "

Two-dimensional Cauchy distribution in Fourier space; corresponds to a normalized exp(-r) in real space, with  $r=\\\\sqrt{(\\\\frac{x}{\\\\omega_x})^2 + (\\\\frac{y}{\\\\omega_y})^2}$.

C++ includes: Profiles2D.h
";

%feature("docstring")  Profile2DCauchy::Profile2DCauchy "Profile2DCauchy::Profile2DCauchy(std::vector< double > P)
Profile2DCauchy::Profile2DCauchy";

%feature("docstring")  Profile2DCauchy::Profile2DCauchy "Profile2DCauchy::Profile2DCauchy(double omega_x, double omega_y, double gamma)
Profile2DCauchy::Profile2DCauchy";

%feature("docstring")  Profile2DCauchy::clone "Profile2DCauchy * Profile2DCauchy::clone() const override
Profile2DCauchy::clone";

%feature("docstring")  Profile2DCauchy::className "std::string Profile2DCauchy::className() const final
Profile2DCauchy::className";

%feature("docstring")  Profile2DCauchy::standardizedFT2D "double Profile2DCauchy::standardizedFT2D(double qx, double qy) const override
Profile2DCauchy::standardizedFT2D
Fourier transformed distribution for q in X,Y coordinates the original distribution (in real space) is assumed to be normalized: total integral is equal to 1 
";

%feature("docstring")  Profile2DCauchy::decayFT2D "double Profile2DCauchy::decayFT2D(double qx, double qy) const override
Profile2DCauchy::decayFT2D";

%feature("docstring")  Profile2DCauchy::createSampler "std::unique_ptr< IDistribution2DSampler > Profile2DCauchy::createSampler() const override
Profile2DCauchy::createSampler";


// File: classProfile2DComponents.xml
%feature("docstring") Profile2DComponents "

Predefined Fourier transformed distributions for functional tests.

C++ includes: Profile2DComponents.h
";

%feature("docstring")  Profile2DComponents::Profile2DComponents "Profile2DComponents::Profile2DComponents()
Profile2DComponents::Profile2DComponents";


// File: classProfile2DCone.xml
%feature("docstring") Profile2DCone "

Two-dimensional cone distribution in Fourier space; corresponds to 1-r if r<1 (and 0 otherwise) in real space with  $r=\\\\sqrt{(\\\\frac{x}{\\\\omega_x})^2 + (\\\\frac{y}{\\\\omega_y})^2}$.

C++ includes: Profiles2D.h
";

%feature("docstring")  Profile2DCone::Profile2DCone "Profile2DCone::Profile2DCone(std::vector< double > P)
Profile2DCone::Profile2DCone";

%feature("docstring")  Profile2DCone::Profile2DCone "Profile2DCone::Profile2DCone(double omega_x, double omega_y, double gamma)
Profile2DCone::Profile2DCone";

%feature("docstring")  Profile2DCone::clone "Profile2DCone * Profile2DCone::clone() const override
Profile2DCone::clone";

%feature("docstring")  Profile2DCone::className "std::string Profile2DCone::className() const final
Profile2DCone::className";

%feature("docstring")  Profile2DCone::standardizedFT2D "double Profile2DCone::standardizedFT2D(double qx, double qy) const override
Profile2DCone::standardizedFT2D
Fourier transformed distribution for q in X,Y coordinates the original distribution (in real space) is assumed to be normalized: total integral is equal to 1 
";

%feature("docstring")  Profile2DCone::decayFT2D "double Profile2DCone::decayFT2D(double qx, double qy) const override
Profile2DCone::decayFT2D";

%feature("docstring")  Profile2DCone::createSampler "std::unique_ptr< IDistribution2DSampler > Profile2DCone::createSampler() const override
Profile2DCone::createSampler";


// File: classProfile2DGate.xml
%feature("docstring") Profile2DGate "

Two-dimensional gate distribution in Fourier space; corresponds to normalized constant if r<1 (and 0 otherwise) in real space, with  $r=\\\\sqrt{(\\\\frac{x}{\\\\omega_x})^2 + (\\\\frac{y}{\\\\omega_y})^2}$.

C++ includes: Profiles2D.h
";

%feature("docstring")  Profile2DGate::Profile2DGate "Profile2DGate::Profile2DGate(std::vector< double > P)
Profile2DGate::Profile2DGate";

%feature("docstring")  Profile2DGate::Profile2DGate "Profile2DGate::Profile2DGate(double omega_x, double omega_y, double gamma)
Profile2DGate::Profile2DGate";

%feature("docstring")  Profile2DGate::clone "Profile2DGate * Profile2DGate::clone() const override
Profile2DGate::clone";

%feature("docstring")  Profile2DGate::className "std::string Profile2DGate::className() const final
Profile2DGate::className";

%feature("docstring")  Profile2DGate::standardizedFT2D "double Profile2DGate::standardizedFT2D(double qx, double qy) const override
Profile2DGate::standardizedFT2D
Fourier transformed distribution for q in X,Y coordinates the original distribution (in real space) is assumed to be normalized: total integral is equal to 1 
";

%feature("docstring")  Profile2DGate::decayFT2D "double Profile2DGate::decayFT2D(double qx, double qy) const override
Profile2DGate::decayFT2D";

%feature("docstring")  Profile2DGate::createSampler "std::unique_ptr< IDistribution2DSampler > Profile2DGate::createSampler() const override
Profile2DGate::createSampler";


// File: classProfile2DGauss.xml
%feature("docstring") Profile2DGauss "

Two-dimensional Gauss distribution in Fourier space; corresponds to normalized exp(-r^2/2) in real space with  $r=\\\\sqrt{(\\\\frac{x}{\\\\omega_x})^2 + (\\\\frac{y}{\\\\omega_y})^2}$.

C++ includes: Profiles2D.h
";

%feature("docstring")  Profile2DGauss::Profile2DGauss "Profile2DGauss::Profile2DGauss(std::vector< double > P)
Profile2DGauss::Profile2DGauss";

%feature("docstring")  Profile2DGauss::Profile2DGauss "Profile2DGauss::Profile2DGauss(double omega_x, double omega_y, double gamma)
Profile2DGauss::Profile2DGauss";

%feature("docstring")  Profile2DGauss::clone "Profile2DGauss * Profile2DGauss::clone() const override
Profile2DGauss::clone";

%feature("docstring")  Profile2DGauss::className "std::string Profile2DGauss::className() const final
Profile2DGauss::className";

%feature("docstring")  Profile2DGauss::standardizedFT2D "double Profile2DGauss::standardizedFT2D(double qx, double qy) const override
Profile2DGauss::standardizedFT2D
Fourier transformed distribution for q in X,Y coordinates the original distribution (in real space) is assumed to be normalized: total integral is equal to 1 
";

%feature("docstring")  Profile2DGauss::decayFT2D "double Profile2DGauss::decayFT2D(double qx, double qy) const override
Profile2DGauss::decayFT2D";

%feature("docstring")  Profile2DGauss::createSampler "std::unique_ptr< IDistribution2DSampler > Profile2DGauss::createSampler() const override
Profile2DGauss::createSampler";


// File: classProfile2DVoigt.xml
%feature("docstring") Profile2DVoigt "

Two-dimensional Voigt distribution in Fourier space; corresponds to eta*Gauss + (1-eta)*Cauchy

C++ includes: Profiles2D.h
";

%feature("docstring")  Profile2DVoigt::Profile2DVoigt "Profile2DVoigt::Profile2DVoigt(std::vector< double > P)
Profile2DVoigt::Profile2DVoigt";

%feature("docstring")  Profile2DVoigt::Profile2DVoigt "Profile2DVoigt::Profile2DVoigt(double omega_x, double omega_y, double gamma, double eta)
Profile2DVoigt::Profile2DVoigt";

%feature("docstring")  Profile2DVoigt::clone "Profile2DVoigt * Profile2DVoigt::clone() const override
Profile2DVoigt::clone";

%feature("docstring")  Profile2DVoigt::className "std::string Profile2DVoigt::className() const final
Profile2DVoigt::className";

%feature("docstring")  Profile2DVoigt::parDefs "std::vector< ParaMeta > Profile2DVoigt::parDefs() const final
Profile2DVoigt::parDefs";

%feature("docstring")  Profile2DVoigt::standardizedFT2D "double Profile2DVoigt::standardizedFT2D(double qx, double qy) const override
Profile2DVoigt::standardizedFT2D
Fourier transformed distribution for q in X,Y coordinates the original distribution (in real space) is assumed to be normalized: total integral is equal to 1 
";

%feature("docstring")  Profile2DVoigt::decayFT2D "double Profile2DVoigt::decayFT2D(double qx, double qy) const override
Profile2DVoigt::decayFT2D";

%feature("docstring")  Profile2DVoigt::eta "double Profile2DVoigt::eta() const
Profile2DVoigt::eta
balances between Gauss (eta=0) and Lorentz (eta=1) 
";

%feature("docstring")  Profile2DVoigt::createSampler "std::unique_ptr< IDistribution2DSampler > Profile2DVoigt::createSampler() const override
Profile2DVoigt::createSampler";

%feature("docstring")  Profile2DVoigt::pythonConstructor "std::string Profile2DVoigt::pythonConstructor() const override
Profile2DVoigt::pythonConstructor
Creates the Python constructor of this class (or derived classes) 
";

%feature("docstring")  Profile2DVoigt::validate "std::string Profile2DVoigt::validate() const override
Profile2DVoigt::validate";


// File: classPyramid2.xml
%feature("docstring") Pyramid2 "

A frustum (truncated pyramid) with rectangular base.

C++ includes: Pyramid2.h
";

%feature("docstring")  Pyramid2::Pyramid2 "Pyramid2::Pyramid2(double length, double width, double height, double alpha)
Pyramid2::Pyramid2";

%feature("docstring")  Pyramid2::Pyramid2 "Pyramid2::Pyramid2(std::vector< double > P)
Pyramid2::Pyramid2";

%feature("docstring")  Pyramid2::clone "Pyramid2 * Pyramid2::clone() const override
Pyramid2::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Pyramid2::className "std::string Pyramid2::className() const final
Pyramid2::className";

%feature("docstring")  Pyramid2::parDefs "std::vector< ParaMeta > Pyramid2::parDefs() const final
Pyramid2::parDefs";

%feature("docstring")  Pyramid2::length "double Pyramid2::length() const
Pyramid2::length";

%feature("docstring")  Pyramid2::width "double Pyramid2::width() const
Pyramid2::width";

%feature("docstring")  Pyramid2::height "double Pyramid2::height() const
Pyramid2::height";

%feature("docstring")  Pyramid2::alpha "double Pyramid2::alpha() const
Pyramid2::alpha";

%feature("docstring")  Pyramid2::validate "std::string Pyramid2::validate() const override
Pyramid2::validate";


// File: classPyramid3.xml
%feature("docstring") Pyramid3 "

A frustum with equilateral trigonal base.

C++ includes: Pyramid3.h
";

%feature("docstring")  Pyramid3::Pyramid3 "Pyramid3::Pyramid3(double base_edge, double height, double alpha)
Pyramid3::Pyramid3";

%feature("docstring")  Pyramid3::Pyramid3 "Pyramid3::Pyramid3(std::vector< double > P)
Pyramid3::Pyramid3";

%feature("docstring")  Pyramid3::clone "Pyramid3 * Pyramid3::clone() const override
Pyramid3::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Pyramid3::className "std::string Pyramid3::className() const final
Pyramid3::className";

%feature("docstring")  Pyramid3::parDefs "std::vector< ParaMeta > Pyramid3::parDefs() const final
Pyramid3::parDefs";

%feature("docstring")  Pyramid3::baseEdge "double Pyramid3::baseEdge() const
Pyramid3::baseEdge";

%feature("docstring")  Pyramid3::height "double Pyramid3::height() const
Pyramid3::height";

%feature("docstring")  Pyramid3::alpha "double Pyramid3::alpha() const
Pyramid3::alpha";

%feature("docstring")  Pyramid3::validate "std::string Pyramid3::validate() const override
Pyramid3::validate";


// File: classPyramid4.xml
%feature("docstring") Pyramid4 "

A frustum with a quadratic base.

C++ includes: Pyramid4.h
";

%feature("docstring")  Pyramid4::Pyramid4 "Pyramid4::Pyramid4(double base_edge, double height, double alpha)
Pyramid4::Pyramid4";

%feature("docstring")  Pyramid4::Pyramid4 "Pyramid4::Pyramid4(std::vector< double > P)
Pyramid4::Pyramid4";

%feature("docstring")  Pyramid4::clone "Pyramid4 * Pyramid4::clone() const override
Pyramid4::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Pyramid4::className "std::string Pyramid4::className() const final
Pyramid4::className";

%feature("docstring")  Pyramid4::parDefs "std::vector< ParaMeta > Pyramid4::parDefs() const final
Pyramid4::parDefs";

%feature("docstring")  Pyramid4::height "double Pyramid4::height() const
Pyramid4::height";

%feature("docstring")  Pyramid4::baseEdge "double Pyramid4::baseEdge() const
Pyramid4::baseEdge";

%feature("docstring")  Pyramid4::alpha "double Pyramid4::alpha() const
Pyramid4::alpha";

%feature("docstring")  Pyramid4::validate "std::string Pyramid4::validate() const override
Pyramid4::validate";


// File: classPyramid6.xml
%feature("docstring") Pyramid6 "

A frustum (truncated pyramid) with regular hexagonal base.

C++ includes: Pyramid6.h
";

%feature("docstring")  Pyramid6::Pyramid6 "Pyramid6::Pyramid6(double base_edge, double height, double alpha)
Pyramid6::Pyramid6";

%feature("docstring")  Pyramid6::Pyramid6 "Pyramid6::Pyramid6(std::vector< double > P)
Pyramid6::Pyramid6";

%feature("docstring")  Pyramid6::clone "Pyramid6 * Pyramid6::clone() const override
Pyramid6::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Pyramid6::className "std::string Pyramid6::className() const final
Pyramid6::className";

%feature("docstring")  Pyramid6::parDefs "std::vector< ParaMeta > Pyramid6::parDefs() const final
Pyramid6::parDefs";

%feature("docstring")  Pyramid6::baseEdge "double Pyramid6::baseEdge() const
Pyramid6::baseEdge";

%feature("docstring")  Pyramid6::height "double Pyramid6::height() const
Pyramid6::height";

%feature("docstring")  Pyramid6::alpha "double Pyramid6::alpha() const
Pyramid6::alpha";

%feature("docstring")  Pyramid6::validate "std::string Pyramid6::validate() const override
Pyramid6::validate";


// File: structLattice2D_1_1ReciprocalBases.xml
%feature("docstring") Lattice2D::ReciprocalBases "";


// File: classRefractiveMaterialImpl.xml
%feature("docstring") RefractiveMaterialImpl "

Material implementation based on refractive coefficiencts (valid for one wavelength value only)

C++ includes: RefractiveMaterialImpl.h
";

%feature("docstring")  RefractiveMaterialImpl::~RefractiveMaterialImpl "RefractiveMaterialImpl::~RefractiveMaterialImpl() override=default
RefractiveMaterialImpl::~RefractiveMaterialImpl";

%feature("docstring")  RefractiveMaterialImpl::clone "RefractiveMaterialImpl * RefractiveMaterialImpl::clone() const override
RefractiveMaterialImpl::clone
Returns pointer to a copy of material. 
";

%feature("docstring")  RefractiveMaterialImpl::refractiveIndex "complex_t RefractiveMaterialImpl::refractiveIndex(double wavelength) const override
RefractiveMaterialImpl::refractiveIndex
Returns refractive index For this particular implementation returned value does not depend on passed wavelength 
";

%feature("docstring")  RefractiveMaterialImpl::refractiveIndex2 "complex_t RefractiveMaterialImpl::refractiveIndex2(double wavelength) const override
RefractiveMaterialImpl::refractiveIndex2
Returns squared refractive index. For this particular implementation returned value does not depend on passed wavelength. 
";

%feature("docstring")  RefractiveMaterialImpl::materialData "complex_t RefractiveMaterialImpl::materialData() const override
RefractiveMaterialImpl::materialData
Returns underlying material data. 
";

%feature("docstring")  RefractiveMaterialImpl::typeID "MATERIAL_TYPES RefractiveMaterialImpl::typeID() const override
RefractiveMaterialImpl::typeID
Returns type of material implementation. 
";

%feature("docstring")  RefractiveMaterialImpl::scalarSubtrSLD "complex_t RefractiveMaterialImpl::scalarSubtrSLD(double lambda0) const override
RefractiveMaterialImpl::scalarSubtrSLD
Returns (  $ \\\\pi/\\\\lambda^2 $ - sld), sld (in  $nm^{-2}$) being the scattering length density. If the wavelength associated with passed wavevector is different from the one associated with refractive coefficients used during the object construction, provided result is inconsistent. 
";

%feature("docstring")  RefractiveMaterialImpl::print "std::string RefractiveMaterialImpl::print() const override
RefractiveMaterialImpl::print
Prints object data. 
";


// File: classRippleCosineNet.xml
%feature("docstring") RippleCosineNet "";

%feature("docstring")  RippleCosineNet::RippleCosineNet "RippleCosineNet::RippleCosineNet(double length, double width, double height)
RippleCosineNet::RippleCosineNet";

%feature("docstring")  RippleCosineNet::~RippleCosineNet "RippleCosineNet::~RippleCosineNet() override
RippleCosineNet::~RippleCosineNet";


// File: classRippleSawtoothNet.xml
%feature("docstring") RippleSawtoothNet "";

%feature("docstring")  RippleSawtoothNet::RippleSawtoothNet "RippleSawtoothNet::RippleSawtoothNet(double length, double width, double height, double asymmetry)
RippleSawtoothNet::RippleSawtoothNet";

%feature("docstring")  RippleSawtoothNet::~RippleSawtoothNet "RippleSawtoothNet::~RippleSawtoothNet() override
RippleSawtoothNet::~RippleSawtoothNet";


// File: classRotationEuler.xml
%feature("docstring") RotationEuler "

A sequence of rotations about the z-x'-z'' axes.

C++ includes: Rotations.h
";

%feature("docstring")  RotationEuler::RotationEuler "RotationEuler::RotationEuler(std::vector< double > P)
RotationEuler::RotationEuler";

%feature("docstring")  RotationEuler::RotationEuler "RotationEuler::RotationEuler(double alpha, double beta, double gamma)
RotationEuler::RotationEuler";

%feature("docstring")  RotationEuler::clone "RotationEuler * RotationEuler::clone() const override
RotationEuler::clone";

%feature("docstring")  RotationEuler::className "std::string RotationEuler::className() const final
RotationEuler::className";

%feature("docstring")  RotationEuler::parDefs "std::vector< ParaMeta > RotationEuler::parDefs() const final
RotationEuler::parDefs";

%feature("docstring")  RotationEuler::createInverse "IRotation * RotationEuler::createInverse() const override
RotationEuler::createInverse
Returns a new  IRotation object that is the current object's inverse. 
";

%feature("docstring")  RotationEuler::alpha "double RotationEuler::alpha() const
RotationEuler::alpha
First Euler angle, rotation around z axis. 
";

%feature("docstring")  RotationEuler::beta "double RotationEuler::beta() const
RotationEuler::beta
Second Euler angle, rotation around x' axis. 
";

%feature("docstring")  RotationEuler::gamma "double RotationEuler::gamma() const
RotationEuler::gamma
Third Euler angle, rotation around z'' axis. 
";

%feature("docstring")  RotationEuler::rotMatrix "RotMatrix RotationEuler::rotMatrix() const override
RotationEuler::rotMatrix
Returns transformation. 
";


// File: classRotationX.xml
%feature("docstring") RotationX "

A rotation about the x axis.

C++ includes: Rotations.h
";

%feature("docstring")  RotationX::RotationX "RotationX::RotationX(std::vector< double > P)
RotationX::RotationX
Constructor of rotation around x-axis. 
";

%feature("docstring")  RotationX::RotationX "RotationX::RotationX(double angle)
RotationX::RotationX";

%feature("docstring")  RotationX::clone "RotationX * RotationX::clone() const override
RotationX::clone";

%feature("docstring")  RotationX::className "std::string RotationX::className() const final
RotationX::className";

%feature("docstring")  RotationX::parDefs "std::vector< ParaMeta > RotationX::parDefs() const final
RotationX::parDefs";

%feature("docstring")  RotationX::createInverse "RotationX * RotationX::createInverse() const override
RotationX::createInverse
Returns a new  IRotation object that is the current object's inverse. 
";

%feature("docstring")  RotationX::angle "double RotationX::angle() const
RotationX::angle";

%feature("docstring")  RotationX::rotMatrix "RotMatrix RotationX::rotMatrix() const override
RotationX::rotMatrix
Returns transformation. 
";


// File: classRotationY.xml
%feature("docstring") RotationY "

A rotation about the y axis.

C++ includes: Rotations.h
";

%feature("docstring")  RotationY::RotationY "RotationY::RotationY(std::vector< double > P)
RotationY::RotationY
Constructor of rotation around y-axis. 
";

%feature("docstring")  RotationY::RotationY "RotationY::RotationY(double angle)
RotationY::RotationY";

%feature("docstring")  RotationY::clone "RotationY * RotationY::clone() const override
RotationY::clone";

%feature("docstring")  RotationY::className "std::string RotationY::className() const final
RotationY::className";

%feature("docstring")  RotationY::parDefs "std::vector< ParaMeta > RotationY::parDefs() const final
RotationY::parDefs";

%feature("docstring")  RotationY::createInverse "RotationY * RotationY::createInverse() const override
RotationY::createInverse
Returns a new  IRotation object that is the current object's inverse. 
";

%feature("docstring")  RotationY::angle "double RotationY::angle() const
RotationY::angle";

%feature("docstring")  RotationY::rotMatrix "RotMatrix RotationY::rotMatrix() const override
RotationY::rotMatrix
Returns transformation. 
";


// File: classRotationZ.xml
%feature("docstring") RotationZ "

A rotation about the z axis.

C++ includes: Rotations.h
";

%feature("docstring")  RotationZ::RotationZ "RotationZ::RotationZ(std::vector< double > P)
RotationZ::RotationZ
Constructor of rotation around z-axis. 
";

%feature("docstring")  RotationZ::RotationZ "RotationZ::RotationZ(double angle)
RotationZ::RotationZ";

%feature("docstring")  RotationZ::clone "RotationZ * RotationZ::clone() const override
RotationZ::clone";

%feature("docstring")  RotationZ::className "std::string RotationZ::className() const final
RotationZ::className";

%feature("docstring")  RotationZ::parDefs "std::vector< ParaMeta > RotationZ::parDefs() const final
RotationZ::parDefs";

%feature("docstring")  RotationZ::createInverse "RotationZ * RotationZ::createInverse() const override
RotationZ::createInverse
Returns a new  IRotation object that is the current object's inverse. 
";

%feature("docstring")  RotationZ::angle "double RotationZ::angle() const
RotationZ::angle";

%feature("docstring")  RotationZ::rotMatrix "RotMatrix RotationZ::rotMatrix() const override
RotationZ::rotMatrix
Returns transformation. 
";


// File: structRoughnessModelWrap.xml
%feature("docstring") RoughnessModelWrap "";


// File: classSawtoothRippleBox.xml
%feature("docstring") SawtoothRippleBox "

The form factor for a cosine ripple, with box profile in elongation direction.

C++ includes: SawtoothRipple.h
";

%feature("docstring")  SawtoothRippleBox::SawtoothRippleBox "SawtoothRippleBox::SawtoothRippleBox(double length, double width, double height, double asymmetry)
SawtoothRippleBox::SawtoothRippleBox";

%feature("docstring")  SawtoothRippleBox::SawtoothRippleBox "SawtoothRippleBox::SawtoothRippleBox(std::vector< double > P)
SawtoothRippleBox::SawtoothRippleBox";

%feature("docstring")  SawtoothRippleBox::clone "SawtoothRippleBox * SawtoothRippleBox::clone() const override
SawtoothRippleBox::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  SawtoothRippleBox::className "std::string SawtoothRippleBox::className() const final
SawtoothRippleBox::className";

%feature("docstring")  SawtoothRippleBox::parDefs "std::vector< ParaMeta > SawtoothRippleBox::parDefs() const final
SawtoothRippleBox::parDefs";


// File: classSawtoothRippleGauss.xml
%feature("docstring") SawtoothRippleGauss "

The form factor for a cosine ripple, with Gaussian profile in elongation direction.

C++ includes: SawtoothRipple.h
";

%feature("docstring")  SawtoothRippleGauss::SawtoothRippleGauss "SawtoothRippleGauss::SawtoothRippleGauss(double length, double width, double height, double asymmetry)
SawtoothRippleGauss::SawtoothRippleGauss";

%feature("docstring")  SawtoothRippleGauss::SawtoothRippleGauss "SawtoothRippleGauss::SawtoothRippleGauss(std::vector< double > P)
SawtoothRippleGauss::SawtoothRippleGauss";

%feature("docstring")  SawtoothRippleGauss::clone "SawtoothRippleGauss * SawtoothRippleGauss::clone() const override
SawtoothRippleGauss::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  SawtoothRippleGauss::className "std::string SawtoothRippleGauss::className() const final
SawtoothRippleGauss::className";

%feature("docstring")  SawtoothRippleGauss::parDefs "std::vector< ParaMeta > SawtoothRippleGauss::parDefs() const final
SawtoothRippleGauss::parDefs";


// File: classSawtoothRippleLorentz.xml
%feature("docstring") SawtoothRippleLorentz "

The form factor for a cosine ripple, with Lorentz form factor in elongation direction.

C++ includes: SawtoothRipple.h
";

%feature("docstring")  SawtoothRippleLorentz::SawtoothRippleLorentz "SawtoothRippleLorentz::SawtoothRippleLorentz(double length, double width, double height, double asymmetry)
SawtoothRippleLorentz::SawtoothRippleLorentz";

%feature("docstring")  SawtoothRippleLorentz::SawtoothRippleLorentz "SawtoothRippleLorentz::SawtoothRippleLorentz(std::vector< double > P)
SawtoothRippleLorentz::SawtoothRippleLorentz";

%feature("docstring")  SawtoothRippleLorentz::clone "SawtoothRippleLorentz * SawtoothRippleLorentz::clone() const override
SawtoothRippleLorentz::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  SawtoothRippleLorentz::className "std::string SawtoothRippleLorentz::className() const final
SawtoothRippleLorentz::className";

%feature("docstring")  SawtoothRippleLorentz::parDefs "std::vector< ParaMeta > SawtoothRippleLorentz::parDefs() const final
SawtoothRippleLorentz::parDefs";


// File: classSimpleSelectionRule.xml
%feature("docstring") SimpleSelectionRule "

Selection rule (v*q)modulus!=0, defined by vector v(a,b,c) and modulus.

C++ includes: ISelectionRule.h
";

%feature("docstring")  SimpleSelectionRule::SimpleSelectionRule "SimpleSelectionRule::SimpleSelectionRule(int a, int b, int c, int modulus)
SimpleSelectionRule::SimpleSelectionRule";

%feature("docstring")  SimpleSelectionRule::~SimpleSelectionRule "SimpleSelectionRule::~SimpleSelectionRule() override=default
SimpleSelectionRule::~SimpleSelectionRule";

%feature("docstring")  SimpleSelectionRule::clone "SimpleSelectionRule * SimpleSelectionRule::clone() const override
SimpleSelectionRule::clone";

%feature("docstring")  SimpleSelectionRule::coordinateSelected "bool SimpleSelectionRule::coordinateSelected(const I3 &coordinate) const override
SimpleSelectionRule::coordinateSelected";


// File: classSphere.xml
%feature("docstring") Sphere "

A full sphere.

C++ includes: Sphere.h
";

%feature("docstring")  Sphere::Sphere "Sphere::Sphere(double radius, bool position_at_center=false)
Sphere::Sphere";

%feature("docstring")  Sphere::Sphere "Sphere::Sphere(std::vector< double > P, bool position_at_center=false)
Sphere::Sphere";

%feature("docstring")  Sphere::clone "Sphere * Sphere::clone() const override
Sphere::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Sphere::className "std::string Sphere::className() const final
Sphere::className";

%feature("docstring")  Sphere::parDefs "std::vector< ParaMeta > Sphere::parDefs() const final
Sphere::parDefs";

%feature("docstring")  Sphere::radius "double Sphere::radius() const
Sphere::radius";

%feature("docstring")  Sphere::radialExtension "double Sphere::radialExtension() const override
Sphere::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  Sphere::bottomZ "double Sphere::bottomZ(const IRotation *rotation) const override
Sphere::bottomZ";

%feature("docstring")  Sphere::topZ "double Sphere::topZ(const IRotation *rotation) const override
Sphere::topZ";

%feature("docstring")  Sphere::formfactor_at_bottom "complex_t Sphere::formfactor_at_bottom(C3 q) const override
Sphere::formfactor_at_bottom";

%feature("docstring")  Sphere::validate "std::string Sphere::validate() const override
Sphere::validate";


// File: classSpheroid.xml
%feature("docstring") Spheroid "

A full spheroid (an ellipsoid with two equal axes, hence with circular cross section)

C++ includes: Spheroid.h
";

%feature("docstring")  Spheroid::Spheroid "Spheroid::Spheroid(double radius, double height)
Spheroid::Spheroid";

%feature("docstring")  Spheroid::Spheroid "Spheroid::Spheroid(std::vector< double > P)
Spheroid::Spheroid";

%feature("docstring")  Spheroid::clone "Spheroid * Spheroid::clone() const override
Spheroid::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  Spheroid::className "std::string Spheroid::className() const final
Spheroid::className";

%feature("docstring")  Spheroid::parDefs "std::vector< ParaMeta > Spheroid::parDefs() const final
Spheroid::parDefs";

%feature("docstring")  Spheroid::height "double Spheroid::height() const
Spheroid::height";

%feature("docstring")  Spheroid::radius "double Spheroid::radius() const
Spheroid::radius";

%feature("docstring")  Spheroid::radialExtension "double Spheroid::radialExtension() const override
Spheroid::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  Spheroid::formfactor_at_bottom "complex_t Spheroid::formfactor_at_bottom(C3 q) const override
Spheroid::formfactor_at_bottom";

%feature("docstring")  Spheroid::validate "std::string Spheroid::validate() const override
Spheroid::validate";


// File: classSquareLattice2D.xml
%feature("docstring") SquareLattice2D "

A two-dimensional Bravais lattice with square unit cell.

C++ includes: Lattice2D.h
";

%feature("docstring")  SquareLattice2D::SquareLattice2D "SquareLattice2D::SquareLattice2D(double length, double xi=0.0)
SquareLattice2D::SquareLattice2D";

%feature("docstring")  SquareLattice2D::clone "SquareLattice2D * SquareLattice2D::clone() const override
SquareLattice2D::clone";

%feature("docstring")  SquareLattice2D::className "std::string SquareLattice2D::className() const final
SquareLattice2D::className";

%feature("docstring")  SquareLattice2D::parDefs "std::vector< ParaMeta > SquareLattice2D::parDefs() const final
SquareLattice2D::parDefs";

%feature("docstring")  SquareLattice2D::length1 "double SquareLattice2D::length1() const override
SquareLattice2D::length1";

%feature("docstring")  SquareLattice2D::length2 "double SquareLattice2D::length2() const override
SquareLattice2D::length2";

%feature("docstring")  SquareLattice2D::latticeAngle "double SquareLattice2D::latticeAngle() const override
SquareLattice2D::latticeAngle";

%feature("docstring")  SquareLattice2D::unitCellArea "double SquareLattice2D::unitCellArea() const override
SquareLattice2D::unitCellArea";


// File: classTruncatedCube.xml
%feature("docstring") TruncatedCube "

A cube, with tetrahedral truncation of all corners

C++ includes: TruncatedCube.h
";

%feature("docstring")  TruncatedCube::TruncatedCube "TruncatedCube::TruncatedCube(double length, double removed_length)
TruncatedCube::TruncatedCube";

%feature("docstring")  TruncatedCube::TruncatedCube "TruncatedCube::TruncatedCube(std::vector< double > P)
TruncatedCube::TruncatedCube";

%feature("docstring")  TruncatedCube::clone "TruncatedCube * TruncatedCube::clone() const override
TruncatedCube::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  TruncatedCube::className "std::string TruncatedCube::className() const final
TruncatedCube::className";

%feature("docstring")  TruncatedCube::parDefs "std::vector< ParaMeta > TruncatedCube::parDefs() const final
TruncatedCube::parDefs";

%feature("docstring")  TruncatedCube::length "double TruncatedCube::length() const
TruncatedCube::length";

%feature("docstring")  TruncatedCube::removedLength "double TruncatedCube::removedLength() const
TruncatedCube::removedLength";

%feature("docstring")  TruncatedCube::validate "std::string TruncatedCube::validate() const override
TruncatedCube::validate";


// File: classTruncatedEllipsoidNet.xml
%feature("docstring") TruncatedEllipsoidNet "";

%feature("docstring")  TruncatedEllipsoidNet::TruncatedEllipsoidNet "TruncatedEllipsoidNet::TruncatedEllipsoidNet(double r_x, double r_y, double r_z, double height, double dh)
TruncatedEllipsoidNet::TruncatedEllipsoidNet";

%feature("docstring")  TruncatedEllipsoidNet::~TruncatedEllipsoidNet "TruncatedEllipsoidNet::~TruncatedEllipsoidNet() override
TruncatedEllipsoidNet::~TruncatedEllipsoidNet";


// File: classTruncatedSphere.xml
%feature("docstring") TruncatedSphere "

A truncated  Sphere.

C++ includes: TruncatedSphere.h
";

%feature("docstring")  TruncatedSphere::TruncatedSphere "TruncatedSphere::TruncatedSphere(double radius, double height, double dh)
TruncatedSphere::TruncatedSphere";

%feature("docstring")  TruncatedSphere::TruncatedSphere "TruncatedSphere::TruncatedSphere(std::vector< double > P)
TruncatedSphere::TruncatedSphere";

%feature("docstring")  TruncatedSphere::clone "TruncatedSphere * TruncatedSphere::clone() const override
TruncatedSphere::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  TruncatedSphere::className "std::string TruncatedSphere::className() const final
TruncatedSphere::className";

%feature("docstring")  TruncatedSphere::parDefs "std::vector< ParaMeta > TruncatedSphere::parDefs() const final
TruncatedSphere::parDefs";

%feature("docstring")  TruncatedSphere::height "double TruncatedSphere::height() const
TruncatedSphere::height";

%feature("docstring")  TruncatedSphere::radius "double TruncatedSphere::radius() const
TruncatedSphere::radius";

%feature("docstring")  TruncatedSphere::removedTop "double TruncatedSphere::removedTop() const
TruncatedSphere::removedTop";

%feature("docstring")  TruncatedSphere::radialExtension "double TruncatedSphere::radialExtension() const override
TruncatedSphere::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  TruncatedSphere::formfactor_at_bottom "complex_t TruncatedSphere::formfactor_at_bottom(C3 q) const override
TruncatedSphere::formfactor_at_bottom
Complex form factor. 
";

%feature("docstring")  TruncatedSphere::validate "std::string TruncatedSphere::validate() const override
TruncatedSphere::validate";


// File: classTruncatedSpheroid.xml
%feature("docstring") TruncatedSpheroid "

A truncated spheroid. An ellipsoid with two equal axis, truncated by a plane perpendicular to the third axis.

C++ includes: TruncatedSpheroid.h
";

%feature("docstring")  TruncatedSpheroid::TruncatedSpheroid "TruncatedSpheroid::TruncatedSpheroid(double radius, double height, double height_flattening, double dh)
TruncatedSpheroid::TruncatedSpheroid";

%feature("docstring")  TruncatedSpheroid::TruncatedSpheroid "TruncatedSpheroid::TruncatedSpheroid(std::vector< double > P)
TruncatedSpheroid::TruncatedSpheroid";

%feature("docstring")  TruncatedSpheroid::clone "TruncatedSpheroid * TruncatedSpheroid::clone() const override
TruncatedSpheroid::clone
Returns a clone of this  ISampleNode object. 
";

%feature("docstring")  TruncatedSpheroid::className "std::string TruncatedSpheroid::className() const final
TruncatedSpheroid::className";

%feature("docstring")  TruncatedSpheroid::parDefs "std::vector< ParaMeta > TruncatedSpheroid::parDefs() const final
TruncatedSpheroid::parDefs";

%feature("docstring")  TruncatedSpheroid::radius "double TruncatedSpheroid::radius() const
TruncatedSpheroid::radius";

%feature("docstring")  TruncatedSpheroid::height "double TruncatedSpheroid::height() const
TruncatedSpheroid::height";

%feature("docstring")  TruncatedSpheroid::heightFlattening "double TruncatedSpheroid::heightFlattening() const
TruncatedSpheroid::heightFlattening";

%feature("docstring")  TruncatedSpheroid::removedTop "double TruncatedSpheroid::removedTop() const
TruncatedSpheroid::removedTop";

%feature("docstring")  TruncatedSpheroid::radialExtension "double TruncatedSpheroid::radialExtension() const override
TruncatedSpheroid::radialExtension
Returns the (approximate in some cases) radial size of the particle of this form factor's shape. This is used for SSCA calculations 
";

%feature("docstring")  TruncatedSpheroid::formfactor_at_bottom "complex_t TruncatedSpheroid::formfactor_at_bottom(C3 q) const override
TruncatedSpheroid::formfactor_at_bottom";

%feature("docstring")  TruncatedSpheroid::validate "std::string TruncatedSpheroid::validate() const override
TruncatedSpheroid::validate";


// File: namespace_0d125.xml


// File: namespace_0d129.xml


// File: namespace_0d133.xml


// File: namespace_0d143.xml


// File: namespace_0d145.xml


// File: namespace_0d16.xml


// File: namespace_0d184.xml


// File: namespace_0d197.xml


// File: namespace_0d2.xml


// File: namespace_0d207.xml


// File: namespace_0d229.xml


// File: namespace_0d242.xml


// File: namespace_0d34.xml


// File: namespace_0d36.xml


// File: namespace_0d38.xml


// File: namespace_0d4.xml


// File: namespacebake.xml
%feature("docstring")  bake::CubicLattice "Lattice3D bake::CubicLattice(double a)
bake::CubicLattice
Returns a primitive cubic (cP) lattice with edge length a. 
";

%feature("docstring")  bake::FCCLattice "Lattice3D bake::FCCLattice(double a)
bake::FCCLattice
Returns a face-centered cubic (cF) lattice with edge length a. 
";

%feature("docstring")  bake::HexagonalLattice "Lattice3D bake::HexagonalLattice(double a, double c)
bake::HexagonalLattice
Returns a primitive hexagonal (hP) lattice with hexagonal edge a and height c. 
";

%feature("docstring")  bake::HCPLattice "Lattice3D bake::HCPLattice(double a, double c)
bake::HCPLattice
TODO: Clarify how this is meant: HCP is not a Bravais lattice. 
";

%feature("docstring")  bake::TetragonalLattice "Lattice3D bake::TetragonalLattice(double a, double c)
bake::TetragonalLattice
Returns a primitive tetragonal (tP) lattice with square base edge a and height c. 
";

%feature("docstring")  bake::BCTLattice "Lattice3D bake::BCTLattice(double a, double c)
bake::BCTLattice
Returns a body-centered cubic (cI) lattice with edge length a. TODO: Clarify meaning of c 
";


// File: namespaceExemplarySamples.xml
%feature("docstring")  ExemplarySamples::createBoxCompositionRotateX "MultiLayer * ExemplarySamples::createBoxCompositionRotateX()
ExemplarySamples::createBoxCompositionRotateX";

%feature("docstring")  ExemplarySamples::createBoxCompositionRotateY "MultiLayer * ExemplarySamples::createBoxCompositionRotateY()
ExemplarySamples::createBoxCompositionRotateY";

%feature("docstring")  ExemplarySamples::createBoxCompositionRotateZ "MultiLayer * ExemplarySamples::createBoxCompositionRotateZ()
ExemplarySamples::createBoxCompositionRotateZ";

%feature("docstring")  ExemplarySamples::createBoxCompositionRotateZandY "MultiLayer * ExemplarySamples::createBoxCompositionRotateZandY()
ExemplarySamples::createBoxCompositionRotateZandY";

%feature("docstring")  ExemplarySamples::createBoxStackComposition "MultiLayer * ExemplarySamples::createBoxStackComposition()
ExemplarySamples::createBoxStackComposition";

%feature("docstring")  ExemplarySamples::createBoxesSquareLattice2D "MultiLayer * ExemplarySamples::createBoxesSquareLattice2D()
ExemplarySamples::createBoxesSquareLattice2D";

%feature("docstring")  ExemplarySamples::createCoreShellParticle "MultiLayer * ExemplarySamples::createCoreShellParticle()
ExemplarySamples::createCoreShellParticle";

%feature("docstring")  ExemplarySamples::createCoreShellBoxRotateZandY "MultiLayer * ExemplarySamples::createCoreShellBoxRotateZandY()
ExemplarySamples::createCoreShellBoxRotateZandY";

%feature("docstring")  ExemplarySamples::createCustomMorphology "MultiLayer * ExemplarySamples::createCustomMorphology()
ExemplarySamples::createCustomMorphology";

%feature("docstring")  ExemplarySamples::createCylindersAndPrisms "MultiLayer * ExemplarySamples::createCylindersAndPrisms()
ExemplarySamples::createCylindersAndPrisms";

%feature("docstring")  ExemplarySamples::createCylindersInDWBA "MultiLayer * ExemplarySamples::createCylindersInDWBA()
ExemplarySamples::createCylindersInDWBA
Builds sample: cylinder form factor in DWBA (IsGISAXS example #3, part I). 
";

%feature("docstring")  ExemplarySamples::createCylindersInBA "MultiLayer * ExemplarySamples::createCylindersInBA(double height=5, double radius=5)
ExemplarySamples::createCylindersInBA
Builds sample: cylinder form factor in BA (IsGISAXS example #3, part II). 
";

%feature("docstring")  ExemplarySamples::createLargeCylindersInDWBA "MultiLayer * ExemplarySamples::createLargeCylindersInDWBA(double height=1000, double radius=500)
ExemplarySamples::createLargeCylindersInDWBA
Builds sample with large cylinders for MC integration tests. 
";

%feature("docstring")  ExemplarySamples::createFeNiBilayer "MultiLayer * ExemplarySamples::createFeNiBilayer()
ExemplarySamples::createFeNiBilayer";

%feature("docstring")  ExemplarySamples::createFeNiBilayerTanh "MultiLayer * ExemplarySamples::createFeNiBilayerTanh()
ExemplarySamples::createFeNiBilayerTanh";

%feature("docstring")  ExemplarySamples::createFeNiBilayerNC "MultiLayer * ExemplarySamples::createFeNiBilayerNC()
ExemplarySamples::createFeNiBilayerNC";

%feature("docstring")  ExemplarySamples::createFeNiBilayerSpinFlip "MultiLayer * ExemplarySamples::createFeNiBilayerSpinFlip()
ExemplarySamples::createFeNiBilayerSpinFlip";

%feature("docstring")  ExemplarySamples::createFeNiBilayerSpinFlipTanh "MultiLayer * ExemplarySamples::createFeNiBilayerSpinFlipTanh()
ExemplarySamples::createFeNiBilayerSpinFlipTanh";

%feature("docstring")  ExemplarySamples::createFeNiBilayerSpinFlipNC "MultiLayer * ExemplarySamples::createFeNiBilayerSpinFlipNC()
ExemplarySamples::createFeNiBilayerSpinFlipNC";

%feature("docstring")  ExemplarySamples::createHomogeneousMultilayer "MultiLayer * ExemplarySamples::createHomogeneousMultilayer()
ExemplarySamples::createHomogeneousMultilayer";

%feature("docstring")  ExemplarySamples::createLattice1D "MultiLayer * ExemplarySamples::createLattice1D()
ExemplarySamples::createLattice1D";

%feature("docstring")  ExemplarySamples::createLayersWithAbsorptionWithFF "MultiLayer * ExemplarySamples::createLayersWithAbsorptionWithFF(const IFormFactor *)
ExemplarySamples::createLayersWithAbsorptionWithFF";

%feature("docstring")  ExemplarySamples::createLayersWithAbsorptionBySLD "MultiLayer * ExemplarySamples::createLayersWithAbsorptionBySLD()
ExemplarySamples::createLayersWithAbsorptionBySLD";

%feature("docstring")  ExemplarySamples::createMagneticSubstrateZeroField "MultiLayer * ExemplarySamples::createMagneticSubstrateZeroField()
ExemplarySamples::createMagneticSubstrateZeroField";

%feature("docstring")  ExemplarySamples::createSimpleMagneticLayer "MultiLayer * ExemplarySamples::createSimpleMagneticLayer()
ExemplarySamples::createSimpleMagneticLayer";

%feature("docstring")  ExemplarySamples::createMagneticLayer "MultiLayer * ExemplarySamples::createMagneticLayer()
ExemplarySamples::createMagneticLayer";

%feature("docstring")  ExemplarySamples::createSimpleMagneticRotationWithRoughness "MultiLayer * ExemplarySamples::createSimpleMagneticRotationWithRoughness(const std::string &roughnessKey)
ExemplarySamples::createSimpleMagneticRotationWithRoughness";

%feature("docstring")  ExemplarySamples::createMagneticRotation "MultiLayer * ExemplarySamples::createMagneticRotation()
ExemplarySamples::createMagneticRotation";

%feature("docstring")  ExemplarySamples::createMagneticParticleZeroField "MultiLayer * ExemplarySamples::createMagneticParticleZeroField()
ExemplarySamples::createMagneticParticleZeroField";

%feature("docstring")  ExemplarySamples::createMagneticCylinders "MultiLayer * ExemplarySamples::createMagneticCylinders()
ExemplarySamples::createMagneticCylinders";

%feature("docstring")  ExemplarySamples::createMagneticSpheres "MultiLayer * ExemplarySamples::createMagneticSpheres()
ExemplarySamples::createMagneticSpheres";

%feature("docstring")  ExemplarySamples::createMesoCrystal "MultiLayer * ExemplarySamples::createMesoCrystal()
ExemplarySamples::createMesoCrystal";

%feature("docstring")  ExemplarySamples::createMultiLayerWithNCRoughness "MultiLayer * ExemplarySamples::createMultiLayerWithNCRoughness()
ExemplarySamples::createMultiLayerWithNCRoughness";

%feature("docstring")  ExemplarySamples::createMultiLayerWithRoughness "MultiLayer * ExemplarySamples::createMultiLayerWithRoughness()
ExemplarySamples::createMultiLayerWithRoughness";

%feature("docstring")  ExemplarySamples::createMultipleLayout "MultiLayer * ExemplarySamples::createMultipleLayout()
ExemplarySamples::createMultipleLayout";

%feature("docstring")  ExemplarySamples::createRadialParaCrystal "MultiLayer * ExemplarySamples::createRadialParaCrystal()
ExemplarySamples::createRadialParaCrystal";

%feature("docstring")  ExemplarySamples::createBasic2DParaCrystalWithFTDis "MultiLayer * ExemplarySamples::createBasic2DParaCrystalWithFTDis(const IProfile2D *pdf2)
ExemplarySamples::createBasic2DParaCrystalWithFTDis";

%feature("docstring")  ExemplarySamples::createHexParaCrystal "MultiLayer * ExemplarySamples::createHexParaCrystal()
ExemplarySamples::createHexParaCrystal";

%feature("docstring")  ExemplarySamples::createRectParaCrystal "MultiLayer * ExemplarySamples::createRectParaCrystal()
ExemplarySamples::createRectParaCrystal";

%feature("docstring")  ExemplarySamples::createParticleComposition "MultiLayer * ExemplarySamples::createParticleComposition()
ExemplarySamples::createParticleComposition";

%feature("docstring")  ExemplarySamples::createCylindersWithSizeDistribution "MultiLayer * ExemplarySamples::createCylindersWithSizeDistribution()
ExemplarySamples::createCylindersWithSizeDistribution";

%feature("docstring")  ExemplarySamples::createTwoTypesCylindersDistribution "MultiLayer * ExemplarySamples::createTwoTypesCylindersDistribution()
ExemplarySamples::createTwoTypesCylindersDistribution";

%feature("docstring")  ExemplarySamples::createRotatedPyramidsDistribution "MultiLayer * ExemplarySamples::createRotatedPyramidsDistribution()
ExemplarySamples::createRotatedPyramidsDistribution";

%feature("docstring")  ExemplarySamples::createSpheresWithLimitsDistribution "MultiLayer * ExemplarySamples::createSpheresWithLimitsDistribution()
ExemplarySamples::createSpheresWithLimitsDistribution";

%feature("docstring")  ExemplarySamples::createConesWithLimitsDistribution "MultiLayer * ExemplarySamples::createConesWithLimitsDistribution()
ExemplarySamples::createConesWithLimitsDistribution";

%feature("docstring")  ExemplarySamples::createLinkedBoxDistribution "MultiLayer * ExemplarySamples::createLinkedBoxDistribution()
ExemplarySamples::createLinkedBoxDistribution";

%feature("docstring")  ExemplarySamples::createParticleInVacuumWithFF "MultiLayer * ExemplarySamples::createParticleInVacuumWithFF(const IFormFactor *)
ExemplarySamples::createParticleInVacuumWithFF";

%feature("docstring")  ExemplarySamples::createHardDisk "MultiLayer * ExemplarySamples::createHardDisk()
ExemplarySamples::createHardDisk";

%feature("docstring")  ExemplarySamples::createPlainMultiLayerBySLD "MultiLayer * ExemplarySamples::createPlainMultiLayerBySLD(int n_layers=10, double thick_ti=3.0)
ExemplarySamples::createPlainMultiLayerBySLD";

%feature("docstring")  ExemplarySamples::createResonator "MultiLayer * ExemplarySamples::createResonator(double ti_thickness=13.0)
ExemplarySamples::createResonator";

%feature("docstring")  ExemplarySamples::createCosineRipple "MultiLayer * ExemplarySamples::createCosineRipple()
ExemplarySamples::createCosineRipple";

%feature("docstring")  ExemplarySamples::createTriangularRipple "MultiLayer * ExemplarySamples::createTriangularRipple(double d=0)
ExemplarySamples::createTriangularRipple";

%feature("docstring")  ExemplarySamples::createAsymRipple "MultiLayer * ExemplarySamples::createAsymRipple()
ExemplarySamples::createAsymRipple";

%feature("docstring")  ExemplarySamples::createRotatedPyramids "MultiLayer * ExemplarySamples::createRotatedPyramids()
ExemplarySamples::createRotatedPyramids";

%feature("docstring")  ExemplarySamples::createSizeDistributionDAModel "MultiLayer * ExemplarySamples::createSizeDistributionDAModel()
ExemplarySamples::createSizeDistributionDAModel";

%feature("docstring")  ExemplarySamples::createSizeDistributionLMAModel "MultiLayer * ExemplarySamples::createSizeDistributionLMAModel()
ExemplarySamples::createSizeDistributionLMAModel";

%feature("docstring")  ExemplarySamples::createSizeDistributionSSCAModel "MultiLayer * ExemplarySamples::createSizeDistributionSSCAModel()
ExemplarySamples::createSizeDistributionSSCAModel";

%feature("docstring")  ExemplarySamples::createCylindersInSSCA "MultiLayer * ExemplarySamples::createCylindersInSSCA()
ExemplarySamples::createCylindersInSSCA";

%feature("docstring")  ExemplarySamples::createSlicedComposition "MultiLayer * ExemplarySamples::createSlicedComposition()
ExemplarySamples::createSlicedComposition";

%feature("docstring")  ExemplarySamples::createSlicedCylinders "MultiLayer * ExemplarySamples::createSlicedCylinders()
ExemplarySamples::createSlicedCylinders";

%feature("docstring")  ExemplarySamples::createSLDSlicedCylinders "MultiLayer * ExemplarySamples::createSLDSlicedCylinders()
ExemplarySamples::createSLDSlicedCylinders";

%feature("docstring")  ExemplarySamples::createAveragedSlicedCylinders "MultiLayer * ExemplarySamples::createAveragedSlicedCylinders()
ExemplarySamples::createAveragedSlicedCylinders";

%feature("docstring")  ExemplarySamples::createThickAbsorptiveSample "MultiLayer * ExemplarySamples::createThickAbsorptiveSample()
ExemplarySamples::createThickAbsorptiveSample";

%feature("docstring")  ExemplarySamples::createTransformBox "MultiLayer * ExemplarySamples::createTransformBox()
ExemplarySamples::createTransformBox";

%feature("docstring")  ExemplarySamples::createBasic2DLattice "MultiLayer * ExemplarySamples::createBasic2DLattice()
ExemplarySamples::createBasic2DLattice";

%feature("docstring")  ExemplarySamples::createSquareLattice2D "MultiLayer * ExemplarySamples::createSquareLattice2D()
ExemplarySamples::createSquareLattice2D";

%feature("docstring")  ExemplarySamples::createCenteredSquareLattice2D "MultiLayer * ExemplarySamples::createCenteredSquareLattice2D()
ExemplarySamples::createCenteredSquareLattice2D";

%feature("docstring")  ExemplarySamples::createRotatedSquareLattice2D "MultiLayer * ExemplarySamples::createRotatedSquareLattice2D()
ExemplarySamples::createRotatedSquareLattice2D";

%feature("docstring")  ExemplarySamples::createFiniteSquareLattice2D "MultiLayer * ExemplarySamples::createFiniteSquareLattice2D()
ExemplarySamples::createFiniteSquareLattice2D";

%feature("docstring")  ExemplarySamples::createSuperLattice "MultiLayer * ExemplarySamples::createSuperLattice()
ExemplarySamples::createSuperLattice";


// File: namespaceff.xml


// File: namespaceMaterialUtils.xml
%feature("docstring")  MaterialUtils::ScalarReducedPotential "complex_t MaterialUtils::ScalarReducedPotential(complex_t n, R3 k, double n_ref)
MaterialUtils::ScalarReducedPotential
Function for calculating the reduced potential, used for obtaining the Fresnel coefficients (non-polarized material case) 
";

%feature("docstring")  MaterialUtils::PolarizedReducedPotential "SpinMatrix MaterialUtils::PolarizedReducedPotential(complex_t n, R3 b_field, R3 k, double n_ref)
MaterialUtils::PolarizedReducedPotential
Function for calculating the reduced potential, used for obtaining the Fresnel coefficients (polarized material case) 
";

%feature("docstring")  MaterialUtils::MagnetizationCorrection "SpinMatrix MaterialUtils::MagnetizationCorrection(complex_t unit_factor, double magnetic_factor, Vec3< T > polarization)
MaterialUtils::MagnetizationCorrection";

%feature("docstring")  MaterialUtils::checkMaterialTypes "MATERIAL_TYPES MaterialUtils::checkMaterialTypes(const std::vector< const Material * > &materials)
MaterialUtils::checkMaterialTypes
Checks if all non-default materials in  materials are of the same type and returns this type. If several types of materials are involved, InvalidMaterialType identifier is returned. 
";


// File: namespacePolyhedralUtil.xml
%feature("docstring")  PolyhedralUtil::BottomZ "double PolyhedralUtil::BottomZ(const std::vector< R3 > &vertices, const IRotation *rotation)
PolyhedralUtil::BottomZ
Calculates the z-coordinate of the lowest vertex after rotation. 
";

%feature("docstring")  PolyhedralUtil::TopZ "double PolyhedralUtil::TopZ(const std::vector< R3 > &vertices, const IRotation *rotation)
PolyhedralUtil::TopZ
Calculates the z-coordinate of the highest vertex after rotation. 
";


// File: namespacePy.xml


// File: namespacePy_1_1Import.xml
%feature("docstring")  Py::Import::createFromPython "std::unique_ptr< MultiLayer > Py::Import::createFromPython(const std::string &script, const std::string &functionName, const std::string &path=\"\")
Py::Import::createFromPython
Creates a multi layer by running python code in embedded interpreter.

Parameters:
-----------

script: 
Python script

functionName: 
A function name in this script which produces a  MultiLayer

path: 
A path to import BornAgain library. If empty, relies on PYTHONPATH 
";

%feature("docstring")  Py::Import::listOfFunctions "std::vector< std::string > Py::Import::listOfFunctions(const std::string &script, const std::string &path=\"\")
Py::Import::listOfFunctions
Returns list of functions defined in the script.

Parameters:
-----------

script: 
Python script

path: 
A path to import BornAgain library. If empty, relies on PYTHONPATH 
";


// File: namespacerefMat.xml


// File: namespaceripples.xml
%feature("docstring")  ripples::factor_x_box "complex_t ripples::factor_x_box(complex_t q, double l)
ripples::factor_x_box";

%feature("docstring")  ripples::factor_x_Gauss "complex_t ripples::factor_x_Gauss(complex_t q, double l)
ripples::factor_x_Gauss";

%feature("docstring")  ripples::factor_x_Lorentz "complex_t ripples::factor_x_Lorentz(complex_t q, double l)
ripples::factor_x_Lorentz";

%feature("docstring")  ripples::profile_yz_bar "complex_t ripples::profile_yz_bar(complex_t qy, complex_t qz, double width, double height)
ripples::profile_yz_bar
Complex form factor of rectangular ripple (bar). 
";

%feature("docstring")  ripples::profile_yz_cosine "complex_t ripples::profile_yz_cosine(complex_t qy, complex_t qz, double width, double height)
ripples::profile_yz_cosine
Complex form factor of cosine ripple. 
";

%feature("docstring")  ripples::profile_yz_triangular "complex_t ripples::profile_yz_triangular(complex_t qy, complex_t qz, double width, double height, double asymmetry)
ripples::profile_yz_triangular
Complex form factor of triangular ripple. 
";


// File: namespaceSampleUtils.xml


// File: namespaceSampleUtils_1_1Multilayer.xml
%feature("docstring")  SampleUtils::Multilayer::LayerTopRoughness "const LayerRoughness * SampleUtils::Multilayer::LayerTopRoughness(const MultiLayer &sample, size_t i)
SampleUtils::Multilayer::LayerTopRoughness
Returns top roughness of layer. 
";

%feature("docstring")  SampleUtils::Multilayer::IndexOfLayer "size_t SampleUtils::Multilayer::IndexOfLayer(const MultiLayer &sample, const Layer *p_layer)
SampleUtils::Multilayer::IndexOfLayer
Returns the index of the given layer. 
";

%feature("docstring")  SampleUtils::Multilayer::hasRoughness "bool SampleUtils::Multilayer::hasRoughness(const MultiLayer &sample)
SampleUtils::Multilayer::hasRoughness";


// File: namespaceSampleUtils_1_1someff.xml
%feature("docstring")  SampleUtils::someff::ffSphere "complex_t SampleUtils::someff::ffSphere(C3 q, double R)
SampleUtils::someff::ffSphere
Returns the form factor of a sphere of radius R.

Used by the hard sphere and by several soft sphere classes. 
";


// File: namespacestd.xml


// File: IInterference_8cpp.xml


// File: IInterference_8h.xml


// File: Interference1DLattice_8cpp.xml


// File: Interference1DLattice_8h.xml


// File: Interference2DLattice_8cpp.xml


// File: Interference2DLattice_8h.xml


// File: Interference2DParaCrystal_8cpp.xml


// File: Interference2DParaCrystal_8h.xml


// File: Interference2DSuperLattice_8cpp.xml


// File: Interference2DSuperLattice_8h.xml


// File: Interference3DLattice_8cpp.xml


// File: Interference3DLattice_8h.xml


// File: InterferenceFinite2DLattice_8cpp.xml


// File: InterferenceFinite2DLattice_8h.xml


// File: InterferenceFinite3DLattice_8cpp.xml


// File: InterferenceFinite3DLattice_8h.xml


// File: InterferenceHardDisk_8cpp.xml


// File: InterferenceHardDisk_8h.xml


// File: InterferenceNone_8cpp.xml


// File: InterferenceNone_8h.xml


// File: InterferenceRadialParaCrystal_8cpp.xml


// File: InterferenceRadialParaCrystal_8h.xml


// File: Interferences_8h.xml


// File: InterferenceTwin_8cpp.xml


// File: InterferenceTwin_8h.xml


// File: ParticleLayout_8cpp.xml


// File: ParticleLayout_8h.xml


// File: FormFactorComponents_8cpp.xml


// File: FormFactorComponents_8h.xml


// File: IRegistry_8h.xml


// File: Profile2DComponents_8cpp.xml


// File: Profile2DComponents_8h.xml


// File: IDistribution1DSampler_8cpp.xml


// File: IDistribution1DSampler_8h.xml


// File: IDistribution2DSampler_8cpp.xml


// File: IDistribution2DSampler_8h.xml


// File: IPeakShape_8cpp.xml


// File: IPeakShape_8h.xml


// File: Profiles1D_8cpp.xml


// File: Profiles1D_8h.xml


// File: Profiles2D_8cpp.xml


// File: Profiles2D_8h.xml


// File: Bar_8cpp.xml


// File: Bar_8h.xml


// File: Bipyramid4_8cpp.xml


// File: Bipyramid4_8h.xml


// File: Box_8cpp.xml


// File: Box_8h.xml


// File: CantellatedCube_8cpp.xml


// File: CantellatedCube_8h.xml


// File: Cone_8cpp.xml


// File: Cone_8h.xml


// File: CosineRipple_8cpp.xml


// File: CosineRipple_8h.xml


// File: Cylinder_8cpp.xml


// File: Cylinder_8h.xml


// File: Dodecahedron_8cpp.xml


// File: Dodecahedron_8h.xml


// File: EllipsoidalCylinder_8cpp.xml


// File: EllipsoidalCylinder_8h.xml


// File: HardParticles_8h.xml


// File: HemiEllipsoid_8cpp.xml


// File: HemiEllipsoid_8h.xml


// File: HollowSphere_8cpp.xml


// File: HollowSphere_8h.xml


// File: HorizontalCylinder_8cpp.xml


// File: HorizontalCylinder_8h.xml


// File: Icosahedron_8cpp.xml


// File: Icosahedron_8h.xml


// File: IFormFactorPolyhedron_8cpp.xml


// File: IFormFactorPolyhedron_8h.xml


// File: IFormFactorPrism_8cpp.xml


// File: IFormFactorPrism_8h.xml


// File: IProfileRipple_8cpp.xml


// File: IProfileRipple_8h.xml


// File: LongBoxGauss_8cpp.xml


// File: LongBoxGauss_8h.xml


// File: LongBoxLorentz_8cpp.xml


// File: LongBoxLorentz_8h.xml


// File: PlatonicOctahedron_8cpp.xml


// File: PlatonicOctahedron_8h.xml


// File: PlatonicTetrahedron_8cpp.xml


// File: PlatonicTetrahedron_8h.xml


// File: Prism3_8cpp.xml


// File: Prism3_8h.xml


// File: Prism6_8cpp.xml


// File: Prism6_8h.xml


// File: Pyramid2_8cpp.xml


// File: Pyramid2_8h.xml


// File: Pyramid3_8cpp.xml


// File: Pyramid3_8h.xml


// File: Pyramid4_8cpp.xml


// File: Pyramid4_8h.xml


// File: Pyramid6_8cpp.xml


// File: Pyramid6_8h.xml


// File: Ripples_8cpp.xml


// File: Ripples_8h.xml


// File: SawtoothRipple_8cpp.xml


// File: SawtoothRipple_8h.xml


// File: Sphere_8cpp.xml


// File: Sphere_8h.xml


// File: Spheroid_8cpp.xml


// File: Spheroid_8h.xml


// File: TruncatedCube_8cpp.xml


// File: TruncatedCube_8h.xml


// File: TruncatedSphere_8cpp.xml


// File: TruncatedSphere_8h.xml


// File: TruncatedSpheroid_8cpp.xml


// File: TruncatedSpheroid_8h.xml


// File: LayerInterface_8cpp.xml


// File: LayerInterface_8h.xml


// File: LayerRoughness_8cpp.xml


// File: LayerRoughness_8h.xml


// File: BakeLattice_8cpp.xml


// File: BakeLattice_8h.xml


// File: ISelectionRule_8cpp.xml


// File: ISelectionRule_8h.xml


// File: Lattice2D_8cpp.xml


// File: Lattice2D_8h.xml


// File: Lattice3D_8cpp.xml


// File: Lattice3D_8h.xml


// File: SomeFormFactors_8cpp.xml


// File: SomeFormFactors_8h.xml


// File: Admixtures_8h.xml


// File: BaseMaterialImpl_8h.xml


// File: MagneticMaterialImpl_8cpp.xml


// File: MagneticMaterialImpl_8h.xml


// File: Material_8cpp.xml


// File: Material_8h.xml


// File: MaterialBySLDImpl_8cpp.xml


// File: MaterialBySLDImpl_8h.xml


// File: MaterialFactoryFuncs_8cpp.xml
%feature("docstring")  RefractiveMaterial "Material RefractiveMaterial(const std::string &name, complex_t refractive_index, R3 magnetization)

Constructs a material with  name,  refractive_index and  magnetization (in A/m). Alternatively,  $\\\\delta$ and  $\\\\beta$ for refractive index  $n = 1 - \\\\delta + i \\\\beta$ can be passed directly. With no parameters given, constructs default (vacuum) material with  $n = 1$ and zero magnetization. 
";

%feature("docstring")  RefractiveMaterial "Material RefractiveMaterial(const std::string &name, double delta, double beta, R3 magnetization)
";

%feature("docstring")  Vacuum "Material Vacuum()
";

%feature("docstring")  MaterialBySLD "Material MaterialBySLD()
";

%feature("docstring")  MaterialBySLD "Material MaterialBySLD(const std::string &name, double sld_real, double sld_imag, R3 magnetization)

Constructs a wavelength-independent material with a given complex-valued scattering length density (SLD). SLD values for a wide variety of materials can be found on https://sld-calculator.appspot.com/ and https://www.ncnr.nist.gov/resources/activation/ By convention, SLD imaginary part is treated as negative by default, which corresponds to attenuation of the signal. With no parameters given, MaterialBySLD constructs default (vacuum) material with zero sld and zero magnetization.

Parameters:
-----------

name: 
material name

sld_real: 
real part of the scattering length density, inverse square angstroms

sld_imag: 
imaginary part of the scattering length density, inverse square angstroms

magnetization: 
magnetization (in A/m) 
";


// File: MaterialFactoryFuncs_8h.xml
%feature("docstring")  Vacuum "Material Vacuum()
";

%feature("docstring")  RefractiveMaterial "Material RefractiveMaterial(const std::string &name, double delta, double beta, R3 magnetization={})
";

%feature("docstring")  RefractiveMaterial "Material RefractiveMaterial(const std::string &name, complex_t refractive_index, R3 magnetization={})

Constructs a material with  name,  refractive_index and  magnetization (in A/m). Alternatively,  $\\\\delta$ and  $\\\\beta$ for refractive index  $n = 1 - \\\\delta + i \\\\beta$ can be passed directly. With no parameters given, constructs default (vacuum) material with  $n = 1$ and zero magnetization. 
";

%feature("docstring")  MaterialBySLD "Material MaterialBySLD()
";

%feature("docstring")  MaterialBySLD "Material MaterialBySLD(const std::string &name, double sld_real, double sld_imag, R3 magnetization={})

Constructs a wavelength-independent material with a given complex-valued scattering length density (SLD). SLD values for a wide variety of materials can be found on https://sld-calculator.appspot.com/ and https://www.ncnr.nist.gov/resources/activation/ By convention, SLD imaginary part is treated as negative by default, which corresponds to attenuation of the signal. With no parameters given, MaterialBySLD constructs default (vacuum) material with zero sld and zero magnetization.

Parameters:
-----------

name: 
material name

sld_real: 
real part of the scattering length density, inverse square angstroms

sld_imag: 
imaginary part of the scattering length density, inverse square angstroms

magnetization: 
magnetization (in A/m) 
";


// File: MaterialUtils_8cpp.xml


// File: MaterialUtils_8h.xml


// File: RefractiveMaterialImpl_8cpp.xml


// File: RefractiveMaterialImpl_8h.xml


// File: Layer_8cpp.xml


// File: Layer_8h.xml


// File: MultiLayer_8cpp.xml


// File: MultiLayer_8h.xml


// File: MultilayerUtils_8cpp.xml


// File: MultilayerUtils_8h.xml


// File: PyImport_8cpp.xml


// File: PyImport_8h.xml


// File: RoughnessModels_8cpp.xml


// File: RoughnessModels_8h.xml


// File: Crystal_8cpp.xml


// File: Crystal_8h.xml


// File: IFormFactor_8cpp.xml


// File: IFormFactor_8h.xml


// File: IParticle_8cpp.xml


// File: IParticle_8h.xml


// File: MesoCrystal_8cpp.xml


// File: MesoCrystal_8h.xml


// File: Particle_8cpp.xml


// File: Particle_8h.xml


// File: ParticleComposition_8cpp.xml


// File: ParticleComposition_8h.xml


// File: ParticleCoreShell_8cpp.xml


// File: ParticleCoreShell_8h.xml


// File: PolyhedralUtil_8cpp.xml


// File: PolyhedralUtil_8h.xml


// File: ISampleNode_8cpp.xml


// File: ISampleNode_8h.xml


// File: Rotations_8cpp.xml
%feature("docstring")  createProduct "IRotation * createProduct(const IRotation &left, const IRotation &right)

Returns concatenated rotation (first right, then left). 
";


// File: Rotations_8h.xml
%feature("docstring")  createProduct "IRotation * createProduct(const IRotation &left, const IRotation &right)

Returns concatenated rotation (first right, then left). 
";


// File: BoxNet_8cpp.xml


// File: BoxNet_8h.xml


// File: DoubleEllipse_8cpp.xml


// File: DoubleEllipse_8h.xml


// File: IShape3D_8cpp.xml
%feature("docstring")  RectangleVertices "std::vector< R3 > RectangleVertices(double length, double width, double z)

Helper functions to construct lists of vertices

Generate vertices of centered rectangle at height z 
";

%feature("docstring")  EllipseVerticesZ "std::vector< R3 > EllipseVerticesZ(double r_x, double r_y, double z)

Generate vertices of centered horizontal ellipse with given semi-axes at height z. 
";

%feature("docstring")  EllipseVerticesXtrunc "std::vector< R3 > EllipseVerticesXtrunc(double x, double r_y, double r_z, double z_b, double z_t)

Generate vertices of centered vertical ellipse with given semi-axes at position x and truncation heights z_b (bottom) and z_t (top) 
";


// File: IShape3D_8h.xml
%feature("docstring")  RectangleVertices "std::vector< R3 > RectangleVertices(double length, double width, double z)

Helper functions to construct lists of vertices

Generate vertices of centered rectangle at height z 
";

%feature("docstring")  EllipseVerticesZ "std::vector< R3 > EllipseVerticesZ(double r_x, double r_y, double z)

Generate vertices of centered horizontal ellipse with given semi-axes at height z. 
";

%feature("docstring")  EllipseVerticesXtrunc "std::vector< R3 > EllipseVerticesXtrunc(double x, double r_y, double r_z, double z_b, double z_t)

Generate vertices of centered vertical ellipse with given semi-axes at position x and truncation heights z_b (bottom) and z_t (top) 
";


// File: RippleCosineNet_8cpp.xml


// File: RippleCosineNet_8h.xml


// File: RippleSawtoothNet_8cpp.xml


// File: RippleSawtoothNet_8h.xml


// File: TruncatedEllipsoidNet_8cpp.xml


// File: TruncatedEllipsoidNet_8h.xml


// File: FuzzySphere_8cpp.xml


// File: FuzzySphere_8h.xml


// File: Gauss_8cpp.xml


// File: Gauss_8h.xml


// File: SoftParticles_8h.xml


// File: BoxCompositionBuilder_8cpp.xml


// File: BoxCompositionBuilder_8h.xml


// File: BoxesSquareLatticeBuilder_8cpp.xml


// File: BoxesSquareLatticeBuilder_8h.xml


// File: CoreShellParticleBuilder_8cpp.xml


// File: CoreShellParticleBuilder_8h.xml


// File: CustomMorphologyBuilder_8cpp.xml


// File: CustomMorphologyBuilder_8h.xml


// File: CylindersAndPrismsBuilder_8cpp.xml


// File: CylindersAndPrismsBuilder_8h.xml


// File: CylindersBuilder_8cpp.xml


// File: CylindersBuilder_8h.xml


// File: ExemplarySamples_8h.xml


// File: FeNiBilayerBuilder_8cpp.xml


// File: FeNiBilayerBuilder_8h.xml


// File: HomogeneousMultilayerBuilder_8cpp.xml


// File: HomogeneousMultilayerBuilder_8h.xml


// File: LatticeBuilder_8cpp.xml


// File: LatticeBuilder_8h.xml


// File: LayersWithAbsorptionBuilder_8cpp.xml


// File: LayersWithAbsorptionBuilder_8h.xml


// File: LayersWithAbsorptionBySLDBuilder_8cpp.xml
%feature("docstring")  middle_layer_thickness "const double middle_layer_thickness(60.0)
";


// File: LayersWithAbsorptionBySLDBuilder_8h.xml


// File: MagneticLayersBuilder_8cpp.xml


// File: MagneticLayersBuilder_8h.xml


// File: MagneticParticlesBuilder_8cpp.xml


// File: MagneticParticlesBuilder_8h.xml


// File: MesoCrystalBuilder_8cpp.xml


// File: MesoCrystalBuilder_8h.xml


// File: MultiLayerWithNCRoughnessBuilder_8cpp.xml


// File: MultiLayerWithNCRoughnessBuilder_8h.xml


// File: MultiLayerWithRoughnessBuilder_8cpp.xml


// File: MultiLayerWithRoughnessBuilder_8h.xml


// File: MultipleLayoutBuilder_8cpp.xml


// File: MultipleLayoutBuilder_8h.xml


// File: ParaCrystalBuilder_8cpp.xml


// File: ParaCrystalBuilder_8h.xml


// File: ParticleCompositionBuilder_8cpp.xml


// File: ParticleCompositionBuilder_8h.xml


// File: ParticleDistributionsBuilder_8cpp.xml


// File: ParticleDistributionsBuilder_8h.xml


// File: ParticleInVacuumBuilder_8cpp.xml


// File: ParticleInVacuumBuilder_8h.xml


// File: PercusYevickBuilder_8cpp.xml


// File: PercusYevickBuilder_8h.xml


// File: PlainMultiLayerBySLDBuilder_8cpp.xml


// File: PlainMultiLayerBySLDBuilder_8h.xml


// File: ReferenceMaterials_8h.xml


// File: ResonatorBuilder_8cpp.xml


// File: ResonatorBuilder_8h.xml


// File: RipplesBuilder_8cpp.xml


// File: RipplesBuilder_8h.xml


// File: RotatedPyramidsBuilder_8cpp.xml


// File: RotatedPyramidsBuilder_8h.xml


// File: SizeDistributionModelsBuilder_8cpp.xml


// File: SizeDistributionModelsBuilder_8h.xml


// File: SlicedCompositionBuilder_8cpp.xml


// File: SlicedCompositionBuilder_8h.xml


// File: SlicedCylindersBuilder_8cpp.xml


// File: SlicedCylindersBuilder_8h.xml


// File: ThickAbsorptiveSampleBuilder_8cpp.xml


// File: ThickAbsorptiveSampleBuilder_8h.xml


// File: TransformationsBuilder_8cpp.xml


// File: TransformationsBuilder_8h.xml


// File: TwoDimLatticeBuilder_8cpp.xml


// File: TwoDimLatticeBuilder_8h.xml


// File: dir_220e7f16e10b4e45e27e10ed0346ff0c.xml


// File: dir_53ad17160220d2858133377088cf64b3.xml


// File: dir_7b210e8d28f50f0c519681ee1b473363.xml


// File: dir_844f24c588eea1b259def164cc466f1a.xml


// File: dir_ff19b2623e8f6ab46659baac68a70953.xml


// File: dir_da063889c15f3636a66540651967c41d.xml


// File: dir_ed097210e0926370940660d36aeab42a.xml


// File: dir_fba8602a8c23825d875c7205aab8e979.xml


// File: dir_9b633c8be420b8d6b83f5ed5376ef19b.xml


// File: dir_61bfb933e72dfe3586b97d80db501038.xml


// File: dir_8f7f72226bf217e57890a767dfa82dfa.xml


// File: dir_c4bcd3a441ff6332187b5528d22c5933.xml


// File: dir_7002b98d93049c66d9f454102abc535d.xml


// File: dir_ccd033f493018670b3204f8d6a838d21.xml


// File: dir_d9d42b37b662547974602e66402128ce.xml

